#include <stdio.h>
#include <dos.h>
#include <dir.h>

#define ESC  27


extern int errno;


main (narg, varg)
int narg;
char *varg [];
{
    char car;
    unsigned char vcar, base, i, j, disque;
    unsigned lsect;
    unsigned char buffer [32][16];
    int place [4];


    /* selection du disque a lire */
    if (narg > 1)
        disque = (*varg [1] | ' ') - 'a';
    else
        disque = getdisk ();

    /* initialisation */
    lsect = 0;

    /* boucle de lecture et d'affichage */
    do
    {
        printf ("Numro de secteur ?   ESC pour sortir : ");

        car = getch ();

        if (car == '&')
        {
            putchar (car);
            base = 16;
            car = getch ();
        }
        else
            base = 10;

        if (car == '\r')
            lsect ++;
        else
        {
            lsect = 0;

            while (car != '\r' && car != ESC)
            {
                putchar (car);

                vcar = car & 0x0f;

                if (car > '9')
                    vcar = vcar + 9;

                lsect = (lsect * base) + vcar;

                car = getch ();
            }
        }

        putchar ('\n');

        if (car == ESC)
            exit ();

        if (absread (disque, 1, lsect, buffer) == 0)
        {
            printf ("\nSecteur : %5u, &%04X\n", lsect, lsect);
            puts ("     ---------------------------------------------------");
            puts ("     |  0  1  2  3  4  5  6  7  8  9  A  B  C  D  E  F |");
            puts ("--------------------------------------------------------");

            for (i = 0; i < 32; i++)
            {
                printf ("| %2X |", i);

                for (j = 0; j < 16; j++)
                {
                    vcar = buffer [i][j];

                    if (vcar < 16)
                        printf (" 0%X", vcar);
                    else
                        printf (" %X", vcar);
                }

                printf (" |   ");

                for (j = 0; j < 16; j++)
                {
                    vcar = buffer [i][j];

                    if (vcar > 0x1b)
                        putchar (vcar);
                    else
                        putchar ('.');
                }

                if (i == 15)
                    getch ();

                putchar ('\n');
            }

            puts ("--------------------------------------------------------");
        }
        else
        {
            errno = errno >> 8;

            if (errno & 1)
                puts ("Instruction incorrecte");

            if (errno & 2)
            {
                printf ("Adresse incorrecte ");

                getdfree (disque + 1, (struct dfree *) place);

                if (place [3] == -1)
                    puts ("(disque inexistant)");
                else
                    puts ("(disque incompatible avec la commande absread)");
            }

            if (errno & 4)
                puts ("Secteur non trouv");

            if (errno & 8)
                puts ("Erreur DMA");

            if (errno & 0x10)
                puts ("Erreur CRC  (secteur dfectueux)");

            if (errno & 0x20)
                puts ("Erreur controleur disque");

            if (errno & 0x40)
                puts ("Recherche infructueuse");

            if (errno & 0x80)
                puts ("Le disque ne rpond pas");

            /* Certaines erreurs sont fatales */
            if (errno & 0x82)
                exit ();
        }
    }
    while (1);
}