/* taille et nombre max des buffers utiliss */
#define szbuffer     5000
#define nbmaxbuf      120

/* mmoire minimum pour travailler */
#define minmemolibre  600

/* sauvegardes pour la fonction undo */
static intxx numligref;           /* numro de ligne */
static char  undo_ok;             /* valeur -1, 0 ou 1 */

/* adresses des buffers allous */
static octet *adrbuf [nbmaxbuf];
static octet nbtotbuf;

/* liste des buffers utiliss */
static octet *listebuf, *listebuf2;

/* buffers courants et positionnement */
static octet *bufcour, *bufcour2;
static octet numbufcour, numbufcour2;
static int16 posbufcour, posbufcour2;

/* emplacement fin du fichier */
static octet numderbuf, numderbuf2;
static int16 szderbuf,  szderbuf2;

/* sauvegarde position dans les buffers */
static octet savenumbuf, savenumbuf2, numbufref;
static int16 saveposbuf, saveposbuf2, posbufref;



#define carcourant()         bufcour [posbufcour]
#define debfichier()         (numbufcour == 0 && posbufcour == 0)
#define finfichier()         (numbufcour == numderbuf && posbufcour >= szderbuf)

#define carcourant2()        bufcour2 [posbufcour2]
#define debfich2()           (numbufcour2 == 0 && posbufcour2 == 0)
#define dercar2()            bufcour2 [szderbuf2]
#define majbuf2(c)           bufcour2 [szderbuf2 - 1] = c

cremem ()
{
    listebuf  = malloc (nbmaxbuf);
    listebuf2 = malloc (nbmaxbuf);

    nbtotbuf = 0;

    unpackmem ();
}




unpackmem ()
{
    while (coreleft () > szbuffer + minmemolibre)
        adrbuf [nbtotbuf++] = malloc (szbuffer);

    adrbuf [nbtotbuf] = 0;
}




packmem ()
{
    octet occupation [nbmaxbuf];
    octet numbuf1, numbuf2, numcour;


    for (numcour = 0; numcour < nbtotbuf; numcour ++)
        occupation [numcour] = 0;

    for (numcour = 0; numcour <= numderbuf; numcour ++)
        occupation [listebuf [numcour]] = 1;

    numbuf1 = 0;
    numbuf2 = nbtotbuf - 1;

    while (numbuf1 < numbuf2)
    {
        while (occupation [numbuf1] == 1)
            numbuf1 ++;

        while (occupation [numbuf2] == 0)
            numbuf2 --;

        if (numbuf2 > numbuf1)
        {
            memcpy (adrbuf [numbuf1], adrbuf [numbuf2], szbuffer);

            numcour = 0;

            while (listebuf [numcour] != numbuf2)
                numcour ++;

            listebuf [numcour] = numbuf1;

            occupation [numbuf1] = 1;
            occupation [numbuf2] = 0;
        }
    }

    while (nbtotbuf > numbuf1)
        free (adrbuf [--nbtotbuf]);

    adrbuf [nbtotbuf] = 0;

    bufcour = adrbuf [listebuf [numbufcour]];

    duplibuf ();
    undo_ok = -1;
}

initmem ()
{
    listebuf [0] = 0;

    numderbuf = 0;
    szderbuf  = 0;

    bufcour = adrbuf [0];

    undo_ok = 1;
}




posdebuf ()
{
    numbufcour = 0;
    posbufcour = 0;

    bufcour = adrbuf [listebuf [0]];
}




avancebuf ()
{
    posbufcour ++;

    if (posbufcour >= szbuffer)
    {
        if (numbufcour < numderbuf)
        {
            numbufcour ++;
            bufcour = adrbuf [listebuf [numbufcour]];

            posbufcour = 0;
        }
    }
}




reculebuf ()
{
    if (posbufcour > 0)
        posbufcour --;
    else
    {
        numbufcour --;
        bufcour = adrbuf [listebuf [numbufcour]];

        posbufcour = szbuffer - 1;
    }
}




ajoutbuf (c)
octet c;
{
    octet numbuflibre;


    if (szderbuf >= szbuffer)
    {
        numbuflibre = listebuf [numderbuf] + 1;

        bufcour = adrbuf [numbuflibre];

        listebuf [++numderbuf] = numbuflibre;
        szderbuf = 0;
    }

    bufcour [szderbuf++] = c;
}

intxx insertmax ()
{
    octet libre;

    libre = nbtotbuf - 2 - numderbuf;

    if (libre > 0)
        return ((libre * (long) szbuffer) - szderbuf);
    else
        return (0);
}




sauveposbuf ()
{
    savenumbuf2 = savenumbuf;
    savenumbuf  = numbufcour;
    saveposbuf2 = saveposbuf;
    saveposbuf  = posbufcour;
}




restorposbuf ()
{
    numbufcour = savenumbuf;
    savenumbuf = savenumbuf2;
    bufcour = adrbuf [listebuf [numbufcour]];

    posbufcour = saveposbuf;
    saveposbuf = saveposbuf2;
}




octet cherchebuflibre ()
{
    octet occupation [nbmaxbuf + 1];
    octet numbuf;


    for (numbuf = 0; numbuf <= nbtotbuf; numbuf ++)
        occupation [numbuf] = 0;

    for (numbuf = 0; numbuf < numbufcour; numbuf ++)
        occupation [listebuf [numbuf]] = 2;

    while (numbuf <= numderbuf)
        occupation [listebuf [numbuf++]] = 1;

    for (numbuf = 0; numbuf <= numderbuf2; numbuf ++)
        occupation [listebuf2 [numbuf]] = 1;

    for (numbuf = 0; occupation [numbuf] != 0; numbuf ++);

    if (adrbuf [numbuf] == 0)
    {
        undo_ok = 0;

        for (numbuf = 0; occupation [numbuf] == 1; numbuf ++);

        if (adrbuf [numbuf] == 0)
        {
            numbuf = numbufcour;
            bip ();
        }
    }

    return (numbuf);
}




posfinbuf2 ()
{
    numbufcour2 = numderbuf2;
    posbufcour2 = szderbuf2;

    bufcour2 = adrbuf [listebuf2 [numderbuf2]];
}

avancebuf2 ()
{
    posbufcour2 ++;

    if (posbufcour2 >= szbuffer)
    {
        if (numbufcour2 < numderbuf2)
        {
            numbufcour2 ++;
            bufcour2 = adrbuf [listebuf2 [numbufcour2]];

            posbufcour2 = 0;
        }
    }
}




reculebuf2 ()
{
    if (posbufcour2 > 0)
        posbufcour2 --;
    else
    {
        numbufcour2 --;
        bufcour2 = adrbuf [listebuf2 [numbufcour2]];

        posbufcour2 = szbuffer - 1;
    }
}




ajoutbuf2 (c)
octet c;
{
    octet numbuflibre;


    if (szderbuf2 >= szbuffer)
    {
        numbuflibre = cherchebuflibre ();

        bufcour2 = adrbuf [numbuflibre];

        numderbuf2 ++;
        listebuf2 [numderbuf2] = numbuflibre;
        szderbuf2 = 0;
    }

    bufcour2 [szderbuf2++] = c;
}




supcarbuf2 ()
{
    if (szderbuf2 > 0)
        szderbuf2 --;
    else
    {
        numderbuf2 --;
        bufcour2 = adrbuf [listebuf2 [numderbuf2]];

        szderbuf2 = szbuffer - 1;
    }
}

duplibuf ()
{
    for (numderbuf2 = 0; numderbuf2 <= numderbuf; numderbuf2 ++)
        listebuf2 [numderbuf2] = listebuf [numderbuf2];

    numderbuf2 = numderbuf;
    szderbuf2 = szderbuf;

    saveposref ();
}




saveposref ()
{
    posbufref = posbufcour;
    numbufref = numbufcour;
    numligref = numlig;
    ligneref  = lignecurseur;
    colonref  = colcurseur;
}




permutposbuf ()
{
    octet numtmp;
    int16 postmp;


    numtmp     = savenumbuf;
    savenumbuf = numbufcour;
    numbufcour = numtmp;

    bufcour = adrbuf [listebuf [numbufcour]];

    postmp     = saveposbuf;
    saveposbuf = posbufcour;
    posbufcour = postmp;
}




undo ()
{
    permute ();

    numbufcour = numbufref;
    posbufcour = posbufref;
    bufcour = adrbuf [listebuf [numbufcour]];

    numlig = numligref;
    lignecurseur = ligneref;
    colcurseur = colonref;
}




permute ()
{
    octet *listmp;
    octet numtmp;
    int16 sztmp;


    listmp    = listebuf2;
    listebuf2 = listebuf;
    listebuf  = listmp;

    numtmp     = numderbuf2;
    numderbuf2 = numderbuf;
    numderbuf  = numtmp;

    sztmp     = szderbuf2;
    szderbuf2 = szderbuf;
    szderbuf  = sztmp;
}

copdebuf ()
{
    octet numbuflibre;


    undo_ok = 1;

    for (numderbuf2 = 0; numderbuf2 < numbufcour; numderbuf2 ++)
        listebuf2 [numderbuf2] = listebuf [numderbuf2];

    numbuflibre = cherchebuflibre ();

    bufcour2 = adrbuf [numbuflibre];

    listebuf2 [numderbuf2] = numbuflibre;

    memcpy (bufcour2, bufcour, posbufcour);
    szderbuf2 = posbufcour;

    saveposref ();
}




copfinbuf ()
{
    int16 postmp;
    octet numtmp;


    numtmp = numderbuf2;
    postmp = szderbuf2;

    if (szderbuf2 == posbufcour)
    {
        memcpy (bufcour2 + posbufcour, bufcour + posbufcour, szbuffer - posbufcour);

        while (numbufcour < numderbuf)
            listebuf2 [++numderbuf2] = listebuf [++numbufcour];

        szderbuf2  = szderbuf;
    }
    else
    {
        while (! finfichier ())
        {
            ajoutbuf2 (carcourant ());
            avancebuf ();
        }
    }

    permute ();

    numbufcour = numtmp;
    posbufcour = postmp;
    bufcour = adrbuf [listebuf [numbufcour]];

#ifdef gvi
    if (majtmp == 0)
    {
        majtmp   = 1;
        misajour = 1;
        heuremajsuiv = clock () + (att_maj * TIC_SEC);
    }
#endif
}
