/* taille et nombre max des buffers utiliss */
#define szbuffer     5000
#define nbmaxbuf      120

/* mmoire minimum pour travailler */
#define minmemolibre  600

/* sauvegardes pour la fonction undo */
static intxx numligref;           /* numro de ligne */
static char  ligneref, colonref;  /* position du curseur */
static octet undo_ok;

/* adresses des buffers allous */
static octet *adrbuf [nbmaxbuf];
static octet nbtotbuf;

/* liste des buffers utiliss */
static octet *listebuf, *listebuf2;

/* buffers courants et positionnement */
static octet *bufcour, *bufcour2;
static octet numbufcour, numbufcour2;
static int16 posbufcour, posbufcour2;

/* emplacement fin du fichier */
static octet numderbuf, numderbuf2;
static int16 szderbuf,  szderbuf2;

/* sauvegarde position dans les buffers */
static octet savenumbuf, savenumbuf2, numbufref;
static int16 saveposbuf, saveposbuf2, posbufref;



#define carcourant()         bufcour [posbufcour]
#define debfichier()         (numbufcour == 0 && posbufcour == 0)
#define finfichier()         (numbufcour == numderbuf && posbufcour >= szderbuf)

#define carcourant2()        bufcour2 [posbufcour2]
#define debfich2()           (numbufcour2 == 0 && posbufcour2 == 0)
#define dercar2()            bufcour2 [szderbuf2]
#define majbuf2(c)           bufcour2 [szderbuf2 - 1] = c

cremem ()
{
    listebuf  = malloc (nbmaxbuf);
    listebuf2 = malloc (nbmaxbuf);

    nbtotbuf = 0;

    unpackmem ();
}




unpackmem ()
{
    while (coreleft () > szbuffer + minmemolibre)
        adrbuf [nbtotbuf++] = malloc (szbuffer);

    adrbuf [nbtotbuf] = 0;
    adrbuf [nbtotbuf + 1] = 0;
}




packmem ()
{
    octet derbuf;


    derbuf = (numderbuf + 1) * 2;

    while (nbtotbuf > derbuf)
        free (adrbuf [--nbtotbuf]);

    adrbuf [nbtotbuf] = 0;
}




initmem ()
{
    listebuf [0] = 0;

    numderbuf = 0;
    szderbuf  = 0;

    bufcour = adrbuf [0];

    undo_ok = 1;
}




posdebuf ()
{
    numbufcour = 0;
    posbufcour = 0;

    bufcour = adrbuf [listebuf [0]];
}




avancebuf ()
{
    posbufcour ++;

    if (posbufcour >= szbuffer)
    {
        if (numbufcour < numderbuf)
        {
            numbufcour ++;
            bufcour = adrbuf [listebuf [numbufcour]];

            posbufcour = 0;
        }
        else if (posbufcour > szbuffer)
            posbufcour = szbuffer;
    }
}

reculebuf ()
{
    if (posbufcour > 0)
        posbufcour --;
    else
    {
        numbufcour --;
        bufcour = adrbuf [listebuf [numbufcour]];

        posbufcour = szbuffer - 1;
    }
}




ajoutbuf (c)
octet c;
{
    octet numbuflibre;


    if (szderbuf >= szbuffer)
    {
        numbuflibre = listebuf [numderbuf] + 2;

        bufcour = adrbuf [numbuflibre];

        listebuf [++numderbuf] = numbuflibre;
        szderbuf = 0;
    }

    bufcour [szderbuf++] = c;
}




intxx insertmax ()
{
    return (((nbtotbuf / 2) - numderbuf) * (long) szbuffer - szderbuf);
}




sauveposbuf ()
{
    savenumbuf2 = savenumbuf;
    savenumbuf  = numbufcour;
    saveposbuf2 = saveposbuf;
    saveposbuf  = posbufcour;
}




restorposbuf ()
{
    numbufcour = savenumbuf;
    savenumbuf = savenumbuf2;
    bufcour = adrbuf [listebuf [numbufcour]];

    posbufcour = saveposbuf;
    saveposbuf = saveposbuf2;
}




posfinbuf2 ()
{
    numbufcour2 = numderbuf2;
    posbufcour2 = szderbuf2;

    bufcour2 = adrbuf [listebuf2 [numderbuf2]];
}

avancebuf2 ()
{
    posbufcour2 ++;

    if (posbufcour2 >= szbuffer)
    {
        if (numbufcour2 < numderbuf2)
        {
            numbufcour2 ++;
            bufcour2 = adrbuf [listebuf2 [numbufcour2]];

            posbufcour2 = 0;
        }
        else if (posbufcour2 > szbuffer)
            posbufcour2 = szbuffer;
    }
}




reculebuf2 ()
{
    if (posbufcour2 > 0)
        posbufcour2 --;
    else
    {
        numbufcour2 --;
        bufcour2 = adrbuf [listebuf2 [numbufcour2]];

        posbufcour2 = szbuffer - 1;
    }
}




ajoutbuf2 (c)
octet c;
{
    octet numbuflibre;


    if (szderbuf2 >= szbuffer)
    {
        numbuflibre = listebuf2 [numderbuf2] + 2;

        bufcour2 = adrbuf [numbuflibre];

        numderbuf2 ++;
        listebuf2 [numderbuf2] = numbuflibre;
        szderbuf2 = 0;
    }

    bufcour2 [szderbuf2++] = c;
}




supcarbuf2 ()
{
    if (szderbuf2 > 0)
        szderbuf2 --;
    else
    {
        numderbuf2 --;
        bufcour2 = adrbuf [listebuf2 [numderbuf2]];

        szderbuf2 = szbuffer - 1;
    }
}

duplibuf ()
{
    for (numderbuf2 = 0; numderbuf2 <= numderbuf; numderbuf2 ++)
    {
        listebuf2 [numderbuf2] = listebuf [numderbuf2] + 1;
        memcpy (adrbuf [listebuf2 [numderbuf2]],
                adrbuf [listebuf [numderbuf2]], szbuffer);
    }

    numderbuf2 = numderbuf;
    szderbuf2  = szderbuf;

    saveposref ();
}




saveposref ()
{
    posbufref = posbufcour;
    numbufref = numbufcour;
    numligref = numlig;
    ligneref  = lignecurseur;
    colonref  = colcurseur;
}




permutposbuf ()
{
    octet numtmp;
    int16 postmp;


    numtmp     = savenumbuf;
    savenumbuf = numbufcour;
    numbufcour = numtmp;

    bufcour = adrbuf [listebuf [numbufcour]];

    postmp     = saveposbuf;
    saveposbuf = posbufcour;
    posbufcour = postmp;
}




undo ()
{
    permute ();

    numbufcour = numbufref;
    posbufcour = posbufref;
    bufcour = adrbuf [listebuf [numbufcour]];

    numlig = numligref;
    lignecurseur = ligneref;
    colcurseur = colonref;
}




permute ()
{
    octet *listmp;
    octet numtmp;
    int16 sztmp;


    listmp    = listebuf2;
    listebuf2 = listebuf;
    listebuf  = listmp;

    numtmp     = numderbuf2;
    numderbuf2 = numderbuf;
    numderbuf  = numtmp;

    sztmp     = szderbuf2;
    szderbuf2 = szderbuf;
    szderbuf  = sztmp;
}

copdebuf ()
{
    octet numbuflibre;


    numbuflibre = 1 - listebuf [0];

    for (numderbuf2 = 0; numderbuf2 < numbufcour; numderbuf2 ++)
    {
        listebuf2 [numderbuf2] = numbuflibre;
        memcpy (adrbuf [numbuflibre], adrbuf [listebuf [numderbuf2]], szbuffer);
        numbuflibre = numbuflibre + 2;
    }

    listebuf2 [numderbuf2] = numbuflibre;
    bufcour2 = adrbuf [numbuflibre];

    memcpy (bufcour2, bufcour, posbufcour);
    szderbuf2 = posbufcour;

    saveposref ();
}




copfinbuf ()
{
    int16 postmp;
    octet numtmp;


    numtmp = numderbuf2;
    postmp = szderbuf2;

    if (szderbuf2 == posbufcour && numderbuf2 == numbufcour)
    {
        memcpy (bufcour2 + posbufcour, bufcour + posbufcour, szbuffer - posbufcour);

        while (numbufcour < numderbuf)
        {
            listebuf2 [numderbuf2 + 1] = listebuf2 [numderbuf2] + 2;
            memcpy (adrbuf [listebuf2 [++numderbuf2]],
                    adrbuf [listebuf [++numbufcour]], szbuffer);
        }

        szderbuf2 = szderbuf;
    }
    else
    {
        while (! finfichier ())
        {
            ajoutbuf2 (carcourant ());
            avancebuf ();
        }
    }

    permute ();

    numbufcour = numtmp;
    posbufcour = postmp;
    bufcour = adrbuf [listebuf [numbufcour]];

    if (majtmp == 0)
    {
        majtmp   = 1;
        misajour = 1;
        heuremajsuiv = clock () + (att_maj * TIC_SEC);
    }
}
