#include <stdio.h>
#include <dos.h>
#include <math.h>

#define periode     29.5300589
#define offset       1.27
#define poidsjour  (4.0 / periode)


main (int narg, char *varg [])
{
    struct date datecur;


    if (--narg > 0)
    {
        do
        {
            varg ++;
            cal (atoi (*varg));

            if (--narg > 0)
                putchar ('\n');
        }
        while (narg > 0);
    }
    else
    {
        getdate (&datecur);
        cal (datecur.da_year);
    }
}


cal (int an)
{
    char *listemois [] = {"Janv", "Fvr", "Mars", "Avr", "Mai", "Juin",
                          "Juil", "Aout", "Sept", "Oct", "Nov", "Dc"};
    long   jdebmois [13];
    long   jdeban;
    double poscycle;
    long   numjour, numcycle;
    int    cycle;
    int    jour, mois;
    int    i;


    if (an < 100)
    {
        if (an < 50)
            an = an + 2000;
        else
            an = an + 1900;
    }

    if (an < 1901 || an > 2099)
        fprintf (stderr,
      "Anne trop lointaine, une erreur d'un jour par sicle est possible\n");

    jdeban = ((long) an * 365) + (an / 4);

    for (i = 1; i < 12; i++)
        jdebmois [i + 1] = jdeban + (i * 30) + (i * 10 / 17);

    numjour = jdeban - (an / 4) + ((an - 1) / 4) - 29;
    jdebmois [0] = numjour;
    jdebmois [1] = numjour + 31;

    poscycle = (numjour * poidsjour) + offset;
    numcycle = floor (poscycle);

    do
    {
        numjour ++;
        poscycle = poscycle + poidsjour;
    }
    while (floor (poscycle) == numcycle);

    numcycle ++;
    cycle = numcycle % 4;

    printf ("             Calendrier lunaire %d\n\n", an);

    puts ("|  Nouvelle | Premier Q |   Pleine  | Dernier Q |");

    for (i = 0; i < cycle; i++)
        printf ("|           ");

    mois = 0;

    do
    {
        jour = numjour - jdebmois [mois];
        printf ("| %3d %-6s", jour, listemois [mois]);

        numjour = numjour + 7;
        poscycle = (numjour * poidsjour) + offset;

        while (floor (poscycle) == numcycle)
        {
            poscycle = poscycle + poidsjour;
            numjour ++;
        }

        numcycle ++;
        cycle = numcycle % 4;

        if (numjour > jdebmois [mois + 1])
            mois++;

        if (!cycle && mois < 12)
            puts ("|");
    }
    while (mois < 12);

    while (cycle++ % 4)
        printf ("|           ");

    puts ("|");
}
