#include <stdio.h>
#include <dos.h>
#include <io.h>

#define droit_a   0x20
#define droit_s     4
#define droit_h     2
#define droit_p     1
#define droit_w     1
#define tous      0x27

#define absolu      0
#define relatif     1

#define octet     unsigned char


static octet mode;
static octet masque1, masque2;
static octet type_chmod;



main (narg, varg)
int narg;
char *varg [];
{
    /* se positionner sur le premier argument */
    *varg++;


    if ('0' <= **varg && **varg <= '9')
    {
        type_chmod = absolu;
        lecval_droits (*varg);
    }
    else if (**varg == 'a' || **varg == 's' || **varg == 'h' || **varg == 'p')
    {
        type_chmod = absolu;
        droits_absolu (*varg);
    }
    else if (**varg == '+' || **varg == '-')
    {
        type_chmod = relatif;
        masque1 = 0;
        masque2 = 0;

        do
        {
            if (** varg == '+')
                ajout_droits (*varg + 1);
            else
                supprime_droits (*varg + 1);

            varg++;
            narg--;
        }
        while (**varg == '+' || **varg == '-');
    }
    else
        erreur ("Droit d'accs ", *varg, " invalide");

    if (type_chmod == absolu)
    {
        /* se positionner sur le premier nom de fichier */
        varg++;
        narg--;

        /* tantqu'il y a des fichiers ou des rpertoires  traiter */
        while (--narg > 0)
        {
            /* mettre  jour le mode d'accs */
            if (_chmod (*varg, 1, mode) == -1)
                if (access (*varg, 0) == 0)
                    fprintf (stderr,
             "Impossible de changer le droit d'accs de %s\n", *varg);
                else
                    fprintf (stderr, "Fichier %s inexistant\n", *varg);

            /* passer  l'argument suivant */
            *varg++;
        }
    }
    else
    {
        /* si les droits  rajouter et  supprimer sont compatibles */
        if ((masque1 & masque2) == 0)
        {
            /* mise en forme du masque des droits  supprimer */
            masque2 = masque2 ^ tous;

            /* tantqu'il y a des fichiers ou des rpertoires  traiter */
            while (--narg > 0)
            {
                /* recuprer le mode d'accs initial */
                mode = _chmod (*varg, 0);

                /* et le mettre  jour */
                if (_chmod (*varg, 1, (mode | masque1) & masque2) == -1)
                    if (access (*varg, 0) == 0)
                        fprintf (stderr,
                 "Impossible de changer le droit d'accs de %s\n", *varg);
                    else
                        fprintf (stderr, "Fichier %s inexistant\n", *varg);

                /* passer  l'argument suivant */
                *varg++;
            }
        }
        else
        {
            /* chercher les bits communs aux 2 masques */
            masque1 = masque1 & masque2;

            /* messages d'erreur */
            fputs ("Utilisation de droits incompatibles entre eux : ", stderr);

            if ((masque1 & droit_p) != 0)
                fputs ("+p ou -w  avec  -p ou +w\n", stderr);

            if ((masque1 & droit_a) != 0)
                fputs ("+a et -a   ", stderr);

            if ((masque1 & droit_s) != 0)
                fputs ("+s et -s   ", stderr);

            if ((masque1 & droit_h) != 0)
                fputs ("+h et -h", stderr);

            putc ('\n', stderr);
        }
    }
}


lecval_droits (chaine)
char *chaine;
{
    int  posdercar;


    mode = *chaine - '0';

    posdercar = 1;

    while ('0' <= chaine [posdercar] && chaine [posdercar] <= '9')
        mode = (mode * 10) + (chaine [posdercar ++] - '0');

    if (chaine [posdercar] != 0)
        erreur ("Droit d'accs ", chaine, " invalide");

    if (mode > 7)
    {
        if (mode < 16)
            mode = mode + 24;
        else if (20 <= mode && mode <= 27)
            mode = mode + 12;
        else
            erreur ("Mode d'accs ", chaine, " invalide");
    }
}


droits_absolu (chaine)
char *chaine;
{
    mode = 0;

    do
    {
        switch (*chaine)
        {
            case 'a' : mode = mode | droit_a;
                       break;
            case 's' : mode = mode | droit_s;
                       break;
            case 'h' : mode = mode | droit_h;
                       break;
            case 'p' : mode = mode | droit_p;
                       break;
            case 'w' : fputs ("Le droit w est implicite\n", stderr);
                       break;

            default  : chaine [1] = 0;
                       erreur ("Droit ", chaine, " inexistant");
        }

        chaine++;
    }
    while (*chaine != 0);
}


ajout_droits (chaine)
char *chaine;
{
    do
    {
        switch (*chaine)
        {
            case 'a' : masque1 = masque1 | droit_a;
                       break;
            case 's' : masque1 = masque1 | droit_s;
                       break;
            case 'h' : masque1 = masque1 | droit_h;
                       break;
            case 'p' : masque1 = masque1 | droit_p;
                       break;
            case 'w' : masque2 = masque2 | droit_p;
                       break;

            default  : chaine [1] = 0;
                       erreur ("Droit ", chaine, " inexistant");
        }

        chaine++;
    }
    while (*chaine != 0);
}


supprime_droits (chaine)
char *chaine;
{
    do
    {
        switch (*chaine)
        {
            case 'a' : masque2 = masque2 | droit_a;
                       break;
            case 's' : masque2 = masque2 | droit_s;
                       break;
            case 'h' : masque2 = masque2 | droit_h;
                       break;
            case 'p' : masque2 = masque2 | droit_p;
                       break;
            case 'w' : masque1 = masque1 | droit_p;
                       break;

            default  : chaine [1] = 0;
                       erreur ("Droit ", chaine, " inexistant");
        }

        chaine++;
    }
    while (*chaine != 0);
}


erreur (chaine1, chaine2, chaine3)
char *chaine1, *chaine2, *chaine3;
{
     fputs (chaine1, stderr);
     fputs (chaine2, stderr);
     fputs (chaine3, stderr);
     putc ('\n', stderr);
     exit ();
}
