/***********************************************************************
*                                                                      *
*   Programme convaccent.c                                             *
*                                                                      *
*   Dvelopp sur machine UNIX et rcupr                             *
*                                                                      *
*   Sans option, convertit les caractres accentus IBM utiliss sur   *
*   les compatibles P.C et les imprimantes en caractres accentus     *
*   des visus VT100.                                                   *
*                                                                      *
*   Avec option -e : fait la conversion inverse.                       *
*                                                                      *
***********************************************************************/

#include <stdio.h>


/* table de correspondance pour la conversion */
static char tabcor [96] = { 0   , 0xad, 0x9b, 0x9c, 0   , 0x9d, 0   , 0   ,
                            0   , 0   , 0xa6, 0xae, 0   , 0   , 0   , 0   ,
                            0xf8, 0xf1, 0xfd, 0   , 0   , 0xe6, 0   , 0xf9,
                            0   , 0   , 0xa7, 0xaf, 0xac, 0xab, 0   , 0xa8,
                            0   , 0   , 0   , 0   , 0x8e, 0x8f, 0x92, 0x80,
                            0   , 0x90, 0   , 0   , 0   , 0   , 0   , 0   ,
                            0   , 0xa5, 0   , 0   , 0   , 0   , 0x99, 0   ,
                            0xe9, 0   , 0   , 0   , 0x9a, 0   , 0   , 0xe1,
                            0x85, 0xa0, 0x83, 0   , 0x84, 0x86, 0x91, 0x87,
                            0x8a, 0x82, 0x88, 0x89, 0x8d, 0xa1, 0x8c, 0x8b,
                            0   , 0xa4, 0x95, 0xa2, 0x93, 0   , 0x94, 0   ,
                            0xed, 0x97, 0xa3, 0x96, 0x81, 0x98, 0   , 0     };

/* programme principal */

main (narg, varg)
int narg;
char *varg [];
{
    int car;
    int sens = 0;
    int i;
    char coresp [128];

    /* positionnement sur le 1er argument */
    varg++;

    /* si option de slection de la table de correspondance */
    if (narg > 1 && **varg == '-')
    {
        /* test si option -e */
        if (strcmp (*varg, "-e") == 0)
            sens = 1;

        /* passage  l'argument suivant */
        varg++;
        narg--;
    }

    /* prise en compte du nom de fichier passe en paramtre */
    if (narg > 1)
    {
        if (freopen (*varg, "rb", stdin) == 0)
            fprintf (stderr, "Fichier %s inexistant\n", *varg);
    }

    /* initialisation de la table de correspondance */
    for (i = 0; i < 128; i++)
        coresp [i] = i | 0x80;

    /* remplissage de la table de correspondance */
    if (sens == 0)
    {
        /* conversion de l'cran vers l'imprimante */
        for (i = 0; i < 96; i++)
            if (tabcor [i] != 0)
                coresp [0x20 + i] = tabcor [i];
    }
    else
    {
        /* conversion de l'imprimante vers l'cran */
        for (i = 0; i < 96; i++)
            if (tabcor [i] != 0)
                coresp [(tabcor [i]) & 0x7f] = 0xa0 + i;
    }

    /* lire le premier caractre */
    car = getchar ();

    /* tantque non fin de fichier */
    while (car != -1)
    {
        /* transformation si ncssaire et dition du caractre */
        if ((car & 0x80) == 0)
            putchar (car);
        else
            putchar (coresp [car & 0x7f]);

        /* lire et mmoriser le caractre suivant */
        car = getchar ();
    }

    /* diter si ncssaire le dernier caractre du fichier */
    if (car != -1)
        putchar (car);
}
