#include <stdio.h>
#include <dir.h>
#include <io.h>

#define szbuf  16384

struct ffblk fich;       /* table de description des fichiers */


/* extraction du nom de fichier  partir d'un chemin d'accs */
char *basename (chaine)
char *chaine;
{
    char *car,     /* caractre courant dans la chaine */
         *debchn;  /* caractre qui suit le dernier '/' rencontr */

    /* positionnement sur le premier caractre de la chaine */
    car = chaine;
    debchn = car;

    /* tantque chaine non compltement explore */
    while (*car != 0)
    {
        /* si le caractre courant est un '/' ou un '\' */
        if ((*car == '\\') || (*car == '/'))
            /* mmoriser la position du caractre suivant */
            debchn = car + 1;

        /* avancer d'un caractre */
        car++;
    }

    /* retourner la position du dbut du nom de fichier */
    return (debchn);
}


/* programme principal */
main (narg, varg)
int narg;
char *varg [];
{
    char *lastarg;     /* dernier argument */
    char chemin [80];  /* chemin d'accs  un fichier du rpertoire */
    char newfic [80];  /* nom du nouveau fichier */
    char dirder;       /* type du dernier argument (fichier ou rpertoire) */
    FILE *ftest;       /* descripteur de fichier */

    /* positionnement sur le premier argument */
    *varg++;
    narg--;

    /* controle du nombre d'arguments */
    if (narg < 2)
        psyntaxe ();
    else
    {
        /* rcupration du dernier argument */
        lastarg = *(varg + narg - 1);

        /* fabriquer chemin d'accs aux lments du rpertoire  tester */
        sprintf (chemin, "%s/*.*", lastarg);

        /* s'il s'agit d'un rpertoire */
        if (findfirst (chemin, &fich, 0xff) == 0)
            /* le mmoriser */
            dirder = 1;

        /* sinon  vrification suplmentaire */
        else
        {
            /* essayer de crer un fichier dans le rpertoire */
            sprintf (chemin, "%s/-", lastarg);
            ftest = fopen (chemin, "a");

            /* si l'essai est concluant */
            if (ftest > 0)
            {
                /* fermer et dtruire le fichier d'essai */
                fclose (ftest);
                unlink (chemin);

                /* et memoriser le fait qu'on a un rpertoire */
                dirder = 1;
            }
            /* sinon  on n'est pas sur un rpertoire */
            else
                dirder = 0;
        }

        /* si le dernier argument est un rpertoire */
        if (dirder == 1)
        {
            /* tantqu'il y a des fichiers  copier */
            while (--narg > 0)
            {
                /* crer le chemin d'accs au nouveau fichier */
                sprintf (newfic, "%s/%s", lastarg, basename (*varg));

                /* copier le fichier */
                cp2 (*varg, newfic);

                /* passer  l'argument suivant */
                *varg++;
            }
        }
        /* sinon */
        else
        {
            /* si seulement 2 arguments */
            if (narg == 2)
                /* copier le fichier */
                cp2 (*varg, *(varg + 1));

            /* sinon */
            else
                /* rappeler la syntaxe de la commande */
                psyntaxe ();
        }
    }
}


/* copie d'un fichier */
cp2 (oldfic, newfic)
char oldfic [], newfic [];
{
    FILE *ficin, *ficout; /* descripteurs de fichiers */
    int descfic;          /* descripteur de fichier pour la fonction open */
    struct ftime mtime;   /* date derniere mise a jour du fichier a copier */
    char buffer [szbuf];  /* buffer de transfert */
    int szlect, szrecop;  /* taille de la zone lue et de la zone recopie */


    /* si l'ancien fichier existe et peut etre recopi */
    if (findfirst (oldfic, &fich, 0xff) == 0)
    {
        if ((fich.ff_attrib & 0x18) == 0)
        {
            /* recuperer la date de derniere mise
               a jour du fichier a recopier */
            descfic = open (oldfic, 0x8001);
            getftime (descfic, &mtime);
            close (descfic);

            /* ouvrir les fichiers origine et destination */
            ficin  = fopen (oldfic, "rb");
            ficout = fopen (newfic, "wb");

            /* lire un morceau du fichier origine */
            szlect = fread (buffer, 1, szbuf, ficin);

            /* tanque non fin de fichier */
            while (szlect > 0)
            {
                /* recopier la zone lue */
                szrecop = fwrite (buffer, 1, szlect, ficout);

                /* si probleme lors de la copie */
                if (szrecop < szlect)
                {
                    /* message d'erreur */
                    perror ("write");

                    /* on arretera la copie */
                    szlect = 0;
                }
                /* sinon */
                else
                    /* lire la suite du fichier d'origine */
                    szlect = fread (buffer, 1, szbuf, ficin);
            }

            /* fermer les fichiers */
            fclose (ficin);
            fclose (ficout);

            /* corriger la date de derniere mise a jour du fichier destination */
            descfic = open (newfic, 0x8001);
            setftime (descfic, &mtime);
            close (descfic);
        }
        else
            fprintf (stderr, "Le fichier %s est un rpertoire ou un label\n",
                                                                     oldfic);
    }
    /* sinon message d'erreur */
    else
        fprintf (stderr, "Fichier %s inexistant\n", oldfic);
}


/* rappel de la syntaxe de la commande */
psyntaxe ()
{
     fprintf (stderr, "Syntaxe : %s\n          %s\n          %s\n",
                   "copfic <nom de fichier> <nouveau nom de fichier>",
                   "                         ou",
                   "copfic <liste de fichiers> <rpertoire de destination>");
}
