#include <stdio.h>
#include <dir.h>

#define szbuf  16384

struct ffblk fich;       /* table de description des fichiers */
static char option = 0;  /* prsence de l'option "-n" ou "-y" */


/* extraction du nom de fichier  partir d'un chemin d'accs */
char *basename (chaine)
char *chaine;
{
    char *car,     /* caractre courant dans la chaine */
         *debchn;  /* caractre qui suit le dernier '/' rencontr */

    /* positionnement sur le premier caractre de la chaine */
    car = chaine;
    debchn = car;

    /* tantque chaine non compltement explore */
    while (*car != 0)
    {
        /* si le caractre courant est un '/' ou un '\' */
        if ((*car == '\\') || (*car == '/'))
            /* mmoriser la position du caractre suivant */
            debchn = car + 1;

        /* avancer d'un caractre */
        car++;
    }

    /* retourner la position du dbut du nom de fichier */
    return (debchn);
}


/* programme principal */
main (narg, varg)
int narg;
char *varg [];
{
    char *carg,        /* caractre courant dans un argument */
         *lastarg;     /* dernier argument */
    char chemin [80];  /* chemin d'accs  un fichier du rpertoire */
    char newfic [80];  /* nom du nouveau fichier */
    char dirder;       /* type du dernier argument (fichier ou rpertoire) */
    FILE *ftest;       /* descripteur de fichier */

    /* positionnement sur le premier argument */
    *varg++;
    narg--;
    carg = *varg;

    /* prise en compte des options "-y" ou "-n" */
    if (*carg == '-')
    {
         carg++;
         *carg = *carg | 0x20;

         if (*carg == 'n')
             option = -1;
         else if (*carg == 'y')
             option = 1;
         else
             fprintf (stderr, "Option %s inconnue\n", *varg);

         /* passage  l'argument suivant */
         *varg++;
         narg--;
    }

    /* controle du nombre d'arguments */
    if (narg < 2)
        psyntaxe ();
    else
    {
        /* rcupration du dernier argument */
        lastarg = *(varg + narg - 1);

        /* fabriquer chemin d'accs aux lments du rpertoire  tester */
        sprintf (chemin, "%s/*.*", lastarg);

        /* s'il s'agit d'un rpertoire */
        if (findfirst (chemin, &fich, 0xff) == 0)
            /* le mmoriser */
            dirder = 1;

        /* sinon  vrification suplmentaire */
        else
        {
            /* essayer de crer un fichier dans le rpertoire */
            sprintf (chemin, "%s/-", lastarg);
            ftest = fopen (chemin, "a");

            /* si l'essai est concluant */
            if (ftest > 0)
            {
                /* fermer et dtruire le fichier d'essai */
                fclose (ftest);
                unlink (chemin);

                /* et mmoriser le fait qu'on a un rpertoire */
                dirder = 1;
            }
            /* sinon  on n'est pas sur un rpertoire */
            else
                dirder = 0;
        }

        /* si le dernier argument est un rpertoire */
        if (dirder == 1)
        {
            /* tantqu'il y a des fichiers  copier */
            while (--narg > 0)
            {
                /* crer le chemin d'accs au nouveau fichier */
                sprintf (newfic, "%s/%s", lastarg, basename (*varg));

                /* copier le fichier */
                cp2 (*varg, newfic);

                /* passer  l'argument suivant */
                *varg++;
            }
        }
        /* sinon */
        else
        {
            /* si seulement 2 arguments */
            if (narg == 2)
                /* copier le fichier */
                cp2 (*varg, *(varg + 1));

            /* sinon */
            else
                /* rappeler la syntaxe de la commande */
                psyntaxe ();
        }
    }
}


/* copie d'un fichier */
cp2 (oldfic, newfic)
char oldfic [], newfic [];
{
    FILE *ficin, *ficout; /* descripteurs de fichiers */
    char buffer [szbuf];  /* buffer de transfert */
    int szlect, szrecop;  /* taille de la zone lue et de la zone recopie */
    char go,              /* indicateur : doit on continuer ? */
         rep;             /* rponse  une question */


    /* si l'ancien fichier existe et peut etre recopi */
    if (findfirst (oldfic, &fich, 0xff) == 0)
    {
        if ((fich.ff_attrib & 0x18) == 0)
        {
            go = option - 3 * (findfirst (newfic, &fich, 0xff));

            /* traitement en fonction de l'existence
               du nouveau fichier et de l'option */
            switch (go)
            {
                /* nouveau fichier existant et option "-n" */
                case -1 : fprintf (stderr, "Fichier %s dj existant\n",
                                                                     newfic);
                          break;

                /* nouveau fichier existant et pas d'option */
                case  0 : printf (
                          "Fichier %s dj existant, voulez vous l'craser ? ",
                                                                    newfic);

                          /* on demande l'avis de l'oprateur */
                          rep = bioskey (0);
                          putchar (rep);
                          putchar (10);

                          /* prise en compte de la rponse */
                          if ((rep | 0x20) == 'n')
                              break;

                /* nouveau fichier existant et option
                   "-y" ou suite du cas prcdent */
                /* nouveau fichier inexistant ou suite du cas prcdent */
                default : /* ouvrir les fichiers origine et destination */
                          ficin  = fopen (oldfic, "rb");
                          ficout = fopen (newfic, "wb");

                          /* lire un morceau du fichier origine */
                          szlect = fread (buffer, 1, szbuf, ficin);

                          /* tanque non fin de fichier */
                          while (szlect > 0)
                          {
                              /* recopier la zone lue */
                              szrecop = fwrite (buffer, 1, szlect, ficout);

                              /* si probleme lors de la copie */
                              if (szrecop < szlect)
                              {
                                  /* message d'erreur */
                                  perror ("write");

                                  /* on arretera la copie */
                                  szlect = 0;
                              }
                              /* sinon */
                              else
                                  /* lire la suite du fichier d'origine */
                                  szlect = fread (buffer, 1, szbuf, ficin);
                          }

                          /* fermer les fichiers */
                          fclose (ficin);
                          fclose (ficout);

            }
        }
        else
            fprintf (stderr, "Le fichier %s est un rpertoire ou un label\n",
                                                                     oldfic);
    }
    /* sinon message d'erreur */
    else
        fprintf (stderr, "Fichier %s inexistant\n", oldfic);
}


/* rappel de la syntaxe de la commande */
psyntaxe ()
{
     fprintf (stderr, "%s %s\n%s %s\n",
             "Syntaxe : cp [-(y|n)] <nom de fichier>",
                            "<nouveau nom de fichier>",
             "     ou : cp [-(y|n)] <liste de fichiers>",
                         "<rpertoire de destination>");
}
