#include <stdio.h>
#include <dir.h>

#define maxchem  128
#define szbuf    16*1024


static struct ffblk descfic;         /* description d'un fichier */
static char   buffer [szbuf];        /* buffer de transfert */
static char   disque;                /* disque de destination */


main (narg, varg)
int narg;
char *varg [];
{
    char origine [maxchem];
    char *dest;
    int  destOK;
    int  place [5];   /* espace disque disponible */
    int  nblocs;


    /* test du nombre d'arguments */
    if (--narg == 1)
    {
        dest = varg [1];

        /* pas de /  la fin du rpertoire de destination */
        if (dest [strlen (dest) - 1] == '/' ||
            dest [strlen (dest) - 1] == '\\')
            dest [strlen (dest) - 1] = 0;

        /* test de l'existence du rpertoire de destination */
        if (*dest == 0 || (dest [1] == ':' && dest [2] == 0))
        {
            /* cas particulier, destination = X:/ ou / */
            destOK = 1;
            descfic.ff_attrib = 0x10;
        }
        else
        {
            /* cas gnral */
            mkdir (dest);
            destOK = (findfirst (dest, &descfic, 0x37) == 0);
        }

        /* si le rpertoire de destination existe */
        if (destOK)
        {
            /* et que c'est bien un rpertoire */
            if (descfic.ff_attrib & 0x10)
            {
                strcat (dest, "/");

                /* rcuprer le nom du disque destinataire de la copie */
                if (dest [1] == ':')
                    disque = *dest & 0x1f;
                else
                    disque = 0;    /* disque courant */

                /* mesurer la place libre sur le disque avant transfert */
                getdfree (disque, place);

                /* recopier les fichiers de nom lus sur l'entre standard */
                while (gets (origine) != 0)
                    copfic (origine, dest);

                /* mesurer la place libre sur le disque aprs transfert */
                getdfree (disque, &place [1]);

                /* calcul de nombre de Koctets utiliss */
                nblocs = ((place [0] - place [1]) *
                          ((place [3] * place [4]) / 512) + 1) / 2;

                /* rcapitulatif des transferts */
                if (nblocs > 1)
                    printf ("%u Koctets utiliss\n", nblocs);

                else if (nblocs == 1)
                    puts ("1 Koctet utilis");

                else if (nblocs == 0)
                    puts ("Occupation disque inchange");
            }
            else
                fprintf (stderr, "%s est un fichier\n", dest);
        }
        else
            fprintf (stderr, "Le rpertoire %s n'a pu tre cr\n", dest);
    }
    else
        fputs ("Syntaxe : <commande> | cpiod <nom de rpertoire>\n", stderr);
}


/* copie d'un fichier ou d'un rpertoire */
copfic (orig, dest)
char *orig, *dest;
{
    FILE  *ficin, *ficout;
    char destination [maxchem];
    char *findest;
    int  szlect, szrecop, recopie;
    int  handle;
    int  place [4];   /* espace disque disponible */


    /* si le fichier  copier existe */
    if (findfirst (orig, &descfic, 0x37) == 0)
    {
        /* crer le chemin d'acc au fichier destination */
        if (orig [1] != ':')
            findest = orig;
        else
            findest = orig + 2;

        while (*findest == '.' || *findest == '/' || *findest == '\\')
            findest ++;

        strcpy (destination, dest);
        strcat (destination, findest);

        /* si le fichier  recopier est un rpertoire */
        if (descfic.ff_attrib & 0x10)
        {
            /* crer le rpertoire de destination */
            if (mkdir (destination) < 0)
            {
                /* prcd si ncessaire de son arborescence */
                mkarbor (destination);
                mkdir (destination);
            }

            puts (destination);
        }
        else
        {
            /* sinon, crer le fichier de destination */
            ficout = fopen (destination, "wb");

            if (ficout == 0)
            {
                /* prcd si ncessaire de son arborescence */
                mkarbor (destination);
                ficout = fopen (destination, "wb");
            }

            /* si on peut remplir ce fichier */
            if (ficout != 0)
            {
                ficin = fopen (orig, "rb");

                /* recopie du fichier d'origine */
                recopie = 1;

                /* lire un morceau du fichier origine */
                szlect = fread (buffer, 1, szbuf, ficin);

                /* tantque non fin de fichier */
                while ((szlect > 0) && (recopie > 0))
                {
                    /* recopier la zone lue */
                    szrecop = fwrite (buffer, 1, szlect, ficout);

                    /* si problme lors de la copie */
                    if (szrecop < szlect)
                    {
                        /* on arrte la copie */
                        recopie = 0;

                        /* manque d'espace disque ? */
                        getdfree (disque, place);

                        /* message d'erreur */
                        if ((place [0] * place [2] * place [3]) < szlect)
                            fprintf (stderr, "Manque d'espace disque\n");
                        else
                            fprintf (stderr, "Erreur indtermine\n");
                    }
                    /* sinon */
                    else
                        /* lire la suite du fichier d'origine */
                        szlect = fread (buffer, 1, szbuf, ficin);
                }

                /* fermer les fichiers */
                fclose (ficin);
                fclose (ficout);

                /* si la copie s'est bien passe */
                if (recopie > 0)
                {
                    /* corriger la date de mise  jour du fichier destination */
                    handle = open (destination, 0x8001);
                    setftime (handle, &descfic.ff_ftime);
                    close (handle);

                    /* mettre  jour les droits d'accs */
                    _chmod (destination, 1, descfic.ff_attrib);

                    puts (destination);
                }
                /* sinon dtruire le fichier mal recopi */
                else
                    unlink (destination);
            }
            else
                fprintf (stderr, "Impossible de mettre  jour le fichier %s\n",
                                                           destination);
        }
    }
    else if (findfirst (orig, &descfic, 0x8) == 0)
        fprintf (stderr, "Le fichier %s est un label\n", orig);
    else
        fprintf (stderr, "Fichier %s inexistant\n", orig);
}


/* creation de l'arborescence d'accs  un fichir */
mkarbor (fichier)
char *fichier;
{
    char *carchem;


    /* chercher le dernier / ou \ du chemin */
    carchem = fichier + strlen (fichier) - 1;

    while (--carchem != fichier && *carchem != '/' && *carchem != '\\');

    /* si trouv */
    if (carchem != fichier)
    {
        *carchem = 0;

        /* et que le rpertoire pre n'existe pas encore */
        if (access (fichier, 0) < 0)
        {
            /* continuer la gnration de l'arborescence */
            mkarbor (fichier);
            mkdir (fichier);
        }

        *carchem = '/';
    }
}