#include <stdio.h>
#include <dir.h>

#define szbuf      16184  /* taille du buffer article */
#define szbufprog  10163  /* szbufprog + dcalage < taille de crypte.exe */
#define decalage   2524
#define szmaxcle   255

#define octet unsigned char
#define int16 unsigned short
#define int32 unsigned long

#define EOL 10


main (narg, varg)
int narg;
char *varg [];
{
    octet bufprog [szbufprog];  /* buffer  valeurs pseudo alatoires */
    octet cle     [szmaxcle];   /* cl de cryptage */
    octet buffer  [szbuf];      /* buffer article */
    int16 posprog;              /* position dans bufprog */
    octet poscle;               /* position dans la cl */
    octet szcle;                /* taille effective de la cl */
    octet compteur;             /* valeur de 0  255 */
    octet posinit;              /* offset initial par rapport  bufprog */
    int32 posfic;               /* position dans le fichier  crypter */
    FILE  *fichier;             /* descripteur de fichier */
    int16 szlect;               /* nombre d'octets lus la dernire fois */
    int16 i;                    /* compteur */
    octet rep;                  /* confirmation de la cl */


    if (narg > 1)
    {
        /* fabrication du buffer pseudo alatoire */
        fichier = fopen (searchpath (*varg), "rb");

        if (fichier > 0)
        {
            if (fseek (fichier, decalage, 0) != 0)
                fputs ("Erreur 1 fabrication buffer alatoire\n", stderr);

            if (fread (bufprog, 1, szbufprog, fichier) != szbufprog)
                fputs ("Erreur 2 fabrication buffer alatoire\n", stderr);

            fclose (fichier);
        }
        else
        {
            fputs ("Erreur systme !\n", stderr);
            exit ();
        }

        /* saisie et prise en compte de la cl de cryptage */
        do
        {
            printf ("Introduire la cl de cryptage/dcryptage : ");
            if (gets (cle) != cle)
                fputs ("Erreur de lecture clavier\n", stderr);

            szcle = strlen (cle);

            printf ("Confirmez vous le cryptage avec la cl %c%s%c ? ",
                                                       0xB2, cle, 0xB2);

            rep = getche () | ' ';
            putchar (EOL);
        }
        while (rep == 'n');

        /* cette variable est destine  brouiller le dcryptage
           si une cl trs proche de la bonne est introduite */
        posinit = 0;

        for (i = 0; i < szcle; i++)
            posinit = posinit ^ (cle [i] * cle [i]);


        /* boucle de traitement des fichiers */
        do
        {
            varg++;
            narg--;

            fichier = fopen (*varg, "r+b");

            if (fichier > 0)
            {
                /* initialisation */
                posprog = posinit;
                poscle  = 0;
                posfic  = 0;
                compteur= 0;

                /* cryptage / dcryptage du fichier */
                szlect = fread (buffer, 1, szbuf, fichier);

                /* tanque non fin de fichier */
                while (szlect > 0)
                {
                    /* crypter les donnes */
                    for (i = 0; i < szlect; i++)
                    {
                        buffer [i] = buffer [i] ^ compteur++ ^ cle [poscle]
                                     ^ bufprog [posprog];

                        if (++poscle >= szcle)
                            poscle = 0;

                        if (++posprog >= szbufprog)
                            posprog = 0;
                    }

                    /* recopier la zone lue  */
                    fseek (fichier, posfic, 0);
                    if (fwrite (buffer, 1, szlect, fichier) != szlect)
                    {
                        fputs ("Erreur d'criture\n", stderr);

                        /* on arrtera la copie si erreur */
                        szlect = 0;
                    }
                    /* sinon */
                    else
                    {
                        /* lire la suite du fichier d'origine */
                        posfic = posfic + szbuf;
                        fseek (fichier, posfic, 0);
                        szlect = fread (buffer, 1, szbuf, fichier);
                    }
                }

                fclose (fichier);
            }
            else
                fprintf (stderr, "Fichier %s inexistant\n", *varg);
        }
        while (narg > 1);
    }
    else
        fputs ("Syntaxe : crypte <nom ou liste de fichier(s)>\n", stderr);
}