#include <stdio.h>
#include <dir.h>
#include <dos.h>

#define mnttab  "c:/config/mnttab"

static int  entete    = 0;  /* Pour n'crire qu'une fois la ligne d'entte */
static int  nbdisque  = 0;  /* Edition plus compacte si plus de 8 disques */
static char chemin [] = "?:/*.*"; /* chemin de recherche du label */


main (narg, varg)
int narg;
char *varg [];
{
    char lecteurs [26]; /* liste des disques slectionns */
    FILE *listdsk;      /* descripteur du fichier mnttab */
    int i;              /* positionnement sur un lecteur */


    /* si pas d'arguments, on utilise le disque courant et les disques fixes */
    if (narg == 1)
    {
        /* initialisation liste */
        for (i = 0; i < 26; i++)
            lecteurs [i] = 0;

        /* prise en compte du disque courant */
        lecteurs [getdisk ()] = 1;

        /* essai d'ouverture du fichier mnttab */
        listdsk = fopen (mnttab, "r");

        /* si ce fichier a pu tre ouvert */
        if (listdsk != 0)
        {
            /* rcupration de la liste des disque fixes */
            i = getc (listdsk);

            while (i != EOF)
            {
                /* pas de distinction entre majuscules et minuscules */
                i = i | 0x20;

                /* filtrage des caractres parasites */
                if ('a' <= i && i <= 'z')
                    lecteurs [(i & 0x1f) - 1] = 1;

                /* passage au disque suivant */
                i = getc (listdsk);
            }

            fclose (listdsk);
        }

        /* compter les disques slectionns */
        for (i = 0; i < 26; i++)
            if (lecteurs [i] != 0)
                nbdisque ++;

        /* on fait le df sur tous les disques slectionns */
        for (i = 0; i < 26; i++)
            if (lecteurs [i] != 0)
                lecdf (i + 1);
    }
    /* sinon */
    else
    {
        /* estimer le nombre de disques passs en paramtre */
        nbdisque = narg - 1;

        /* on fait le df sur tous les disques passs en paramtre */
        while (--narg > 0)
        {
            varg++;
            lecdf (**varg & 0x1f);
        }
    }
}


/* calcul de l'occupation d'un disque particulier */
lecdf (disque)
char disque;
{
    unsigned  place [4];
    long unsigned granule, total, libre, occupe;
    struct ffblk fich;


    /* rcupration de l'occupation du disque slectionn */
    getdfree (disque, &place);

    /* dition de l'entte si ncessaire */
    if (entete == 0)
    {
        puts ("         Total    octets utiliss   octets libres   label");
        entete = 1;
    }
    /* sinon saut de ligne */
    else if (nbdisque < 12)
        putchar ('\n');

    /* si on a pu accder au disque */
    if (place [3] != 0xFFFF)
    {
        /* calcul des valeurs  afficher (en octets) */
        granule = place [2] * place [3];
        total  = place [1] * granule;
        libre  = place [0] * granule;
        occupe = total - libre;

        /* dition des rsultats */
        *chemin = disque + '@';
        printf ("%c:", *chemin);

        if (nbdisque < 8)
            printf ("   %10lu    %10lu       %10lu\n  ", total, occupe, libre);

        /* dition des rsultats en Koctets */
        printf (" %10lu K  %10lu K     %10lu K",
                 total / 1024, occupe / 1024, libre / 1024);

        /* recherche du label */
        if (findfirst (chemin, &fich, FA_LABEL) == 0)
        {
            /* traitement particulier pour windows 95 */
            while (fich.ff_fsize != 0 && findnext (&fich) == 0);

            printf ("      %s", fich.ff_name);
        }

        putchar ('\n');
    }
    else
        printf ("Disque %c: inaccessible\n", disque + '@');
}