#include <stdio.h>

#define SZBUF  16


#define octet unsigned char
#define int16 unsigned int


static octet optd = 0;       /* slection de l'option -d */

static octet buf1 [SZBUF],   /* donnes courantes du fichier 1 */
             buf2 [SZBUF],   /* donnes courantes du fichier 2 */
             szbuf1, szbuf2; /* taille des donnes lues dans buf1 et buf2 */
static long  adresse;        /* adresse courante dans les fichiers */

static int16 maxdif = 10;    /* nombre maximum de diffrences conscutives */

FILE *fic1, *fic2;           /* descripteurs des fichiers */

static octet ecrentete = 1;  /* indique s'il faut diter l'entte */


main (narg, varg)
int narg;
char *varg [];
{
    int16 valopt;


    /* se positionner sur le premier argument */
    varg++;
    narg--;

    /* prise en compte du paramtre nombre de diffrence autorises */
    while (**varg == '-')
    {
        /* rcupration du nombre de diffrences passes en paramtre */
        valopt = - atol (*varg);

        /* si le paramtre n'tait pas une valeur numrique */
        if (valopt == 0)
        {
            /* option -c = on continue quelquesoit le nombre de diffrences */
            if (strcmp (*varg, "-c") == 0)
                maxdif = 0xFFFF;

            else if (strcmp (*varg, "-d") == 0)
                optd = 1;

            else
                narg = 0;     /* gnrera une erreur de syntaxe */
        }
        else
            maxdif = valopt;

        /* passer  l'argument suivant */
        varg++;
        narg--;
    }

    /* si nombre d'arguments correct */
    if (narg == 2)
    {
        /* prendre en compte l'option -d */
        if (optd)
        {
            /* rajouter le nom de fichier  l'argument 1 */
            *(varg [1] - 1) = '/';

            /* supprimer le / en trop si ncessaire */
            if (*(varg [1] - 2) == '/' || *(varg [1] - 2) == '\\')
            {
                strcpy (varg [1] - 1, varg [1]);
                varg [1] = varg [1] - 1;
            }
        }

        /* ouvrir les fichiers */
        fic1 = fopen (varg [0], "rb");

        if (fic1 <= 0)
        {
            fprintf (stderr, "%s : inexistant\n", varg [0]);
            exit ();
        }

        fic2 = fopen (varg [1], "rb");

        /* ouvrir les fichiers */
        fic1 = fopen (varg [0], "rb");

        if (fic1 <= 0)
        {
            fprintf (stderr, "%s : inexistant\n", varg [0]);
            exit ();
        }

        fic2 = fopen (varg [1], "rb");

        if (fic2 <= 0)
        {
            fprintf (stderr, "%s : inexistant\n", varg [1]);
            exit ();
        }

        /* comparer les fichiers */
        cmpfic ();

        /* fermer les fichiers */
        fclose (fic1);
        fclose (fic2);
    }
    /* message d'erreur de syntaxe */
    else
    {
        fprintf (stderr, "%s\n%s\n%s\n%s\n",
                 "Syntaxe : diffbin [-<nombre d'erreurs conscutives>]",
                 "                        [-c] <fichier 1> <fichier 2>",
                 "     ou : diffbin [-<nombre d'erreurs conscutives>]",
                 "                  [-c] -d <rpertoire> <nom de fichier>");
    }
}


/* comparaison des fichiers */
cmpfic ()
{
    int16 nbdif;   /* nombre de blocs de 16 octets diffrents conscutifs */
    octet i;       /* compteur */

    /* initialisation */
    adresse = 0;
    nbdif   = 0;

    /* rpter jusque fin d'un fichier ou trop de diffrences */
    do
    {
        /* lire 16 octets dans chacun des fichiers */
        szbuf1 = lect (fic1, buf1);
        szbuf2 = lect (fic2, buf2);

        /* comparer les taille des blocs lus avant la fin de fichier */
        if (szbuf1 != szbuf2)
            nbdif++;
        else
        {
            /* comparer les contenus des blocs lus */
            for (i = 0; i < szbuf1 && buf1 [i] == buf2 [i]; i++);

            /* prise en compte de la comparaison */
            if (i < szbuf1)
                nbdif++;
            else
                nbdif = 0;
        }

        /* si une diffrence a t trouve */
        if (nbdif > 0)
        {
            /* diter les 2 blocs */
            edite (buf1, szbuf1, '<');
            edite (buf2, szbuf2, '>');
        }

        /* mettre  jour l'adresse */
        adresse++;
    }
    while (szbuf1 == SZBUF && szbuf2 == SZBUF && nbdif < maxdif);

    /* diter si ncessaire la suite du fichier 1 */
    while (szbuf1 == SZBUF && nbdif < maxdif)
    {
        szbuf1 = lect (fic1, buf1);
        edite (buf1, szbuf1, '<');
        nbdif++;
        adresse++;
    }

    /* diter si ncessaire la suite du fichier 2 */
    while (szbuf2 == SZBUF && nbdif < maxdif)
    {
        szbuf2 = lect (fic2, buf2);
        edite (buf2, szbuf2, '>');
        nbdif++;
        adresse++;
    }

    /* message terminal ventuel */
    if (nbdif >= maxdif)
        printf ("Arrt de la comparaison\n");
}


/* lecture d'une ligne */
int lect (fichier, buffer)
FILE *fichier;
octet *buffer;
{
    int car;     /* dernier caractre lu */
    octet szlu;  /* taille du bloc lu */

    /* initialisation */
    szlu = 0;

    /* lecture et prise en compte des caractres */
    do
    {
        car = getc (fichier);
        buffer [szlu] = car;
    }
    while (car != EOF && ++szlu < SZBUF);

    /* retourner le nombre de caractres lus */
    return (szlu);
}


/* dition d'un buffer */
edite (buffer, szbuf, cardeb)
octet *buffer;
octet szbuf;
char  cardeb;
{
    octet posbuf;  /* position le buffer selectionn */

    /* on n'dite rien si le buffer est vide */
    if (szbuf > 0)
    {
        /* diter l'entte de la page si ncessaire */
        if (ecrentete == 1)
        {
            puts ("  Adresse   0  1  2  3  4  5  6  7  8  9  A  B  C  D  E  F");
            ecrentete = 0;
        }

        /* dition de l'entte de la ligne */
        printf ("%c %06X0:", cardeb, adresse);

        /* dition des donnes en hexa */
        for (posbuf = 0; posbuf < szbuf; posbuf++)
            printf (" %02X", buffer [posbuf]);

        /* saut du nombre adquat de blancs */
        while (posbuf++ < SZBUF + 1)
            printf ("   ");

        /* dition des donnes en clair */
        for (posbuf = 0; posbuf < szbuf; posbuf++)
            if (buffer [posbuf] >= ' ')
                putchar (buffer [posbuf]);
            else
                putchar ('.');

        /* passage  la ligne */
        putchar (10);
    }
}