/* Dtecte les lignes diffrentes entre 2 fichiers dont aucun
   ne comporte de rajout de lignes par rapport  l'autre */

#include <stdio.h>

#define MAXLIG 256

#define TAB   9
#define CTRZ 26

#define octet unsigned char

static octet optb = 0;             /* slection de l'option -b */
static octet optd = 0;             /* slection de l'option -d */
static octet optt = 0;             /* slection de l'option -t */

static char ligne1 [MAXLIG],       /* ligne courante du fichier 1 */
            ligne2 [MAXLIG];       /* ligne courante du fichier 2 */
static int  szlig1, szlig2;        /* taille des lignes */
static unsigned int numl;          /* numro de la ligne courante */
static unsigned int maxdiff;       /* nombre maximum de diffrences */

FILE *fic1, *fic2;                 /* descripteurs des fichiers */


main (narg, varg)
int narg;
char *varg [];
{
    /* se positionner sur le premier argument */
    varg++;
    narg--;

    /* initialisation */
    numl = 0;
    maxdiff = 20;

    /* rcupration des options -b et -t */
    while (**varg == '-')
    {
        if (strcmp (*varg, "-b") == 0)
            optb = 1;

        else if (strcmp (*varg, "-c") == 0)
            maxdiff = 0xFFFF;

        else if (strcmp (*varg, "-d") == 0)
            optd = 1;

        else if (strcmp (*varg, "-t") == 0)
            optt = 1;

        else if (atoi (*varg) < 0)
            maxdiff = -atoi (*varg);

        else
        {
            /* option inconnue */
            psyntaxe ();
            exit ();
        }

        /* passage  l'argument suivant */
        varg++;
        narg--;
    }

    /* si nombre d'arguments correct */
    if (narg == 2)
    {
        /* prendre en compte l'option -d */
        if (optd)
        {
            /* rajouter le nom de fichier  l'argument 1 */
            *(varg [1] - 1) = '/';

            /* supprimer le / en trop si ncessaire */
            if (*(varg [1] - 2) == '/' || *(varg [1] - 2) == '\\')
            {
                strcpy (varg [1] - 1, varg [1]);
                varg [1] = varg [1] - 1;
            }
        }

        /* ouvrir les fichiers */
        fic1 = fopen (varg [0], "rb");

        if (fic1 <= 0)
        {
            fprintf (stderr, "%s : inexistant\n", varg [0]);
            exit ();
        }

        fic2 = fopen (varg [1], "rb");

        if (fic2 <= 0)
        {
            fprintf (stderr, "%s : inexistant\n", varg [1]);
            exit ();
        }

        /* comparer les fichiers */
        cmpfic ();
    }
    /* message d'erreur sur le nombre d'arguments */
    else
        psyntaxe ();
}


/* dition de la syntaxe de la commande */
psyntaxe ()
{
    fputs ("Syntaxe : diffl [-b] [-t] [-c] <fichier 1> <fichier 2>\n", stderr);
    fputs ("     ou : diffl [-b] [-t] [-c] -d <rpertoire> <nom de fichier>\n", stderr);
}


/* comparaison des fichiers */
cmpfic ()
{
    unsigned int nbdif; /* comptabilise le nombre de diffrences conscutives */

    /* lire la premire ligne des 2 fichiers */
    szlig1 = lect (fic1, ligne1);
    szlig2 = lect (fic2, ligne2);

    /* tantque non fin de fichiers */
    while (szlig1 >= 0 || szlig2 >= 0)
    {
        /* mettre  jour le numro de ligne */
        numl++;

        /* comparer les lignes */
        nbdif = cmplig ();

        /* si une diffrence a t trouve */
        if (nbdif > 0)
        {
            /* prciser la ligne o se trouve la diffrence */
            printf ("Ligne :%5u\n", numl);

            do
            {
                /* diter les diffrences */
                affligne (ligne1, szlig1, '<');
                affligne (ligne2, szlig2, '>');

                /* passer  la ligne suivante de chaque fichier */
                numl++;
                szlig1 = lect (fic1, ligne1);
                szlig2 = lect (fic2, ligne2);
            }
            while (cmplig () > 0 && nbdif++ < maxdiff);

            /* termin si trop de diffrences */
            if (nbdif > maxdiff)
            {
                printf ("Arrt de la comparaison\n");
                exit ();
            }
        }

        /* passer  la ligne suivante de chaque fichier */
        szlig1 = lect (fic1, ligne1);
        szlig2 = lect (fic2, ligne2);
    }
}


/* lecture d'une ligne */
int lect (fichier, ligne)
FILE *fichier;
char *ligne;
{
    int car;    /* dernier caractre lu */
    int poslig; /* position dans la ligne */


    /* lire le premier caractre de la ligne */
    car = getc (fichier);

    /* si non fin de fichier */
    if (car == EOF)
        return (-1);
    else
    {
        /* on est en dbut de ligne */
        poslig = 0;

        /* tantque non fin de ligne */
        while (car != '\n' && car != EOF)
        {
            if (poslig < MAXLIG)
            {
                /* mmoriser le dernier caractre lu */
                if (car != TAB || optt == 1)
                    ligne [poslig++] = car;

                /* si pas d'option -t remplacer les tabulations par des blancs */
                else
                    do
                        ligne [poslig++] = ' ';
                    while (poslig % 8 != 0 && poslig < MAXLIG);
            }

            /* lire le caractre suivant */
            car = getc (fichier);
        }

        /* retourner la taille de la ligne lue sans le CR ventuel */
        if (ligne [poslig - 1] != '\r')
            return (poslig);
        else
            return (poslig - 1);
    }
}


/* comparaison de la ligne courante des 2 fichiers */
int cmplig ()
{
    int poslig1, poslig2;  /* position courante dans chaque ligne */

    /* positionnement au dbut de chaque ligne */
    poslig1 = 0;
    poslig2 = 0;

    while (poslig1 < szlig1 && poslig2 < szlig2)
    {
        /* si option -b, on saute les blancs */
        if (optb == 1)
        {
            while (ligne1 [poslig1] == ' ' && poslig1 < szlig1)
                poslig1++;

            while (ligne2 [poslig2] == ' ' && poslig2 < szlig2)
                poslig2++;
        }

        /* termin si diffrence trouve */
        if (ligne1 [poslig1] != ligne2 [poslig2])
            return (1);

        /* passage aux caractres suivants */
        poslig1++;
        poslig2++;
    }

    /* controle suplmentaire en fin de ligne */
    if (poslig1 < szlig1 || poslig2 < szlig2)
        return (1);
    else
        return (0);
}


/* dition de la ligne courante passe en paramtre */
affligne (ligne, szlig, sens)
char *ligne;
int  szlig;
char sens;
{
    int poslig;  /* position dans la ligne  diter */


    putchar (sens);
    putchar (' ');

    for (poslig = 0; poslig < szlig; poslig++)
    {
        if (ligne [poslig] != CTRZ)
            putchar (ligne [poslig]);
        else
        {
            putchar ('^');
            putchar ('Z');
        }
    }

    putchar ('\n');
}
