#include <stdio.h>
#include <io.h>
#include <dir.h>

#define FINDOC    12
#define SZPAGE    24
#define SZMAXNOM   8

static FILE  *ficin;
static int   decalage;
static int   optc = 0;


/* prototypage */
char *chemin (char *arg0);


/* programme principal */
main (narg, varg)
int narg;
char *varg [];
{
    ficin = fopen (chemin (*varg), "rb");

    if (ficin == 0)
        fprintf (stderr, "Fichier d'aide en ligne manquant\n");
    else
    {
        if (--narg > 0 && varg [1][0] == '-')
        {
            if (varg [1][1] != 'c' || varg [1][2] != 0)
            {
                fprintf (stderr, "Option %s incorrecte", varg [1]);
                psyntaxe ();
                narg = 1;
            }
            else
                optc = 1;

            varg++;
            narg--;
        }

        if (narg == 1)
        {
            decalage = 1;
            recherche (varg [1]);
        }
        else if (narg > 1)
        {
            fprintf (stderr, "Nombre d'arguments incorrect");
            psyntaxe ();
        }

        affdoc ();
    }
}


char *chemin (char *arg0)
{
    char *chaine;

    chaine = arg0 + (strlen (arg0) - 3);

    strcpy (chaine, "HLP");

    if (access (arg0, 0) == 0)
        return (arg0);
    else
    {
        while (*chaine != '\\' && chaine > arg0)
            chaine--;

        return (searchpath (chaine + 1));
    }
}


psyntaxe ()
{
    int car;


    recherche ("docunix");

    decalage = 5;
    optc = 1;

    do
        car = getc (ficin);
    while (car != '\n' && car != EOF);
}


int recherche (char *commande)
{
    char car, *carcom;
    int  i;


    carcom = commande;

    while (*carcom != 0)
    {
        *carcom = toupper (*carcom);
        carcom++;
    }

    rewind (ficin);

    car = getc (ficin);

    do
    {
        if (car == FINDOC)
        {
            carcom = commande;
            car = getc (ficin);
            i = 0;

            while (car == *carcom && i++ < SZMAXNOM)
            {
                car = getc (ficin);
                carcom++;
            }

            if ((*carcom == 0 && car == ' ') || i == SZMAXNOM)
            {
                if (atoi (commande) == 0)
                {
                    decalage = i + 3;

                    while (car != ' ')
                    {
                        car = getc (ficin);
                        decalage ++;
                    }

                    fseek (ficin, 2 - decalage, 1);
                }
                else
                    decalage = 0;

                return (1);
            }
        }

        car = getc (ficin);
    }
    while (car != EOF);

    printf ("Commande %s non trouve\n", commande);

    return (0);
}


affdoc ()
{
    int car;
    int nblig;
    int i;
    char commande [80];


    do
    {
        putchar ('\n');

        car = getc (ficin);
        nblig = 0;

        while (car != FINDOC && car != EOF)
        {
            if (car == '\n')
            {
                do
                {
                    putchar (car);
                    nblig++;

                    if (nblig == SZPAGE && optc == 0)
                    {
                        printf ("Appuyer sur une touche pour continuer  ");
                        getch ();
                        printf ("\r[K");

                        nblig = 2;    /* pour voir la fin de la page prcdente */
                    }

                    car = getc (ficin);
                }
                while (car == '\n');

                if (car != FINDOC && car != EOF)
                {
                    for (i = 0; i < decalage; i++)
                        putchar (' ');

                    putchar (car);
                    car = getc (ficin);
                }
            }
            else
            {
                putchar (car);
                car = getc (ficin);
            }
        }

        if (optc == 0)
        {
            if (nblig < SZPAGE)
                putchar ('\n');

            if (decalage == 0)
                printf ("Votre Choix ?  ");
            else
                printf ("Taper un nom de commande ou <RETURN> pour sortir  ");

            *commande = 0;

            gets (commande);

            if (*commande)
            {
                if (strcmp (commande, "0") == 0)
                {
                    /* cas particulier, retour au menu principal */
                    rewind (ficin);
                    decalage = 0;
                }
                else
                {
                    /* cas gnral */
                    decalage = 1;
                    recherche (commande);
                }
            }
        }
    }
    while (optc == 0 && *commande != 0);
}