#include <stdio.h>
#include <mem.h>

#define szmaxlig  1024             /* taille maximale des lignes */
#define szmaxexpr  255             /* taille maximale des expressions */
#define nbascii    256             /* nombre de caractres ASCII distincts */

#define EOL  10
#define CR   13

#define OU   '!'                   /* choix entre plusieurs sous chaines */

#define octet unsigned char


static octet ligne [szmaxlig];     /* ligne  analyser */
static int szlig;                  /* taille de la ligne */

static octet optn = 0, optv = 0;   /* options de la commande */
static octet optf = 0;             /* recherche sur plusieurs fichiers */
static octet optdeb = 0;           /* recherche seulement en dbut de ligne */
static octet optfin = 0;           /* recherche seulement en fin de ligne */

static octet expr [szmaxexpr];     /* expression  rechercher */
static octet szexpr;               /* taille de l'expression  rechercher */
static octet nbcarmin;             /* taille min chaine contenant expression */
static octet listecar [nbascii];   /* liste des caractres selectionns */
static octet posmot   [32];        /* position des mots d'une sous expression */
static octet nbmots;               /* nombre de mots d'une sous expression */

static int car;

/* programme principal */
main (narg, varg)
int narg;
char *varg [];
{
    int poslig;             /* position dans la ligne */
    unsigned int numlig;    /* numro de la ligne courante */


    /* se positionner sur le premier argument */
    varg++;
    narg--;

    /* rcuprer les options */
    while (**varg == '-')
    {
        /* option -n (dition des numros de ligne) */
        if (strcmp (*varg, "-n") == 0)
            optn = 1;

        /* option -v (dition si expression non trouve) */
        else if (strcmp (*varg, "-v") == 0)
            optv = 1;

        /* option incorrecte */
        else
            psyntaxe ();

        /* passer  l'argument suivant */
        varg++;
        narg--;
    }

    /* analyser l'expression  rechercher */
    if (narg-- > 0)
    {
        /* pranalyse de l'expression */
        preanalyse (*varg);

        /* calculer la taille minimale d'une chaine contenant l'expression */
        calcnbcarmin ();

        /* on se positionne sur l'argument suivant */
        varg++;
    }
    else
        psyntaxe ();

    /* plusieurs fichiers  analyser ? */
    if (narg > 1)
        optf = 1;

    /* recherche sur les diffrents fichiers */
    do
    {
        /* ouvrir le fichier en lecture */
        if (narg > 0 && freopen (*varg, "rb", stdin) == 0)
            fprintf (stderr, "Fichier %s inexistant\n", *varg);

        /* initialisation */
        numlig = 0;
        car = getchar ();

        /* tantque non fin de fichier */
        while (car != EOF)
        {
            /* lire une ligne */
            numlig++;
            szlig = 0;

            while (car != EOL && car != EOF)
            {
                /* mmoriser le caractre lu */
                if (szlig < szmaxlig)
                    ligne [szlig++] = car;

                /* lire le caractre suivant */
                car = getchar ();
            }

            /* suppression du CR ventuel en fin de ligne */
            if (ligne [szlig - 1] == CR)
                szlig = szlig - 1;

            /* test de prsence de l'expression et dition ventuelle */
            if (tstexpr (0, 0, optdeb) != optv)
            {
                if (optf == 1)
                    printf ("%s:", *varg);

                if (optn == 1)
                    printf ("%u:", numlig);

                for (poslig = 0; poslig < szlig; poslig++)
                    putchar (ligne [poslig]);

                putchar (EOL);
            }

            /* sauter le caractre de passage  la ligne */
            car = getchar ();
        }

        /* passer au fichier suivant */
        varg++;
    }
    while (--narg > 0);
}

/* Rappel de la syntaxe de la commande et arrt */
psyntaxe ()
{
    errfatale (
"Syntaxe : egrep [-n][-v] <expression  rechercher> [<liste de fichiers>]");
}



/* dition d'une erreur fatale et arrt du programme */
errfatale (chaine)
char chaine [];
{
    while (*chaine != 0)
    {
        if (*chaine == '|')
            putc (OU, stderr);
        else
            putc (*chaine, stderr);

        chaine ++;
    }

    putc (EOL, stderr);

    exit ();
}

/* Pranalyse de l'expression  rechercher */
preanalyse (char *exporig)
{
    octet valcar, i;


    /* initialisation */
    szexpr = 0;

    /* recherche seulement en dbut de ligne ? */
    if (*exporig == '^')
    {
        optdeb = 1;
        exporig++;
    }

    /* analyse des caractres de l'expression */
    while (*exporig != 0)
    {
        switch (*exporig)
        {
            /* recherche seulement en fin de ligne ? */
            case '$' : if (*(exporig + 1) == 0)
                           optfin = 1;
                       else
                           expr [szexpr++] = '$';

                       break;

            /* traitement des '\' */
            case '\\': exporig++;

                       switch (*exporig)
                       {
                           /* caractre exprim en hexa */
                           case 'x' : for (i = 0; i < 2; i++)
/* recentrage  gauche */
{
    exporig++;

    valcar = *exporig - '0';

    if (valcar > 16)
        valcar -= 7;

    if ((valcar & 0xD0) != 0)
        errfatale ("Valeur hexadcimale incorrecte");

    expr [szexpr] = (expr [szexpr] << 4) | valcar;
}
/* fin du recentrage  gauche */
                                      szexpr++;
                                      break;

                           /* caractre CR */
                           case 'r' : expr [szexpr++] = CR;
                                      break;

                           default  : /* le '\' est conserve pour la suite */
                                      exporig--;
                                      expr [szexpr++] = '\\';
                       }

                       break;

            /* cas gnral */
            default  : expr [szexpr++] = *exporig;
        }

        /* analyser le caractre suivant */
        exporig++;
    }
}

/* calcul de la taille minimale d'une chaine contenant l'expression */
calcnbcarmin ()
{
    octet i;
    octet szsousexp, minsousexp, sepsousexp;


    nbcarmin = 0;

    i = 0;

    while (i < szexpr)
    {
        if (expr [i] == '!')
        {
            i++;

            if (expr [i] == '(')
                errfatale (
                     "La ngation d'une liste de mots n'est pas autorise");

            else if (expr [i] == '.')
                errfatale (
                     "La ngation du mtacaractre '.' n'est pas autorise");
        }

        if (expr [i] == '(')
        {
            minsousexp = szmaxexpr;
            szsousexp  = 0;
            sepsousexp = 0;

            do
            {
                if (expr [i] == OU)
                {
                    if (szsousexp < minsousexp)
                        minsousexp = szsousexp;

                    szsousexp  = 0;
                    sepsousexp = 1;
                }
                else
                {
                    if (expr [i] == '\\')
                        i++;

                    szsousexp++;
                }

                if (++i >= szexpr)
                {
                    errfatale (
            "Erreur de syntaxe dans l'expression regulire : ')' manquant");
                }
            }
            while (expr [i] != ')');

            if (sepsousexp == 0)
                errfatale (
            "Absence de mtacaractre | dans une liste de sous chaines");

            i++;

            if (i < szexpr)
            {
                switch (expr [i])
                {
                    case '?' :
                    case '*' : i++;
                               break;

                    case '+' : i++;
                    default  : nbcarmin = nbcarmin + minsousexp;
                }
            }
        }
        else
        {
            if (expr [i] == '[')
            {
                nbcarmin++;

                do
                {
                    if (expr [i] == '\\')
                        i++;

                    if (++i >= szexpr)
                    {
                        errfatale (
            "Erreur de syntaxe dans l'expression regulire : ']' manquant");
                    }
                }
                while (expr [i] != ']');
            }
            else
            {
                if (expr [i] == '\\')
                    i++;

                nbcarmin++;
            }

            i++;

            if (i < szexpr)
            {
                switch (expr [i])
                {
                    case '?' :
                    case '*' : nbcarmin --;
                    case '+' : i++;
                }
            }
        }
    }
}

/* test de la prsence de l'expression  rechercher dans la ligne */
int tstexpr (debrech, debexpr, opdeb)
int debrech;   /* position dans la ligne o commence la recherche */
int debexpr;   /* position dans l'expression o commence l'analyse */
octet opdeb;   /* indique si l'expression doit commencer en dbut de ligne */
{
    int   finrech;
    octet contin;
    int   i, j;
    octet carpred;           /* caractre prcdent */
    int   numcar;            /* numro de caractre dans listecar */
    octet negation;


    /* cas particulier : chaine vide */
    if (szexpr == 0 && (szlig == 0 || optdeb == 0 || optfin == 0))
        return (1);

    /* initialisation recherche en dbut de ligne ou sur toute la ligne */
    if (opdeb == 0)
        finrech = debrech + szlig - nbcarmin;
    else
        finrech = debrech;

    /* recherche de l'expression dans la ligne */
    while (debrech <= finrech)
    {
        /* initialisation */
        contin = 1;
        i = debrech++;

        /* pour tous les caractres de l'expression */
        j = debexpr;

        while (j < szexpr && contin == 1)
        {
            /* termin si la ligne est trop courte */
            if (i >= szlig)
                return (0);

            /* mmorisation de la ngation */
            if (expr [j] == '!')
            {
                negation = 1;
                j++;
            }
            else
                negation = 0;

            /* si n'importe quel caractre est accept en position courante */
            if (expr [j] == '.')
            {
                j++;

                switch (expr [j])
                {
                    case '?' : j++;
                               if (tstexpr (i, j, 1) == 1)
                                   return (1);
                               else
                                   i++;

                               break;

                    case '+' : i++;
                    case '*' : j++;
                               return (tstexpr (i, j, 0));

                    default  : i++;
                }
            }

            /* sinon si choix dans une liste de caractres */
            else if (expr [j] == '[')
            {
                j++;
                carpred = 0;

                memset (listecar, negation, nbascii);

                while (expr [j] != ']')
                {
                    /* intervalle ? */
                    if (expr [j] == '-')
                    {
                        j++;

                        numcar = expr [j++];

                        while (numcar > carpred)
                            listecar [numcar--] = 1 ^ negation;
                    }
                    /* caractre simple */
                    else
                    {
                        if (expr [j] == '\\')
                            j++;

                        carpred = expr [j++];
                        listecar [carpred] = 1 ^ negation;
                    }
                }

                j++;

                /* si le caractre courant dans la ligne
                   fait partie de la liste selectionne */
                if (listecar [ligne [i]] == 1)
                {
                    switch (expr [j])
                    {
                        case '+' :
                        case '*' : while (listecar [ligne [++i]] == 1);
                                   j++;
                                   break;

                        case '?' : j++;
                        default  : i++;
                    }
                }
                /* sinon, le caractre n'est pas celui recherch */
                else
                {
                    switch (expr [j])
                    {
                        case '?' :
                        case '*' : j++;
                                   break;

                        default  : contin = 0;
                    }
                }
            }

            /* sinon si choix entre plusieurs mots */
            else if (expr [j] == '(')
            {
                nbmots = 0;
                posmot [nbmots++] = ++j;

                while (expr [j] != ')')
                {
                    if (expr [j] == OU)
                        posmot [nbmots++] = ++j;

                    else if (expr [j++] == '\\')
                            j++;
                }

                j++;

                /* si l'un des mots figure dans la ligne */
                if (testmot (&i) == 1)
                {
                    switch (expr [j])
                    {
                        case '+' :
                        case '*' : while (testmot (&i) == 1);
                        case '?' : j++;
                    }
                }
                /* sinon, aucun mot n'a t trouv */
                else
                {
                    switch (expr [j])
                    {
                        case '?' :
                        case '*' : j++;
                                   break;

                        default  : contin = 0;
                    }
                }
            }

            /* sinon (cas gnral) */
            else
            {
                if (expr [j] == '\\')
                    j++;

                /* si le caractre courant dans la ligne
                   coincide avec celui de l'expression */
                if ((ligne [i] == expr [j]) && (negation == 0))
                {
                    switch (expr [j + 1])
                    {
                        case '+' :
                        case '*' : while (ligne [++i] == expr [j]);
                                   j = j + 2;
                                   break;

                        case '?' : j++;
                        default  : i++;
                                   j++;
                    }
                }
                /* sinon si le caractre est diffrent du caractre interdit */
                else if ((negation != 0) && (ligne [i] != expr [j]))
                {
                    switch (expr [j + 1])
                    {
                        case '+' :
                        case '*' : while (ligne [++i] != expr [j] && i < szlig);
                                   j = j + 2;
                                   break;

                        case '?' : j++;
                        default  : i++;
                                   j++;
                    }
                }
                /* sinon, le caractre n'est pas celui recherch */
                else
                {
                    j++;

                    switch (expr [j])
                    {
                        case '?' :
                        case '*' : j++;
                                   break;

                        default  : contin = 0;
                    }
                }
            }
        }

        /* si expression trouve */
        if (contin == 1)
            /* controle si position par rapport  la fin de ligne correcte */
            if (optfin == 0 || i == szlig)
                return (1);
    }

    /* l'expression n'a pas t trouve */
    return (0);
}

/* test de la prsence d'un mot de la liste dans la ligne */
int testmot (poscur)
int *poscur;    /* position dans la ligne o commence la recherche */
{
    int   i, j;
    octet numot;
    octet trouve;


    for (numot = 0; numot < nbmots; numot++)
    {
        i = *poscur;
        j = posmot [numot];

        trouve = 1;

        while (trouve == 1 && expr [j] != OU && expr [j] != ')')
        {
            if (expr [j] == '\\')
                j++;

            if (ligne [i++] != expr [j++])
                trouve = 0;
        }

        if (trouve == 1)
        {
            *poscur = i;
            return (1);
        }
    }

    return (0);
}