#include <stdio.h>
#include <dos.h>

#define mois_ete       3  /* mois de l'anne pour passage  l'heure d't   */
#define mois_hiver    10  /* mois de l'anne pour passage  l'heure d'hiver */
#define jourmin_ete   25  /* jour du mois aprs lequel on peut passer  l'heure d't   */
#define jourmin_hiver 25  /* jour du mois aprs lequel on peut passer  l'heure d'hiver */

#define dirconf     "c:/config"        /* fichier mmorisant si on est */
#define fichier     dirconf"/saison"   /*  l'heure d't ou d'hiver   */


static int heure_ete;
static FILE *adrfic;


main ()
{
    struct date jour;         /* date et heures courantes */
    struct time heure;
    int mois, an;             /* utilis pour calculer la date */
    int jsem_deb;             /* de changement d'heure */
    char heure_memo;          /* type d'heure mmorise dans un fichier */


    /* rcuprer la date courante */
    getdate (&jour);
    mois = jour.da_mon;
    an   = jour.da_year;

    /* dtrminer si heure d't ou d'hiver */
    if (mois < mois_ete || mois > mois_hiver)
        heure_ete = 0;

    else if (mois_ete < mois && mois < mois_hiver)
        heure_ete = 1;
    else
    {
        mois = mois - 2;

        if (mois <= 0)
        {
            mois = mois + 12;
            an = an - 1;
        }

        jsem_deb = 7 - ((6 + (mois * 44 / 17) + (an * 5 / 4)) % 7);
        /* quivalent  : 7 - ((6 + (mois * 2.59) + (an * 1.25)) % 7)
           sans utiliser l'aritmtique flotante qui augmenterait
           fortement la taille de l'excutable */

        if (jour.da_mon == mois_ete)
        {
            while (jsem_deb < jourmin_ete)
                jsem_deb = jsem_deb + 7;

            if (jour.da_day < jsem_deb)
                heure_ete = 0;
            else
                heure_ete = 1;
        }
        else
        {
            while (jsem_deb < jourmin_hiver)
                jsem_deb = jsem_deb + 7;

            if (jour.da_day < jsem_deb)
                heure_ete = 1;
            else
                heure_ete = 0;
        }
    }


    /* l'heure d't ou d'hiver est elle mmorise ? */
    if (access (fichier, 0) == 0)
    {
        adrfic = fopen (fichier, "r");

        if (adrfic != 0)
        {
            heure_memo = getc (adrfic);
            fclose (adrfic);
        }

        /* si le type d'heure a t mmorise correctement */
        if (heure_memo == 'h' || heure_memo == 'e')
        {
            if (heure_memo == 'h' && heure_ete == 1)
            {
                gettime (&heure);

                /* tentative de passage  l'heure d't */
                if (heure.ti_hour < 23)
                {
                    heure.ti_hour ++;
                    settime (&heure);

                    puts ("Passage  l'heure d't");
                    memorise ();
                }
            }
            else if (heure_memo == 'e' && heure_ete == 0)
            {
                gettime (&heure);

                /* tentative de passage  l'heure d'hiver ? */
                if (heure.ti_hour > 0)
                {
                    heure.ti_hour --;
                    settime (&heure);

                    puts ("Passage  l'heure d'hiver");
                    memorise ();
                }
            }
        }
        else
            memorise ();   /* sinon on mmorise le type d'heure */
    }
    else
    {
        /* on cre juste le fichier qui mmorise de type d'heure */
        mkdir (dirconf);
        memorise ();
    }
}


/* mmorise dans un fichier si l'on est  l'heure d'hiver ou d't */
memorise ()
{
    adrfic = fopen (fichier, "w");

    if (adrfic != 0)
    {
        if (heure_ete == 0)
            putc ('h', adrfic);
        else
            putc ('e', adrfic);

        fclose (adrfic);
    }
}