#include <stdio.h>

#define szmaxlig 1024              /* taille maximale des lignes */
#define szmaxchn  255              /* taille maximale des chaines */

#define EOL  10
#define CR   13

#define octet unsigned char


static octet ligne [szmaxlig];     /* ligne  analyser */
static int   szlig;                /* taille de la ligne */

static octet optn = 0, optv = 0;   /* options de la commande */
static octet optf = 0;             /* recherche sur plusieurs fichiers */
static octet optdeb = 0;           /* recherche seulement en dbut de ligne */
static octet optfin = 0;           /* recherche seulement en fin de ligne */

static octet chaine [szmaxchn];    /* chaine  rechercher */
static octet szchn;                /* taille de la chaine  rechercher */

static int car;

/* programme principal */
main (narg, varg)
int narg;
char *varg [];
{
    int poslig;             /* position dans la ligne */
    unsigned int numlig;    /* numro de la ligne courante */


    /* se positionner sur le premier argument */
    varg++;
    narg--;

    /* rcuprer les options */
    while (**varg == '-')
    {
        /* option -n (dition des numros de ligne) */
        if (strcmp (*varg, "-n") == 0)
            optn = 1;

        /* option -v (dition si chaine de caractres non trouve) */
        else if (strcmp (*varg, "-v") == 0)
            optv = 1;

        /* option incorrecte */
        else
            psyntaxe ();

        /* passer  l'argument suivant */
        varg++;
        narg--;
    }

    /* faire une pranalyse de la chaine de caractres  rechercher */
    if (narg-- > 0)
    {
        preanalyse (*varg);

        varg++;
    }
    else
        psyntaxe ();

    /* plusieurs fichiers  analyser ? */
    if (narg > 1)
        optf = 1;

    /* recherche sur les diffrents fichiers */
    do
    {
        /* ouvrir le fichier en lecture */
        if (narg > 0 && freopen (*varg, "rb", stdin) == 0)
            fprintf (stderr, "Fichier %s inexistant\n", *varg);

        /* initialisation */
        numlig = 0;
        car = getchar ();

        /* tantque non fin de fichier */
        while (car != EOF)
        {
            /* lire une ligne */
            numlig++;
            szlig = 0;

            while (car != EOL && car != EOF)
            {
                /* mmoriser le caractre lu */
                if (szlig < szmaxlig)
                    ligne [szlig++] = car;

                /* lire le caractre suivant */
                car = getchar ();
            }

            /* suppression du CR ventuel en fin de ligne */
            if (ligne [szlig - 1] == CR)
                szlig = szlig - 1;

            /* test de presence de l'expression et edition eventuelle */
            if (tstchn () != optv)
            {
                if (optf == 1)
                    printf ("%s:", *varg);

                if (optn == 1)
                    printf ("%u:", numlig);

                for (poslig = 0; poslig < szlig; poslig++)
                    putchar (ligne [poslig]);

                putchar (EOL);
            }

            /* sauter le caractre de passage  la ligne */
            car = getchar ();
        }

        /* passer au fichier suivant */
        varg++;
    }
    while (--narg > 0);
}

/* Rappel de la syntaxe de la commande et arrt */
psyntaxe ()
{
    fprintf (stderr, "Syntaxe : %s [<liste de fichiers>]\n",
                     "fgrep [-n][-v] <chaine  rechercher>");
    exit ();
}



/* Pranalyse de la chaine  rechercher */
preanalyse (char *chainorig)
{
    octet valcar, i;

    /* initialisation */
    szchn = 0;

    /* recherche seulement en dbut de ligne ? */
    if (*chainorig == '^')
    {
        optdeb = 1;
        chainorig++;
    }

    /* analyse des caractres de la chaine */
    while (*chainorig != 0)
    {
        switch (*chainorig)
        {
            /* recherche seulement en fin de ligne ? */
            case '$' : if (*(chainorig + 1) == 0)
                           optfin = 1;
                       else
                           chaine [szchn++] = '$';

                       break;

            /* traitement des '\' */
            case '\\': chainorig++;

                       switch (*chainorig)
                       {
                           /* caractre exprim en hexa */
                           case 'x' : for (i = 0; i < 2; i++)
/* recentrage  gauche */
{
    chainorig++;

    valcar = *chainorig - '0';

    if (valcar > 16)
        valcar -= 7;

    if ((valcar & 0xD0) != 0)
    {
        fprintf (stderr, "Valeur hexadcimale incorrecte\n");

        exit ();
    }

    chaine [szchn] = (chaine [szchn] << 4) | valcar;
}
/* fin du recentrage  gauche */
                                      szchn++;
                                      break;

                           /* caractre CR */
                           case 'r' : chaine [szchn++] = CR;
                                      break;

                           default  : chaine [szchn++] = *chainorig;
                       }

                       break;

            /* cas gnral */
            default  : chaine [szchn++] = *chainorig;
        }

        /* analyser le caractre suivant */
        chainorig++;
    }
}

/* test de la prsence de la chaine  rechercher dans la ligne */
int tstchn ()
{
    int rechdeb, rechfin;  /* dbut et fin de la zone de recherche */
    int i, j;              /* position dans la ligne et dans la chaine */


    /* termine si chaine plus longue que la ligne */
    if (szchn > szlig)
        return (0);

    /* cas particulier : chaine vide */
    else if (szchn == 0 && (szlig == 0 || optdeb == 0 || optfin == 0))
        return (1);

    /* initialisation de la fin de la zone de recherche */
    if (optdeb == 0)
        rechfin =  szlig - szchn;
    else
        rechfin = 0;

    /* initialisation du dbut de la zone de recherche */
    if (optfin == 0)
        rechdeb = 0;
    else
        rechdeb = szlig - szchn;

    /* recherche de la chaine dans la ligne */
    for (i = rechdeb; i <= rechfin; i++)
    {
        /* si le premier caractre est bon */
        if (ligne [i] == chaine [0])
        {
            j = 1;

            /* on compare les caractres suivants */
            while ((ligne [i + j] == chaine [j]) && (j < szchn))
                j++;

            /* termin s'ils sont tous bons */
            if (j == szchn)
                return (1);
        }
    }

    /* la chaine n'a pas t trouve */
    return (0);
}
