/*
    Variables du programme vi.c
*/

#include <stdio.h>
#include <alloc.h>
#include <mem.h>
#include <stdlib.h>
#include <io.h>
#include <bios.h>
#include "carspe.h"
#include "accent.h"

#define globales

#define octet unsigned char
#define int16 unsigned short


/* noms des fichiers utiliss */
static octet chemfich [szchemin];
static octet *nomfich;
static octet *nomedit;
static octet prefixe  [szchemin];
static octet suffixe  [szsuffixe];
static octet sufsauve [szsuffixe];
#ifndef mxvi
static octet ficsave  [szchemin];
static octet fictmp   [szchemin];
#else
static octet fictrav  [szchemin];
static octet ficsuf   [szchemin];
#endif

/* positionnement dans le fichier charg */
static intxx numlig;           /* numro de ligne courant */
static octet lignecurseur, colcurseur;  /* position du curseur */
static octet coldeblig;        /* premire colonne de la zone texte */
static int16 decald = 0;       /* dcalage au del de la colonne 80 */

/* sauvegarde du positionnement */
static octet savelig, savecol; /* sauvegarde de la position du curseur */
static intxx savenuml;         /* sauvegarde du numro de ligne */
static char  ligneref, colonref;  /* position du curseur */

/* mode courant de fonctionnement de l'diteur */
static octet mode;
static octet reaffmode;        /* 1 = il faudra rafficher le mode */
static octet reaffpage;        /* 1 = il faudra rafficher la page */
static intxx maxinsert;        /* nombre maximal de caractres insrables */

/* indicateurs d'oprations en attente */
static octet resyncbuf;        /* appel  synchrobuf utile ? */
static octet misajour;         /* faudra il mettre  jour le fichier ? */
#ifndef mxvi
static octet majtmp;           /* mise  jour du fichier crash ? */
static long  heuremajsuiv;     /* heure prochaine mise  jour crash */
#endif
static octet termine;          /* fin de traitement du fichier ? */
static octet supbip;           /* suppression du bip si descente fin fichier */
static octet lignechangee;     /* faudra t'il rafficher le bas de page ? */
static int16 apresfinlig;

/* interface avec le clavier */
static int   car;              /* caractre saisi au clavier */
static int   carpred;          /* caractre prcdent saisi au clavier */
static int   carsuiv;          /* caractre suivant saisi au clavier */
static int   caracc;           /* caractre accentu issu de testacc... */
static int   carx;             /* caractre hexa issu de testx et testx2 */
static octet suivantlu = 0;    /* indique si l'on a lu le caractre suivant */
static intxx nbfois;           /* coefficient multiplicateur d'une commande */

/* options de fonctionnement */
static octet optnuml    = 0;
static octet optescape  = 0;
static octet optindente = 1;
static octet optregul   = 0;
static octet optaccent  = 1;
static octet optrecup   = 0;
static octet optsave    = 1;

/* accs aux fichiers */
static FILE  *adrfic;          /* fichier ouvert */
static int   carfic;           /* caractre courant du fichier ouvert */
static octet typefichier;      /* mmorise si fichier de type UNIX ou MS-DOS */
static FILE  *ficaide;         /* descripteur du fichier d'aide en ligne */

/* saisie d'une commande oprateur */
static char commande [colonecran + 10];
static octet poscom;
static octet szcom;

/* recherche d'une chaine ou d'une expression */
static char  ligne [szmaxlig]; /* ligne  analyser */
static int16 szlig;            /* taille de la ligne */
static int   sens;             /* sens d'exploration du fichier */

/* polices de caractres et couleurs */
static octet polcourante;
static char  couleur;          /* initialis par codecouleur */
static char  police;           /* initialis par codepolice  */
static char  listecouleur [7] = "nrvjbmc";
/* static struct text_info confecran;  */

/* alarme d'inactivit */
static long  att_alarme = 0;
