#include <stdio.h>

#define szmaxlig  1024             /* taille maximale des lignes */
#define szmaxexpr  255             /* taille maximale des expressions */

#define EOL  10
#define CR   13

#define octet unsigned char


static octet ligne [szmaxlig];     /* ligne  analyser */
static int   szlig;                /* taille de la ligne */

static octet optn = 0, optv = 0;   /* options de la commande */
static octet optf = 0;             /* recherche sur plusieurs fichiers */
static octet optdeb = 0;           /* recherche seulement en dbut de ligne */
static octet optfin = 0;           /* recherche seulement en fin de ligne */

static octet expr  [szmaxexpr];     /* expression  rechercher */
static octet occur [szmaxexpr];     /* occurence caractres de l'expression */
static octet szexpr;                /* taille de l'expression  rechercher */
static octet nbcarmin;              /* taille min chaine contenant expression */

static octet touscar;        /* codage si n'importe quel caractre accept */

static int car;

/* programme principal */
main (narg, varg)
int narg;
char *varg [];
{
    int poslig;             /* position dans la ligne */
    unsigned int numlig;    /* numro de la ligne courante */


    /* se positionner sur le premier argument */
    varg++;
    narg--;

    /* rcuprer les options */
    while (**varg == '-')
    {
        /* option -n (dition des numros de ligne) */
        if (strcmp (*varg, "-n") == 0)
            optn = 1;

        /* option -v (dition si expression non trouve) */
        else if (strcmp (*varg, "-v") == 0)
            optv = 1;

        /* option incorrecte */
        else
            psyntaxe ();

        /* passer  l'argument suivant */
        varg++;
        narg--;
    }

    /* analyser l'expression  rechercher */
    if (narg-- > 0)
    {
        /* pranalyse de l'expression */
        preanalyse (*varg);

        /* separation des caractres et de leurs occurences */
        sepoccur ();

        /* simplification de l'expression */
        simplifie ();

        /* on se positionne sur l'argument suivant */
        varg++;
    }
    else
        psyntaxe ();

    /* plusieurs fichiers  analyser ? */
    if (narg > 1)
        optf = 1;

    /* recherche sur les diffrents fichiers */
    do
    {
        /* ouvrir le fichier en lecture */
        if (narg > 0 && freopen (*varg, "rb", stdin) == 0)
            fprintf (stderr, "Fichier %s inexistant\n", *varg);

        /* initialisation */
        numlig = 0;
        car = getchar ();

        /* tantque non fin de fichier */
        while (car != EOF)
        {
            /* lire une ligne */
            numlig++;
            szlig = 0;

            while (car != EOL && car != EOF)
            {
                /* mmoriser le caractre lu */
                if (szlig < szmaxlig)
                    ligne [szlig++] = car;

                /* lire le caractre suivant */
                car = getchar ();
            }

            /* suppression du CR ventuel en fin de ligne */
            if (ligne [szlig - 1] == CR)
                szlig = szlig - 1;

            /* test de prsence de l'expression et dition ventuelle */
            if (tstexpr (0, 0, optdeb) != optv)
            {
                if (optf == 1)
                    printf ("%s:", *varg);

                if (optn == 1)
                    printf ("%u:", numlig);

                for (poslig = 0; poslig < szlig; poslig++)
                    putchar (ligne [poslig]);

                putchar (EOL);
            }

            /* sauter le caractre de passage  la ligne */
            car = getchar ();
        }

        /* passer au fichier suivant */
        varg++;
    }
    while (--narg > 0);
}

/* Rappel de la syntaxe de la commande et arrt */
psyntaxe ()
{
    err_fatale (
"Syntaxe : grep [-n][-v] <expression  rechercher> [<liste de fichiers>]");
}



/* Message d'erreur fatal et arrt */
err_fatale (format, car1, car2)
char *format;
char car1, car2;
{
    fprintf (stderr, format, car1, car2);
    fputs ("\n", stderr);

    exit ();
}

/* Pranalyse de l'expression  rechercher */
preanalyse (char *exporig)
{
    octet valcar, i;


    /* initialisation */
    szexpr = 0;

    /* recherche seulement en dbut de ligne ? */
    if (*exporig == '^')
    {
        optdeb = 1;
        exporig++;
    }

    /* analyse des caractres de l'expression */
    while (*exporig != 0)
    {
        switch (*exporig)
        {
            /* recherche seulement en fin de ligne ? */
            case '$' : if (*(exporig + 1) == 0)
                           optfin = 1;
                       else
                           expr [szexpr++] = '$';

                       break;

            /* traitement des '\' */
            case '\\': exporig++;

                       switch (*exporig)
                       {
                           /* caractre exprim en hexa */
                           case 'x' : for (i = 0; i < 2; i++)
/* recentrage  gauche */
{
    exporig++;

    valcar = *exporig - '0';

    if (valcar > 16)
        valcar -= 7;

    if ((valcar & 0xD0) != 0)
    {
        fprintf (stderr, "Valeur hexadcimale incorrecte\n");

        exit ();
    }

    expr [szexpr] = (expr [szexpr] << 4) | valcar;
}
/* fin du recentrage  gauche */
                                      szexpr++;
                                      break;

                           /* caractre CR */
                           case 'r' : expr [szexpr++] = CR;
                                      break;

                           default  : /* le '\' est conserve pour la suite */
                                      exporig--;
                                      expr [szexpr++] = '\\';
                       }

                       break;

            /* cas gnral */
            default  : expr [szexpr++] = *exporig;
        }

        /* analyser le caractre suivant */
        exporig++;
    }
}

/* sparation des caractres et de leurs occurences */
sepoccur ()
{
    octet i, j, k;       /* compteurs */
    octet chertouscar;   /* indique si touscar initialise */


    /* variable touscar non encore initialise */
    chertouscar = 1;

    /* positionnement en debut d'expression */
    i = 0;
    j = 0;

    /* tantque expression non traite en entier */
    while (i < szexpr)
    {
        /* si mtacaractre '!' ou '>' */
        if (expr [i] == '!' || expr [i] == '>')
        {
            /* erreur si fin de chaine */
            if (i + 1 == szexpr)
                err_fatale (
          "Le mtacaractre '%c' ne peut terminer une expression", expr [i]);

            /* erreur si "!." ou ">." */
            else if (expr [i + 1] == '.')
                err_fatale ("Mtacaractres '%c' et '.' incompatibles",
                                                                   expr [i]);
            else
                /* sinon mmoriser le mtacaractre comme occurence */
                occur [j] = expr [i++];
        }
        /* sinon initialiser l'occurence */
        else
            occur [j] = '1';

        /* si mtacaractre '.' */
        if (expr [i] == '.')
        {
            /* si variable "n'importe quel caractre" non initialise */
            if (chertouscar == 1)
            {
                touscar = 0xff;
                k = 0;

                /* rechercher un caractre non utilis dans l'expression */
                while (k < szexpr)
                {
                    if (expr [k++] == touscar)
                    {
                        touscar--;
                        k = 0;
                    }
                }

                /* la variable a t initialise avec le caractre trouv */
                chertouscar = 0;
            }

            /* le caractre courant signifie "n'importe quel caractre" */
            expr [i] = touscar;
        }
        /* sinon si caractre '\', passer au caractre suivant */
        else if (expr [i] == '\\')
            i++;

        /* mmoriser le caractre courant */
        expr [j] = expr [i++];

        /* si le caractre suivant prcise un nombre d'occurences */
        if (expr [i] == '?' || expr [i] == '*' || expr [i] == '+')
        {
            /* si pas de mtacaractre '!' ou '>' */
            if (occur [j] == '1')
                /* mmoriser le nombre d'occurences et avancer d'un caractre */
                occur [j++] = expr [i++];
            else
            {
                if (occur [j] == '>' || expr [i] == '?')
                    err_fatale ("Mtacaractres '%c' et '%c' incompatibles",
                                                        occur [j], expr [i]);

                else if (optfin == 0 || i + 1 < szexpr)
                    err_fatale (
       "Mtacaractres '%c' et '%c' autoriss seulement en fin d'expression",
                                                        occur [j], expr [i]);
                else
                {
                    if (expr [i++] == '+')
                        expr [++j] = expr [j];

                    occur [j++] = '$';
                }
            }
        }
        else
            /* sinon 1 occurence du caractre (dj mmoris) */
            j++;
    }

    /* mmoriser la taille de l'expression traite */
    szexpr = j;
}

/* simplification de l'expression pour rendre la recherche dterministe */
simplifie ()
{
    octet i, j;    /* compteurs */


    /* parcour de l'expression */
    for (i = 1; i < szexpr; i++)
    {
        /* si 2 caractres consecutifs identiques dans l'expression */
        if (expr [i - 1] == expr [i])
        {
            /*  <car><occurence><car>  ==>  <car><car><occurence>  */
            if (occur [i] == '1' && occur [i - 1] != '!'
                                 && occur [i - 1] != '>')
            {
                occur [i] = occur [i - 1];
                occur [i - 1] = '1';
            }

            switch (occur [i - 1])
            {
                           /*  <car><car>*  ==>  <car>+  */
                case '1' : if (occur [i] == '*')
                           {
                               occur [i - 1] = 0;
                               occur [i] = '+';
                           }
                           break;

                           /*  <car>*<car>?  ==>  <car>*  */
                case '*' : if (occur [i] == '?')
                               occur [i] = '*';

                           /*  <car>*<car>*  ==>  <car>*
                               <car>*<car>+  ==>  <car>+
                               <car>?<car>*  ==>  <car>*
                               <car>?<car>+  ==>  <car>+  */
                case '?' : if (occur [i] == '*' || occur [i] == '+')
                               occur [i - 1] = 0;

                           break;

                           /*  <car>+<car>+  ==>  <car><car>+  */
                case '+' : if (occur [i] == '+')
                               occur [i - 1] = '1';

                           /*  <car>+<car>*  ==>  <car>+
                               <car>+<car>?  ==>  <car>+  */
                           else if (occur [i] == '*' || occur [i] == '?')
                           {
                               occur [i - 1] = 0;
                               occur [i] = '+';
                           }
                           break;
            }
        }

        /* sinon si .* ou .+ suivi d'un caractre avec occurence */
        else if (expr [i - 1] == touscar &&
                 (occur [i] == '?' || occur [i] == '*' || occur [i] == '+'))
        {
            if (occur [i - 1] == '*' || occur [i - 1] == '+')
            {
                /*  .*<car>+  ==>  .*<car>  et  .+<car>+  ==>  .+<car>  */
                if (occur [i] == '+')
                    occur [i] = '1';

                /*  .*<car>*  ou  .*<car>?  ==>  .*
                    .+<car>*  ou  .+<car>?  ==>  .+  */
                else
                    occur [i] = 0;
            }
        }

        /* sinon si caractre avec occurence suivi de .* ou .+  */
        else if (expr [i] == touscar && (occur [i - 1] == '?'
              || occur [i - 1] == '*' || occur [i - 1] == '+'))
        {
            if (occur [i] == '*' || occur [i] == '+')
            {
                /*  <car>+.*  ==>  <car>.*  et  <car>+.+  ==>  <car>.+  */
                if (occur [i - 1] == '+')
                    occur [i - 1] = '1';

                /*  <car>*.*  ou  <car>?.*  ==>  .*
                    <car>*.+  ou  <car>?.+  ==>  .+  */
                else
                    occur [i - 1] = 0;
            }
        }
    }

    j = 0;
    nbcarmin = 0;

    /* compacter l'expression en supprimant les occurences effaces et
       calculer la taille minimale d'une chaine contenant l'expression */
    for (i = 0; i < szexpr; i++)
    {
        if (occur [i] != 0)
        {
            expr  [j]   = expr  [i];
            occur [j++] = occur [i];

            if (occur [i] == '1' || occur [i] == '+'
             || occur [i] == '!' || occur [i] == '>')
                nbcarmin++;
        }
    }

    /* mmoriser la taille de l'expression simplifie */
    szexpr = j;
}

/* test de la prsence de l'expression  rechercher dans la ligne */
int tstexpr (debrech, debexpr, opdeb)
int debrech;   /* position dans la ligne o commence la recherche */
int debexpr;   /* position dans l'expression o commence l'analyse */
octet opdeb;   /* indique si l'expression doit commencer en dbut de ligne */
{
    int   finrech;
    octet contin;
    int   i, j;


    /* cas particulier : chaine vide */
    if (nbcarmin == 0 && (szlig == 0 || optdeb == 0 || optfin == 0))
        return (1);

    /* initialisation recherche en dbut de ligne ou sur toute la ligne */
    if (opdeb == 0)
        finrech = debrech + szlig - nbcarmin;
    else
        finrech = debrech;

    /* recherche de l'expression dans la ligne */
    while (debrech <= finrech)
    {
        /* initialisation */
        contin = 1;
        i = debrech++;

        /* pour tous les caractres de l'expression */
        for (j = debexpr; j < szexpr && contin == 1; j++)
        {
            /* termin si la ligne est trop courte */
            if (i >= szlig)
                return (0);

            /* si n'importe quel caractre est accept en position courante */
            if (expr [j] == touscar)
            {
                switch (occur [j])
                {
                    case '1' : i++;
                               break;

                    case '?' : if (tstexpr (i, j + 1, 1) == 1)
                                   return (1);
                               else
                                   i++;

                               break;

                    case '+' : i++;
                    case '*' : j++;
                               return (tstexpr (i, j, 0));
                }
            }

            /* sinon si le caractre courant dans la
               ligne coincide avec celui de l'expression */
            else if (ligne [i] == expr [j])
            {
                /* si occurence multiple du caractre possible */
                if (occur [j] == '+' || occur [j] == '*')
                {
                    /* sauter ces occurences */
                    while (ligne [++i] == expr [j]);
                }
                /* sinon si on ne voulait pas ce caractre */
                else if (occur [j] == '!')
                {
                    /* chec de l'analyse */
                    contin = 0;
                }
                /* sinon passer au caractre suivant */
                else
                    i++;
            }
            /* sinon, le caractre n'est pas celui recherch */
            else
            {
                /* si le caractre cherch doit figurer au moins une fois */
                if (occur [j] == '1' || occur [j] == '+')
                {
                    /* chec de l'analyse */
                    contin = 0;
                }
                /* sinon si on ne voulait pas ce caractre */
                else if (occur [j] == '!')
                {
                    /* passer au caractre suivant */
                    i++;
                }
                /* sinon si mtacaractre '>' */
                else if (occur [j] == '>')
                {
                    /* sauter tous les caractres jusqu' celui recherch */
                    while (ligne [++i] != expr [j])
                        if (i >= szlig)
                            /* termin si caractre non trouv */
                            return (0);

                    /* passer au caractre suivant */
                    i++;
                }
                /* sinon si le caractre ne doit plus apparaitre dans la ligne */
                else if (occur [j] == '$')
                {
                    /* explorer la fin de la ligne */
                    while (ligne [++i] != expr [j])
                        if (i >= szlig)
                            /* termin on n'a pas trouv de caractre */
                            return (1);

                    /* sinon chec de l'analyse */
                    contin = 0;
                }
                /* sinon on poursuivra l'analyse sur le caractre courant */
            }
        }

        /* si expression trouve */
        if (contin == 1)
            /* controle si position par rapport  la fin de ligne correcte */
            if (optfin == 0 || i == szlig)
                return (1);
    }

    /* l'expression n'a pas t trouve */
    return (0);
}