  #include <stdio.h>

#define EOL     10
#define ESC     27

#define octet   unsigned char


static octet scoldeb, coldeb, ncoldeb, colfin, nbcar,
                      posmot, poslig, nbmemo, nblancs, justif;
static char  mot [80], ligne [255];
static int   car1, car2;

main (narg, varg)
int narg;
char *varg [];
{
    char *carg;

    scoldeb = 0;
    colfin  = 0;

    *varg++;
    narg--;
    carg = *varg;

    if (*carg == '-')
    {
         carg++;

         if (*carg++ != 'c')
             psyntaxe ();

         while ((*carg >= '0') && (*carg <= '9'))
         {
             scoldeb = (scoldeb * 10) + *carg - '0';
             carg++;
         }

         if (*carg++ != '-')
             psyntaxe ();

         while ((*carg >= '0') && (*carg <= '9'))
         {
             colfin = (colfin * 10) + *carg - '0';
             carg++;
         }

         if (*carg != 0)
             psyntaxe ();

         *varg++;
         narg--;
    }

    if (colfin == 0)
        colfin = 80;

    do
    {
        if (narg > 0)
        {
            if (freopen (*varg, "r", stdin) == 0)
                fprintf (stderr, "Fichier %s inexistant\n", *varg);
        }

        trtfic ();

        *varg++;
        narg--;
    }
    while (narg > 1);
}


psyntaxe ()
{
     fprintf (stderr, "%s %s\n",
             "Syntaxe : justif [-c<colonne de debut>-<colonne de fin>]",
             "<liste de fichiers>");

     exit ();
}

trtfic ()
{
    octet i;


    posmot  = 0;
    poslig  = 0;
    nbmemo  = 0;
    nblancs = 0;
    coldeb  = scoldeb;
    ncoldeb = coldeb;
    nbcar   = colfin - coldeb;
    justif  = 1;

    car1 = getchar ();
    car2 = getchar ();

    while (car1 != EOF)
    {
        while (car1 == ESC)
            trtesc ();

        if (justif)
        {
            if (car1 == EOL)
            {
                if (car2 != EOL)
                    car1 = ' ';
                else
                {
                    do
                    {
                        trtcar (EOL);

                        car2 = getchar ();
                    }
                    while (car2 == EOL);
                }

                while (car2 == ' ')
                    car2 = getchar ();
            }

            else if ((car1 == '\\') && (car2 == EOL))
            {
                car1 = car2;

                do
                {
                    car2 = getchar ();
                }
                while (car2 == ' ');
            }


            trtcar (car1);
        }
        else
        {
            putchar (car1);

            if (car1 == EOL)
                for (i = 0; i < coldeb; i++)
                    putchar (' ');
        }

        car1 = car2;
        car2 = getchar ();
    }

    if (car1 != EOL)
        trtcar (EOL);
}

trtesc ()
{
    octet decal;

    if ((car2 >= '0') && (car2 <= '9'))
    {
        decal = car2 - '0';

        car2 = getchar ();

        while ((car2 >= '0') && (car2 <= '9'))
        {
            decal = (decal * 10) + (car2 - '0');

            car2 = getchar ();
        }

        if (car2 == '>')
        {
            ncoldeb = ncoldeb + decal;

            if (ncoldeb + 3 > colfin)
                ncoldeb = colfin - 3;
        }
        else if (car2 == '<')
        {
            if (ncoldeb > decal)
            {
                ncoldeb = ncoldeb - decal;

                if (ncoldeb < scoldeb)
                    ncoldeb = scoldeb;
            }
            else
                ncoldeb = scoldeb;
        }
        car1 = getchar ();
        car2 = getchar ();
    }
    else if (car2 == '|')
    {
        ncoldeb = scoldeb;

        car1 = getchar ();
        car2 = getchar ();
    }
    else if (car2 == 'j')
    {
        justif = 1;

        car1 = getchar ();
        car2 = getchar ();
    }
    else if (car2 == '-')
    {
        car2 = getchar ();

        if (car2 == 'j')
        {
            justif = 0;

            trtligne (EOL);

            car1 = getchar ();
            car2 = getchar ();
        }
        else
        {
            if (justif)
                trtcar (ESC);
            else
                putchar (ESC);

            car1 = '-';
            nbcar = nbcar + 3;
        }
    }
    else
    {
        if (justif)
            trtcar (ESC);
        else
            putchar (ESC);

        if (car2 == 't' || car2 == 'c')
            nbcar = nbcar + 3;
        else
            nbcar = nbcar + 2;

        car1 = car2;
        car2 = getchar ();
    }
}

trtcar (car)
char car;
{
    octet i;

    if (car == EOL)
    {
        if (nbmemo < nbcar)
            trtligne (' ');
        else if (nbmemo + nblancs - posmot < nbcar)
            trtmot ();
        else
            trtligne (EOL);

        for (i = 0; i < posmot; i++)
            trtligne (mot [i]);

        trtligne (EOL);

        posmot = 0;
        nbmemo = 0;
    }
    else if (car == ' ')
    {
        if (nbmemo < nbcar)
        {
            if (poslig > 0)
            {
                trtligne (' ');
                nbmemo++;
            }
        }
        else
        {
            if (nbmemo + nblancs - posmot < nbcar)
                trtmot ();
            else
            {
                trtligne (EOL);
                nbmemo = posmot;
            }
        }

        for (i = 0; i < posmot; i++)
            trtligne (mot [i]);

        posmot = 0;
    }

    else
    {
        mot [posmot++] = car;
        nbmemo++;
    }
}


trtmot ()
{
    octet szmax, i, ok;

    szmax = posmot - nbmemo + nbcar - 2;

    if (szmax >= posmot - 2)
    {
        if ((consonne (posmot - 1) == 1) || (voyelle (posmot - 1) == 1))
            szmax = posmot - 2;
        else
            szmax = posmot - 3;
    }
    do
    {
        ok = 1;

        if (voyelle (szmax) == 1)
            ok = 0;
        else if ((voyelle (szmax - 1) == 1) && (consonne (szmax + 1) == 1)
                                            && (mot [szmax + 1] != 'r'))
            ok = 0;
        else if ((mot [szmax] == 'r') && (consonne (szmax - 1) == 1))
            ok = 0;
        else if ((mot [szmax - 1] == 'c') && (mot [szmax] == 'h'))
            szmax--;

        if (ok == 0)
            szmax--;
    }
    while (ok == 0);

    trtligne (' ');

    if (szmax > 1)
    {
        for (i = 0; i < szmax; i++)
            trtligne (mot [i]);

        trtligne ('-');
        trtligne (EOL);
        trtligne ('-');
    }
    else
    {
        trtligne (EOL);
        szmax = 0;
    }

    for (i = szmax; i < posmot; i++)
        trtligne (mot [i]);

    nbmemo = posmot - szmax + 1;
    posmot = 0;
}

int voyelle (pos)
octet pos;
{
    octet car, carmin;

    car = mot [pos];
    carmin = car | 0x20;

    if ((carmin == 'a') || (carmin == 'e') || (carmin == 'i') ||
        (carmin == 'o') || (carmin == 'u') || (carmin == 'y') ||
        ((car > 0x80) && (car < 0x9b) && (car != 0x87)))
        return (1);
    else
        return (0);
}

int consonne (pos)
octet pos;
{
    octet car;

    car = mot [pos];

    if (((car > '@') && (car < '{') && (voyelle (pos) == 0)) ||
         (car == 0x80) || (car == 0x87))
        return (1);
    else
        return (0);
}


trtligne (car)
char car;
{
    octet i, pivot;

    if (car != EOL)
    {
        ligne [poslig++] = car;

        if (car == ' ')
            nblancs++;
    }
    else
    {
        for (i = 0; i < coldeb; i++)
            putchar (' ');

        pivot = nbcar - poslig + 1;

        if (pivot - 1 > nblancs)
            pivot = 0;

        for (i = 0; i < poslig; i++)
        {
            putchar (ligne [i]);

            if (ligne [i] == ' ')
            {
                if (nblancs-- < pivot)
                    putchar (' ');
            }
        }

        putchar (EOL);

        poslig = 0;
        nblancs = 0;
        coldeb = ncoldeb;
        nbcar = colfin - coldeb;
    }
}
