#include <stdio.h>
#include <dir.h>
#include <alloc.h>

/* taille d'un nom de fichier */
#define szmemo 13    /* en octets */

/* nombre de noms de fichiers par ligne */
#define szligne 5


/* description du nom d'un fichier */
typedef char descfic [szmemo];

/* table des noms de fichier */
static struct ffblk fich;

/* pointeurs sur les lments de la table de description des fichiers */
static char *attrib, *nomfich;

/* indicateur : liste des fichiers entirement consulte ? */
static int trouve;

/* nombre de fichiers mmoriss */
static int nbfic = 0;

/* indicateur de debordement de la liste */
static int deborde = 0;

/* nombre maximun de fichiers mmoriss */
static int szliste;

/* pointeur sur la liste des fichiers mmoriss */
unsigned descfic *listefic;

/* nom du fichier  diter */
static char nfichier [szmemo + 1];

/* nombre de noms de fichiers dj dits dans la ligne courante */
static char poslig = 0;

/* programme principal */
main (narg, varg)
int narg;
char *varg [];
{
    /* chemins d'accs aux fichiers du rpertoire slectionn */
    char chemin [256];

    /* dernier caractre d'un nom pass en paramtre */
    char *dercar;


    /* initialisation du nombre maximal d'lments de la liste */
    szliste = (coreleft () - 100) / szmemo;

    /* allocation de la liste des fichiers mmoriss */
    listefic = malloc (szliste * szmemo);

    /* initialisation des pointeurs sur la table de description des fichiers */
    attrib  = &fich.ff_attrib;
    nomfich = fich.ff_name;

    /* calcul du nombre de paramtres de la commande */
    narg--;

    /* si des noms de fichier ou de rpertoire ont t passs en paramtre */
    if (narg > 0)
    {
        /* tant que tous les paramtres n'ont pas t traits */
        while (narg -- > 0)
        {
            /* se positionner sur le premier paramtre non trait */
            varg++;

            /* on considre qu'il s'agit d'un rpertoire
               fabriquer le chemin d'accs aux lments de ce rpertoire */
            dercar = *varg + strlen (*varg) - 1;

            if (*dercar == '/' || *dercar == '\\')
                sprintf (chemin, "%s*.*", *varg);
            else
                sprintf (chemin, "%s/*.*", *varg);

            /* rcuprer les caractristiques du
               premier fichier du rpertoire */
            trouve = findfirst (chemin, &fich, 0xFF);

            /* si fichier trouv */
            if (trouve != -1)
            {
                /* afficher la liste des fichiers dj mmoriss */
                if (nbfic != 0)
                {
                    putchar ('\n');
                    affliste ();
                }

                /* diter le chemin d'accs au rpertoire */
                printf ("\n%s:\n", *varg);

                /* traiter l'ensemble des fichiers du rpertoire */
                lisdir ();
            }
            else
            {
            /* sinon chercher si le paramtre correspond  un nom de fichier */
                trouve = findfirst (*varg, &fich, 0xFF);

                /* si fichier trouv */
                if (trouve != -1)
                    /* mmoriser son nom */
                    memo ();

                /* sinon, message d'erreur */
                else
                    fprintf (stderr, "%s : inexistant\n", *varg);
            }
        }

        /* afficher la liste des derniers fichiers mmoriss */
        if (nbfic != 0)
        {
            putchar ('\n');
            affliste ();
        }
    }
    /* sinon  (commande lance sans paramtres) */
    else
    {
        /* traiter les fichiers du rpertoire courant */
        trouve = findfirst ("*.*", &fich, 0xFF);
        lisdir ();
    }
}


/* mmorisation de l'ensemble des fichiers du rpertoire slectionn */
lisdir ()
{
    /* rpter */
    do
    {
        /* mmoriser le nom du fichier courant */
        if ((fich.ff_attrib & 0x0F) != 0x0F)
            memo ();

        /* chercher le fichier suivant */
        trouve = findnext (&fich);
    }
    /* jusque plus de fichier trouv */
    while (trouve != -1);

    /* afficher la liste des fichiers mmoriss */
    affliste ();
}

/* mmorisation du nom d'un fichier */
memo ()
{
    /* position dans la liste des fichiers */
    int i;

    /* rsultat d'une comparaison entre 2 noms de fichier */
    int ordre;

    /* nom du fichier courant */
    descfic curfic;


    /* traitement de l'attribut du fichier */
    trtattrib ();

    /* recopier dans curfic le nom du fichier  mmoriser */
    memcpy (curfic, nomfich, szmemo);

    /* si la liste des fichiers est pleine */
    if (nbfic == szliste)
    {
        /* message d'erreur eventuel */
        if (deborde == 0)
        {
            fprintf (stderr, "Trop de fichier, ordre non respecte\n");
            deborde = 1;
        }

        /* editer et supprimer le premier fichier de la liste */
        affiche (0);
        memmove (*listefic, listefic [1], (nbfic - 1) * szmemo);

        /* la liste n'est plus pleine */
        nbfic --;
    }

    /* initialisation */
    i = 0;
    ordre = 1;

    /* chercher avant quel fichier de la liste
       le fichier courant doit tre insr */
    while ((i < nbfic) && (ordre == 1))
        ordre = compar (curfic, listefic [i++]);

    /* si on n'est pas arriv en fin de liste */
    if (ordre == -1)
    {
         /* se positionner sur le premier fichier a deplacer */
         i--;

         /* dcaler les derniers fichiers de la liste d'une position */
         memmove (listefic [i + 1], listefic [i], (nbfic - i) * szmemo);
    }

    /* mmoriser le fichier courant dans la liste */
    memcpy (listefic [i], curfic, szmemo);

    /* mise  jour du nombre de fichiers de la liste */
    nbfic++;
}

/* traitement de l'attribut du fichier courant */
trtattrib ()
{
    /* position dans le nom de fichier */
    char i;

    /* caractres aprs le nom de fichier */
    char finfic;


    /* se positionner a la fin du nom de fichier */
    for (i = 1; (i < szmemo) && (nomfich [i] != 0); i++);

    /* traitement de l'attribut rpertoire */
    if (*attrib & 0x10)
        nomfich [i++] = '/';

    /* traitement des autres attributs */
    if (*attrib & 0x06)
        finfic = 0xF0;
    else if (*attrib & 0x08)
        finfic = 0xB0;
    else
        finfic = ' ';

    /* on complte le nom du fichier  13 caractres */
    while (i < szmemo)
        nomfich [i++] = finfic;
}


/* comparaison de 2 noms de fichier */
int compar (x, y)
unsigned char x[], y[];
{
    /* position dans le nom de fichier */
    int i;

    /* rsultat de la comparaison de 2 caractres */
    int ordre = 0;


    /* comparaison des caractres constituant les noms de fichier */
    for (i = 0; ((i < szmemo) && (ordre == 0)); i++)
        if (x [i] != y [i])
            if (x [i] > y [i])
                ordre = 1;
            else
                ordre = -1;

    /* retourner le rsultat de la comparaison */
    return (ordre);
}

/* dition de la liste des fichiers mmoriss */
affliste ()
{
    /* position dans la liste */
    int i;

    /* initialisation */
    nfichier [szmemo] = 0;

    /* pour tous les fichiers de la liste */
    for (i = 0; i < nbfic; i++)
        /* editer le nom du fichier courant */
        affiche (i);

    /* passage  la ligne */
    putchar ('\n');

    /* rinitialisation */
    nbfic = 0;
    poslig = 0;
    deborde = 0;
}


/* dition du nom du (n + 1)ime fichier de la liste */
affiche (n)
int n;
{
    /* rcuprer le nom de fichier */
    memcpy (nfichier, &listefic [n], szmemo);

    /* passage  la ligne ventuel */
    if (poslig++ == szligne)
    {
        putchar ('\n');
        poslig = 1;
    }

    /* criture de caractres blancs ventuels */
    if (poslig > 1)
        printf ("   ");

    /* diter le nom de fichier */
    printf ("%s", nfichier);
}
