#include <stdio.h>

#define octet unsigned char

static ptaille [6] = {4, 1, 0, 36, 33, 32};

static char jeuxcar [45] =
                         "21^2191^\"1\"^629999^26^1\"220387000007700700007";
static char carspe  [45] =
                         "}{a{@}\\ee}ii~[]@{[o||u|y\\].#\\#.....|\\..]....[";

static octet etat, taille, qualite, interligne, page;
static int car;
static char *carg;

main (narg, varg)
int narg;
char *varg [];
{
    etat = 0;
    taille  = 3;
    qualite = 0;
    interligne = 12;
    page = 11;       /* dpend de la taille des feuilles de papier */

    *varg++;
    narg--;
    carg = *varg;

    while (*carg == '-')
    {
         carg++;

         while (*carg != 0)
         {
             switch (*carg)
             {
                 case 'q' : qualite = 1;
                            carg++;
                            break;

                 case 'f' : if (getchar () == '0')
                                qualite = 0;
                            else
                                qualite = 1;
                            break;

                 case 'i' : getval (&interligne, 85);
                            break;

                 case 'p' : getval (&page, 150);
                            break;

                 case 't' : getval (&taille, 6);
                            break;

                 default  : psyntaxe ();
             }
         }

         *varg++;
         narg--;
         carg = *varg;
    }

    freopen ("prn", "w", stdout);

    putchar (27);
    putchar ('3');
    putchar (interligne * 3);

    putchar (27);
    putchar ('C');
    putchar (0);
    putchar (page);

    putchar (27);
    putchar ('x');
    putchar (qualite);

    putchar (27);
    majtaille (taille);

    do
    {
        if (narg > 0)
        {
            if (freopen (*varg, "rb", stdin) == 0)
                fprintf (stderr, "Fichier %s inexistant\n", *varg);
        }

        car = getchar ();

        while (car != EOF)
        {
            if (qualite == 1 && car >= 0x81 &&
                (car <= 0xad || car == 0xe1 || car == 0xed))
            {
                trtaccent (car);
            }
            else
                putchar (car);

            if (car == 27)
                traitescape ();

            car = getchar ();
        }
        putchar (10);
        putchar (12);

        *varg++;
        narg--;
    }
    while (narg > 0);
    putchar (10);
}


psyntaxe ()
{
    fprintf (stderr, "Syntaxe : lp [-(q|i<val>|p<val>|t<val>]* <liste de fichiers>\n");
    exit ();
}


getval (valeur, max)
octet *valeur, max;
{
    octet val, option;

    val = 0;
    option = *carg;
    carg++;

    while ((*carg >= '0') && (*carg <= '9'))
    {
        val = (val * 10) + (*carg - '0');
        carg++;
    }

    if (val > max)
        fprintf (stderr, "Valeur maximale pour l'option %c : %d\n",
                                                      option, max);
    else if (val > 0)
        *valeur = val;
}

majtaille (taille)
octet taille;
{
    if ((taille > 0) && (taille <= 6))
    {
        etat = (etat & 218) | ptaille [taille - 1];

        putchar ('!');
        putchar (etat);
    }
}

traitescape ()
{
    octet majcf;

    majcf = 1;

    car = getchar ();

    switch (car)
    {
        case '-' : car = getchar ();
                   switch (car)
                   {
                       case '_' : etat = etat & 0x7F;
                                  break;

                       case '/' : etat = etat & 0xBF;
                                  break;

                       case '>' : etat = etat & 0xDF;
                                  break;

                       case '<' : etat = etat & 0xFB;
                                  break;

                       case 'd' : etat = etat & 0xEF;
                                  break;

                       case 'g' : etat = etat & 0xF7;
                                  break;

                       case 'q' : putchar ('x');
                                  putchar (0);
                                  qualite = 0;
                                  majcf = 0;
                                  break;

                       case '^' : puts ("~10");
                                  majcf = 0;
                                  break;

                       case '\'':
                       case '.' : puts ("T");
                                  majcf = 0;
                                  break;
                   }
                   break;

        case '_' : etat = etat | 0x80;
                   break;

        case '/' : etat = etat | 0x40;
                   break;

        case '>' : etat = etat | 0x20;
                   break;

        case '<' : etat = etat | 0x04;
                   break;

        case 'd' : etat = etat | 0x10;
                   break;

        case 'g' : etat = etat | 0x08;
                   break;

        case 't' : car = getchar ();
                   if ((car > '0') && (car <= '6'))
                       etat = (etat & 0xDA) | ptaille [car - '1'];
                   break;

        case 'i' : car = getchar ();
                   if (car >= '0' && car <= '9')
                   {
                       interligne = car - '0';
                       if (interligne <= 3)
                       {
                           car = getchar ();
                           if (car >= '0' && car <= '9')
                               interligne = (interligne * 10) + car - '0';
                       }
                       putchar ('3');
                       putchar (interligne * 3);
                       majcf = 0;
                   }
                   break;

        case 'f' : if (getchar () == '0')
                       qualite = 0;
                   else
                       qualite = 1;
                   putchar ('x');
                   putchar (qualite);
                   majcf = 0;
                   break;

        case 'q' : putchar ('x');
                   putchar (1);
                   qualite = 1;
                   majcf = 0;
                   break;

        case '^' : puts ("~11");
                   majcf = 0;
                   break;

        case '\'': puts ("S0");
                   majcf = 0;
                   break;

        case '.' : puts ("S1");
                   majcf = 0;
                   break;

        default  : putchar (car);
                   majcf = 0;
    }

    if (majcf == 1)
    {
        putchar ('!');
        putchar (etat);
    }
}


trtaccent (car)
octet car;
{
    octet postab, jeux;

    if (car < 0xe1)
    {
        postab = car - 0x81;
        jeux = jeuxcar [postab];

        if (jeux == '0')
            putchar (car);

        else if (jeux == '^')
        {
            putchar (carspe [postab]);
            putchar (8);
            putchar ('^');
        }
        else if (jeux == '"')
        {
            putchar (carspe [postab]);
            putchar (8);
            trtcarspe ('~', 1);
        }
        else
            trtcarspe (carspe [postab], jeux - '0');
    }
    else if (car == 0xe1)
        trtcarspe ('~', 2);
    else
        trtcarspe ('|', 9);
}


trtcarspe (vcar, jeux)
octet vcar, jeux;
{
    printf ("%c~50%cR%c%c%cR%c%c~51", 27, 27, jeux, vcar, 27, 0, 27);
}
