#include <stdio.h>

#define octet unsigned char

static ptaille [7] = {5, 4, 1, 0, 36, 33, 32};


static octet etat, taille, fonte, interligne, page;
static int car;
static char *carg;


main (narg, varg)
int narg;
char *varg [];
{
    etat = 0;
    taille = 3;
    fonte = 0;
    interligne = 10;
    page = 11;       /* dpend de la taille des feuilles de papier */

    *varg++;
    narg--;
    carg = *varg;

    /* rcupration des options d'impression */
    while (*carg == '-')
    {
         carg++;

         while (*carg != 0)
         {
             switch (*carg)
             {
                 case 'f' : getval (&fonte, 4);
                            break;

                 case 'q' : fonte = 1;
                            carg ++;
                            break;

                 case 'i' : getval (&interligne, 85);
                            break;

                 case 'p' : getval (&page, 150);
                            break;

                 case 't' : getval (&taille, 6);
                            break;

                 default  : psyntaxe ();
             }
         }

         /* passage  l'argument suivant */
         *varg++;
         narg--;
         carg = *varg;
    }

    /* ouverture du fichier imprimante */
    freopen ("prn", "w", stdout);

    /* slection mode epson */
    putchar (27);
    putchar ('~');
    putchar ('5');
    putchar ('0');

    /* jeu de caractres tendu */
    putchar (27);
    putchar ('6');
    putchar (27);
    putchar ('t');
    putchar ('1');

    /* jeu de caractres amricain */
    putchar (27);
    putchar ('R');
    putchar (0);

    /* taille des interlignes */
    putchar (27);
    putchar ('3');
    putchar (interligne * 3);

    /* longueur des pages */
    putchar (27);
    putchar ('C');
    putchar (0);
    putchar (page);

    /* taille des caractres */
    putchar (27);
    majtaille (taille);

    /* fonte de caractre */
    putchar (27);
    majfonte (fonte);

    /* style des caractres */
    putchar (27);
    putchar ('q');
    putchar (0);
    
    /* impression des fichiers */
    do
    {
        if (narg > 0)
        {
            if (freopen (*varg, "rb", stdin) == 0)
                fprintf (stderr, "Fichier %s inexistant\n", *varg);
        }

        car = getchar ();

        while (car != EOF)
        {
            putchar (car);

            if (car == 27)
                traitescape ();

            car = getchar ();
        }

        /* saut de page en fin de fichier */
        putchar (10);
        putchar (12);

        *varg++;
        narg--;
    }
    while (narg > 0);
    putchar (10);
}


psyntaxe ()
{
    fprintf (stderr, "Syntaxe : lp [-(f<val>|i<val>|p<val>|t<val>]* <liste de fichiers>\n");
    exit ();
}


getval (valeur, max)
octet *valeur, max;
{
    octet val, option;

    val = 0;
    option = *carg;
    carg++;

    while ((*carg >= '0') && (*carg <= '9'))
    {
        val = (val * 10) + (*carg - '0');
        carg++;
    }

    if (val > max)
        fprintf (stderr, "Valeur maximale pour l'option %c : %d\n",
                                                      option, max);
    else if (val > 0)
        *valeur = val;
}


majtaille (taille)
octet taille;
{
    if ((taille <= 6))
    {
        etat = (etat & 218) | ptaille [taille];

        putchar ('!');
        putchar (etat);
    }
}


majfonte (fonte)
octet fonte;
{
    putchar ('x');

    if (fonte > 0)
    {
        putchar ('1');

        putchar (27);
        putchar ('k');
        putchar (fonte & 3);
    }
    else
        putchar ('0');
}


traitescape ()
{
    octet majcf;
    octet couleur;
    octet style;

    majcf = 1;

    car = getchar ();

    switch (car)
    {
        case '-' : car = getchar ();
                   switch (car)
                   {
                       case '_' : etat = etat & 0x7F;
                                  break;

                       case '/' : etat = etat & 0xBF;
                                  break;

                       case '>' : etat = etat & 0xDF;
                                  break;

                       case '<' : etat = etat & 0xFB;
                                  break;

                       case 'd' : etat = etat & 0xEF;
                                  break;

                       case 'g' : etat = etat & 0xF7;
                                  break;

                       case 'q' : puts ("x0");
                                  majcf = 0;
                                  break;

                       case '^' : puts ("~10");
                                  majcf = 0;
                                  break;

                       case '\'':
                       case '.' : puts ("T");
                                  majcf = 0;
                                  break;
                   }
                   break;

        case '_' : etat = etat | 0x80;
                   break;

        case '/' : etat = etat | 0x40;
                   break;

        case '>' : etat = etat | 0x20;
                   break;

        case '<' : etat = etat | 0x04;
                   break;

        case 'd' : etat = etat | 0x10;
                   break;

        case 'g' : etat = etat | 0x08;
                   break;

        case 't' : car = getchar ();
                   if ((car >= '0') && (car <= '6'))
                       etat = (etat & 0xDA) | ptaille [car - '0'];
                   break;

        case 'i' : car = getchar ();
                   if (car >= '0' && car <= '9')
                   {
                       interligne = car - '0';
                       if (interligne <= 3)
                       {
                           car = getchar ();
                           if (car >= '0' && car <= '9')
                               interligne = (interligne * 10) + car - '0';
                       }
                       putchar ('3');
                       putchar (interligne * 3);
                       majcf = 0;
                   }
                   break;

        case 'f' : fonte = getchar () - '0';
                   majfonte (fonte);
                   majcf = 0;
                   break;

        case 'q' : puts ("x1");
                   majcf = 0;
                   break;

        case 's' : style = getchar () & 3;
                   putchar ('q');
                   putchar (style);
                   majcf = 0;
                   break;

        case '^' : puts ("~11");
                   majcf = 0;
                   break;

        case '\'': puts ("S0");
                   majcf = 0;
                   break;

        case '.' : puts ("S1");
                   majcf = 0;
                   break;

        case 'c' : putchar ('r');
                   car = getchar ();
                   couleur = 7;
                   switch (car)
                   {
                       case 'n' : couleur--;
                       case 'm' : couleur--;
                       case 'c' : couleur--;
                       case 'b' : couleur--;
                       case 'j' : couleur--;
                       case 'r' : couleur--;
                       case 'v' : couleur--;
                       default  : putchar (couleur);
                   }
                   majcf = 0;
                   break;

        default  : putchar (car);
                   majcf = 0;
    }

    if (majcf == 1)
    {
        putchar ('!');
        putchar (etat);
    }
}
