#include <stdio.h>
#include <dir.h>
#include <alloc.h>

/* taille d'un nom de fichier */
#define szmemo    13    /* en octets */

/* position maximale du dernier caractre d'un nom de fichier */
#define dercarfic   szmemo - 1

/* taille d'un nom de rpertoire en octets */
#define nbcardir  12

/* nombre de noms de fichiers par ligne */
#define szligne    5


/* description du nom d'un fichier */
typedef char descfic [szmemo];

/* description du nom de rpertoire */
typedef char nomdir [nbcardir];


/* table des noms de fichier */
static struct ffblk fich;

/* pointeurs sur les lments de la table de description des fichiers */
static char *attrib, *nomfich;

/* indicateur : liste des fichiers entirement consulte ? */
static int trouve;

/* nombre de fichiers mmoriss */
static int nbfic = 0;

/* indicateur de debordement de la liste */
static int deborde = 0;

/* nombre maximun de fichiers mmoriss */
static int szliste;

/* pointeur sur la liste des fichiers mmoriss */
unsigned descfic *listefic;

/* adresse de la fin de la liste des fichiers mmoriss */
unsigned descfic *finliste;

/* nom du fichier  diter */
static char nfichier [szmemo + 1];

/* chemins d'accs aux fichiers du rpertoire slectionn */
char chemin [256];

/* nombre de noms de fichiers dj dits dans la ligne courante */
static char poslig = 0;

/* programme principal */
main (narg, varg)
int narg;
char *varg [];
{
    /* dernier caractre d'un nom pass en paramtre */
    char *dercar;

    /* taille de la zone mmoire allouee */
    unsigned szmem;


    /* estimation de la taille mmoire que l'on peut affecter  la liste */
    /* les 500 octets restants autorisent de 30 niveaux de sous rpertoire */
    szmem = coreleft () - 500;

    /* allocation de la liste des fichiers mmoriss */
    listefic = malloc (szmem);

    /* calcul de l'adresse de fin de liste */
    /* le message d'avertissement  la compilation est acceptable */
    finliste = (unsigned) listefic + szmem;

    /* initialisation des pointeurs sur la table de description des fichiers */
    attrib  = &fich.ff_attrib;
    nomfich = fich.ff_name;

    /* calcul du nombre de paramtres de la commande */
    narg--;

    /* si des noms de fichier ou de rpertoire ont t passs en paramtre */
    if (narg > 0)
    {
        /* tant que tous les paramtres n'ont pas t traits */
        while (narg -- > 0)
        {
            /* se positionner sur le premier paramtre non trait */
            varg++;

            /* on considre qu'il s'agit d'un rpertoire
               fabriquer le chemin d'accs aux lments de ce rpertoire */
            dercar = *varg + strlen (*varg) - 1;

            if (*dercar == '/' || *dercar == '\\')
                sprintf (chemin, "%s*.*", *varg);
            else
                sprintf (chemin, "%s/*.*", *varg);

            /* rcuprer les caractristiques du
               premier fichier du rpertoire */
            trouve = findfirst (chemin, &fich, 0xFF);

            /* si fichier trouv */
            if (trouve != -1)
            {
                /* afficher la liste des fichiers dj mmoriss */
                if (nbfic != 0)
                {
                    putchar ('\n');
                    affliste ();
                    nbfic = 0;
                }

                /* diter le chemin d'accs au rpertoire */
                printf ("\n%s:\n", *varg);

                /* traiter l'ensemble des fichiers du rpertoire */
                lisdir ();
            }
            else
            {
            /* sinon chercher si le paramtre correspond  un nom de fichier */
                trouve = findfirst (*varg, &fich, 0xFF);

                /* si fichier trouv */
                if (trouve != -1)
                    /* mmoriser son nom */
                    memo ();

                /* sinon, message d'erreur */
                else
                    fprintf (stderr, "%s : inexistant\n", *varg);
            }
        }

        /* afficher la liste des derniers fichiers mmoriss */
        if (nbfic != 0)
        {
            putchar ('\n');
            affliste ();
            nbfic = 0;
        }
    }
    /* sinon  (commande lance sans paramtres) */
    else
    {
        /* traiter les fichiers du rpertoire courant */
        strcpy (chemin, "*.*");
        trouve = findfirst (chemin, &fich, 0xFF);
        lisdir ();
    }
}


/* mmorisation de l'ensemble des fichiers du rpertoire slectionn */
lisdir ()
{
    /* calculer la taille maximale de la liste de fichiers */
    szliste = ((unsigned) finliste - (unsigned) listefic) / szmemo;

    /* rpter */
    do
    {
        /* mmoriser le nom du fichier courant */
        if ((fich.ff_attrib & 0x0F) != 0x0F)
            memo ();

        /* chercher le fichier suivant */
        trouve = findnext (&fich);
    }
    /* jusque plus de fichier trouv */
    while (trouve != -1);

    /* afficher la liste des fichiers mmoriss */
    affliste ();

    /* traiter de la mme faon les sous rpertoires */
    sousdir ();
}

/* mmorisation du nom d'un fichier */
memo ()
{
    /* position dans la liste des fichiers */
    int i;

    /* rsultat d'une comparaison entre 2 noms de fichier */
    int ordre;

    /* nom du fichier courant */
    descfic curfic;


    /* traitement de l'attribut du fichier */
    trtattrib ();

    /* recopier dans curfic le nom du fichier  mmoriser */
    memcpy (curfic, nomfich, szmemo);

    /* si la liste des fichiers est pleine */
    if (nbfic == szliste)
    {
        /* message d'erreur ventuel */
        if (deborde == 0)
        {
            fprintf (stderr, "Trop de fichier, ordre non respecte\n");
            deborde = 1;
        }

        /* initialisation */
        i = 0;

        /* tantque le ime fichier de la liste est un rpertoire */
        while (listefic [i][dercarfic] & 1)
        {
            /* passer au fichier suivant */
            i++;

            /* termin si liste explore en entier */
            if (i == szliste)
            {
                affliste ();

                fprintf (stderr, "Manque de mmoire, exploration interrompue\n");

                exit ();
            }
        }

        /* diter le nom du fichier slectionn */
        affiche (i);

        /* le supprimer de la liste */
        memmove (listefic [i], listefic [i + 1], (nbfic - i - 1) * szmemo);

        /* la liste n'est plus pleine */
        nbfic --;
    }

    /* initialisation */
    i = 0;
    ordre = 1;

    /* chercher avant quel fichier de la liste
       le fichier courant doit tre insr */
    while ((i < nbfic) && (ordre == 1))
        ordre = compar (curfic, listefic [i++]);

    /* si on n'est pas arriv en fin de liste */
    if (ordre == -1)
    {
         /* se positionner sur le premier fichier  deplacer */
         i--;

         /* dcaler les derniers fichiers de la liste d'une position */
         memmove (listefic [i + 1], listefic [i], (nbfic - i) * szmemo);
    }

    /* mmoriser le fichier courant dans la liste */
    memcpy (listefic [i], curfic, szmemo);

    /* mise  jour du nombre de fichiers de la liste */
    nbfic++;
}

/* traitement de l'attribut du fichier courant */
trtattrib ()
{
    /* position dans le nom de fichier */
    char i;

    /* caractres aprs le nom de fichier */
    char finfic;


    /* se positionner  la fin du nom de fichier */
    for (i = 1; (i < szmemo) && (nomfich [i] != 0); i++);

    /* traitement de l'attribut rpertoire */
    if (*attrib & 0x10)
        nomfich [i++] = '/';

    /* traitement des autres attributs */
    if (*attrib & 0x06)
        finfic = 0xF0;
    else if (*attrib & 0x08)
        finfic = 0xB0;
    else
        finfic = ' ';

    /* on complte le nom du fichier  13 caractres */
    while (i < szmemo)
        nomfich [i++] = finfic;

    /* pose d'un marqueur si le fichier est un rpertoire */
    if (*attrib & 0x10)
        nomfich [dercarfic] = nomfich [dercarfic] | 1;
}


/* comparaison de 2 noms de fichier */
int compar (x, y)
unsigned char x[], y[];
{
    /* position dans le nom de fichier */
    int i;

    /* rsultat de la comparaison de 2 caractres */
    int ordre = 0;


    /* comparaison des caractres constituant les noms de fichier */
    for (i = 0; ((i < szmemo) && (ordre == 0)); i++)
        if (x [i] != y [i])
            if (x [i] > y [i])
                ordre = 1;
            else
                ordre = -1;

    /* retourner le rsultat de la comparaison */
    return (ordre);
}

/* dition de la liste des fichiers mmoriss */
affliste ()
{
    /* position dans la liste */
    int i;


    /* initialisation */
    nfichier [szmemo] = 0;

    /* pour tous les fichiers de la liste */
    for (i = 0; i < nbfic; i++)
        /* editer le nom du fichier courant */
        affiche (i);

    /* passage  la ligne */
    putchar ('\n');

    /* rinitialisation */
    poslig = 0;
    deborde = 0;
}


/* dition du nom du (n + 1)ime fichier de la liste */
affiche (n)
int n;
{
    /* rcuprer le nom de fichier */
    memcpy (nfichier, &listefic [n], szmemo);

    /* suppression du marqueur de rpertoire ventuel */
    if ((nfichier [dercarfic] & 1) && (nfichier [dercarfic] != '/'))
        nfichier [dercarfic] = nfichier [dercarfic] & 0xFE;

    /* passage  la ligne ventuel */
    if (poslig++ == szligne)
    {
        putchar ('\n');
        poslig = 1;
    }

    /* criture de caractres blancs ventuels */
    if (poslig > 1)
        printf ("   ");

    /* diter le nom de fichier */
    printf ("%s", nfichier);
}

/* traitement des sous rpertoires */

/* afin d'optimiser l'utilisation de la mmoire, ce sous programme utilise :

   - la mme variable statique pour mmoriser tous les chemins d'accs de
     l'arborescence

   - les premiers lments de la liste des fichiers pour mmoriser les noms
     des sous rpertoires  explorer

   de ce fait, les messages d'avertissement concernant les manipulations
   d'adresses sont normaux
*/

sousdir ()
{
    /* nombre de sous rpertoires */
    unsigned nbsdir;

    /* liste des sous rpertoires */
    nomdir *listedir;

    /* taille du chemin d'accs au rpertoire  explorer */
    unsigned char szchemin;

     /* position dans la liste des noms de fichiers */
    int i;
    char j;


    /* initialisation */
    nbsdir = 0;
    listedir = listefic;

    /* calculer la taille du chemin d'accs au rpertoire  explorer */
    szchemin = strlen (chemin) - 3;

    /* rcupration des noms de sous rpertoires */
    for (i = 0; i < nbfic; i++)
    {
        /* si on est sur un sous rpertoire */
        if (listefic [i][dercarfic] & 1)
        {
            /* supprimer le '/' dans son nom */
            for (j = 1; j <= nbcardir; j++)
                if (listefic [i][j] == '/')
                    listefic [i][j] = 0;

            /* si le rpertoire n'est ni '.' ni '..'  le mmoriser */
            if (strcmp (listefic [i], ".") != 0
                                && strcmp (listefic [i], "..") != 0)
                memcpy (listedir [nbsdir++], listefic [i], nbcardir);
        }
    }

    /* calculer la nouvelle adresse de listefic */
    listefic = listedir [nbsdir];

    /* Pour chaque rpertoire mmoris */
    for (i = 0; i < nbsdir; i++)
    {
        /* initialisation */
        nbfic = 0;

        /* rcuprer un nom de rpertoire */
        memcpy (nfichier, listedir [i], nbcardir);
        nfichier [nbcardir] = 0;

        /* fabriquer le chemin d'accs au rpertoire */
        strcpy (&chemin [szchemin], nfichier);

        /* diter ce chemin d'accs */
        printf ("\n%s:\n", chemin);

        /* fabriquer le chemin d'accs aux lments du rpertoire */
        strcat (chemin, "/*.*");

        /* rcuprer les caractristiques du premier fichier du rpertoire */
        trouve = findfirst (chemin, &fich, 0xFF);

        /* explorer le rpertoire et les sous rpertoires qu'il contient */
        lisdir ();
    }

    /* librer l'espace mmoire occupe par la liste de rpertoires */
    listefic = listedir;
    nbfic = 0;
}