#include <stdio.h>
#include <dir.h>
#include <alloc.h>

/* taille d'une description des caractristiques d'un fichier */
#define szmemol    6    /* en long entiers */
#define szmemo    24    /* en octets */

/* taille (en octets) d'un nom de fichier */
#define sznfic    13

/* position des caractristiques d'un fichier dans une table */
#define posdate    4
#define postaille  5

#define posattrib sznfic + 1  /* position en octets */

/* droits possibles pour un fichier */
char droitclair [] = "adlshp";


/* description des caractristiques d'un fichier */
typedef unsigned long descfic [szmemol];

/* table de description des fichiers */
static struct ffblk fich;

/* pointeurs sur les lments de la table de description des fichiers */
static char *attrib, *nomfich;
static unsigned int *datheure;
static long *taille;

/* indicateur : liste des fichiers entirement consulte ? */
static int trouve;

/* nombre de fichiers mmoriss */
static int nbfic = 0;

/* indicateur de debordement de la liste */
static int deborde = 0;

/* nombre maximun de fichiers mmoriss */
static int szliste;

/* pointeur sur la liste des fichiers mmoriss */
unsigned descfic *listefic;

/* nom du fichier  diter */
static char nfichier [sznfic + 1];


/* programme principal */
main (narg, varg)
int narg;
char *varg [];
{
    /* chemins d'accs aux fichiers du rpertoire slectionn */
    char chemin [256];

    /* dernier caractre d'un nom pass en paramtre */
    char *dercar;


    /* initialisation du nombre maximal d'lments de la liste */
    szliste = (coreleft () - 100) / szmemo;

    /* allocation de la liste des fichiers mmoriss */
    listefic = malloc (szliste * szmemo);

    /* initialisation des pointeurs sur la table de description des fichiers */
    attrib   = &fich.ff_attrib;
    nomfich  = fich.ff_name;
    datheure = &fich.ff_ftime;
    taille   = &fich.ff_fsize;

    /* calcul du nombre de paramtres de la commande */
    narg--;

    /* si des noms de fichier ou de rpertoire ont t passs en paramtre */
    if (narg > 0)
    {
        /* tant que tous les paramtres n'ont pas t traits */
        while (narg -- > 0)
        {
            /* se positionner sur le premier paramtre non trait */
            varg++;

            /* on considre qu'il s'agit d'un rpertoire
               fabriquer le chemin d'accs aux lments de ce rpertoire */
            dercar = *varg + strlen (*varg) - 1;

            if (*dercar == '/' || *dercar == '\\')
                sprintf (chemin, "%s*.*", *varg);
            else
                sprintf (chemin, "%s/*.*", *varg);

            /* rcuprer les caractristiques du
               premier fichier du rpertoire */
            trouve = findfirst (chemin, &fich, 0xFF);

            /* si fichier trouv */
            if (trouve != -1)
            {
                /* afficher la liste des fichiers dj mmoriss */
                if (nbfic != 0)
                {
                    putchar ('\n');
                    affliste ();
                }

                /* diter le chemin d'accs au rpertoire */
                printf ("\n%s:\n", *varg);

                /* traiter l'ensemble des fichiers du rpertoire */
                lisdir ();
            }
            else
            {
            /* sinon chercher si le paramtre correspond  un nom de fichier */
                trouve = findfirst (*varg, &fich, 0xFF);

                /* si fichier trouv */
                if (trouve != -1)
                    /* mmoriser ses caractristiques */
                    memo ();

                /* sinon, message d'erreur */
                else
                    fprintf (stderr, "%s : inexistant\n", *varg);
            }
        }

        /* afficher la liste des derniers fichiers mmoriss */
        if (nbfic != 0)
        {
            putchar ('\n');
            affliste ();
        }
    }
    /* sinon  (commande lance sans paramtres) */
    else
    {
        /* traiter les fichiers du rpertoire courant */
        trouve = findfirst ("*.*", &fich, 0xFF);
        lisdir ();
    }
}


/* mmorisation de l'ensemble des fichiers du rpertoire slectionn */
lisdir ()
{
    /* rpter */
    do
    {
        /* mmoriser les caractristiques du fichier courant */
        if ((fich.ff_attrib & 0x0F) != 0x0F)
            memo ();

        /* chercher le fichier suivant */
        trouve = findnext (&fich);
    }
    /* jusque plus de fichier trouv */
    while (trouve != -1);

    /* afficher la liste des fichiers mmoriss */
    affliste ();
}

memo ()
{
    /* position dans la liste des fichiers */
    int i;

    /* nom du fichier courant */
    descfic curfic;


    /* traitement de l'attribut du fichier */
    trtattrib ();

    /* recopier dans curfic le nom du fichier  mmoriser */
    memcpy (curfic, nomfich, sznfic);

    /* recopier l'attribut */
    memcpy ((char *) curfic + posattrib, attrib, 1);

    /* recopier l'heure et la date de mise  jour du fichier */
    memcpy (&curfic [posdate], datheure, 4);

    /* recopier la taille du fichier */
    curfic [postaille] = *taille;

    /* si la liste des fichiers est pleine */
    if (nbfic == szliste)
    {
        /* message d'erreur eventuel */
        if (deborde == 0)
        {
            fprintf (stderr, "Trop de fichier, ordre non respecte\n");
            deborde = 1;
        }

        /* editer et supprimer le premier fichier de la liste */
        affiche (0);
        memmove (*listefic, listefic [1], (nbfic - 1) * szmemo);

        /* la liste n'est plus pleine */
        nbfic --;
    }

    /* chercher avant quel fichier de la liste
       le fichier courant doit tre insr */
    for (i = 0; (i < nbfic) && (curfic [posdate] >= listefic [i][posdate]); i++);

    /* dcaler les derniers fichiers de la liste d'une position */
    memmove (listefic [i + 1], listefic [i], (nbfic - i) * szmemo);

    /* mmoriser le fichier courant dans la liste */
    memcpy (listefic [i], curfic, szmemo);

    /* mise  jour du nombre de fichiers de la liste */
    nbfic++;
}

/* traitement de l'attribut du fichier courant */
trtattrib ()
{
    /* position dans le nom de fichier */
    char i;

    /* caractres aprs le nom de fichier */
    char finfic;


    /* se positionner a la fin du nom de fichier */
    for (i = 1; (i < sznfic) && (nomfich [i] != 0); i++);

    /* traitement de l'attribut rpertoire */
    if (*attrib & 0x10)
        nomfich [i++] = '/';

    /* traitement des autres attributs */
    if (*attrib & 0x06)
        finfic = 0xF0;
    else if (*attrib & 0x08)
        finfic = 0xB0;
    else
        finfic = ' ';

    /* on complte le nom du fichier  13 caractres */
    while (i < sznfic)
        nomfich [i++] = finfic;
}

/* dition de la liste des fichiers mmoriss */
affliste ()
{
    /* position dans la liste */
    int i;

    /* initialisation */
    nfichier [sznfic] = 0;

    /* pour tous les fichiers de la liste */
    for (i = 0; i < nbfic; i++)
        /* editer les caractristiques du fichier courant */
        affiche (i);

    /* reinitialisation */
    nbfic   = 0;
    deborde = 0;
}


/* dition des caractristiques du (n + 1)ime fichier de la liste */
affiche (n)
int n;
{
    /* date et heure de mis  jour */
    unsigned char jour, mois, an, heure, min, sec;
    unsigned long datetime;       /* date et heure en format interne */
    int masque;
    int i;


    /* rcuprer le nom de fichier */
    memcpy (nfichier, &listefic [n], sznfic);

    /* rcuprer la date et l'heure en format interme */
    datetime = listefic [n][posdate];

    /* extraire la date de dernire mise  jour du fichier */
    jour = (datetime >> 16) & 0x1F;
    mois = (datetime >> 21) & 0x0F;
    an   = (datetime >> 25) + 80;

    /* mise  jour de l'anne  partir de l'an 2000 */
    if (an > 99)
        an -= 100;

    /* extraire l'heure de dernire mise  jour du fichier */
    heure = (datetime >> 11) & 0x1F;
    min  = (datetime >> 5) & 0x3F;
    sec  = (datetime << 1) & 0x3F;

    /* rcuprer l'attribut */
    memcpy (attrib, (char *) listefic [n] + posattrib, 1);

    /* diter les caractristiques du fichier */
    printf ("%s%9lu    %02d/%02d/%02d  %02d:%02d:%02d    ",
         nfichier, listefic [n][postaille], jour, mois, an, heure, min, sec);

    /* dtail de l'attribut compris */
    i = 0;

    for (masque = 0x20; masque != 0; masque = masque >> 1)
    {
        if (*attrib & masque)
            putchar (droitclair [i]);
        else
            putchar ('-');

        i++;
    }

    putchar ('\n');
}
