#include <stdio.h>
#include <dos.h>

#define dirconf  "c:/config"      /* fichier permettant la correction */
#define fichier  dirconf"/heure"  /* automatique de l'heure du calculateur */

#define int32    unsigned long


/* nouvelle heure saisie par l'oprateur */
static char nouv_heure, nouv_min, nouv_sec;

/* date et heures courantes */
static struct date jour;
static struct time heure;

/* contenu du fichier heure */
static int32  dern_maj_man;
static long   taux_deviation;
static short  decal_depuis_maj;

/* descripteur du fichier heure */
static FILE   *adrfic;


/* prototype de fonction dclare plus bas */
int32 heure_absolue ();

main (narg, varg)
int narg;
char *varg [];
{
    if (narg == 1)
    {
        if (access (fichier, 0) == 0)
            majauto ();
    }
    else if (narg == 3 || narg == 4)
    {
        nouv_heure = valeur (varg [1]);

        if (nouv_heure > 23)
            psyntaxe ();

        nouv_min = valeur (varg [2]);

        if (narg > 3)
            nouv_sec = valeur (varg [3]);
        else
            nouv_sec = 0;

        majmanuelle ();
    }
    else if (narg == 2 && strcmp (varg [1], "-l") == 0)
        etatmaj ();
    else
        psyntaxe ();
}



int valeur (chaine)
char *chaine;
{
    int val;


    val = 0;

    while ('0' <= *chaine && *chaine <= '9')
    {
        val = (val * 10) + (*chaine & 0x0f);
        chaine ++;
    }

    if (*chaine != 0 || val > 59)
        psyntaxe ();

    return (val);
}

/* Remise  l'heure automatique */
majauto ()
{
    int32 maintenant;
    int32 depuis_maj;
    long  deviation;
    short delta;


    lirefic_heure ();

    if (taux_deviation != 0)
    {
        maintenant = heure_absolue ();
        depuis_maj = maintenant - dern_maj_man;

        /* calcul de la dviation */
        if (taux_deviation > 0)
            deviation = (((long) (depuis_maj * 2) / taux_deviation) + 1) / 2;
        else
            deviation = (((long) (depuis_maj * 2) / taux_deviation) - 1) / 2;

        if (deviation != decal_depuis_maj)
        {
            delta = deviation - decal_depuis_maj;   /* delta != 0 */

            if (-3000 < delta && delta < 3000)
            {
                gettime (&heure);   /* pour masquer les temps de calcul */

                heure.ti_sec = heure.ti_sec + (delta % 60);
                heure.ti_min = heure.ti_min + (delta / 60);

                if (heure.ti_sec < 0)
                {
                    heure.ti_sec = heure.ti_sec + 60;
                    heure.ti_min --;
                }
                else if (heure.ti_sec >= 60)
                {
                    heure.ti_sec = heure.ti_sec - 60;
                    heure.ti_min ++;
                }

                if (heure.ti_min < 0)
                {
                    heure.ti_min = heure.ti_min + 60;
                    heure.ti_hour --;
                }
                else if (heure.ti_min >= 60)
                {
                    heure.ti_min = heure.ti_min - 60;
                    heure.ti_hour ++;
                }

                if (0 <= heure.ti_hour && heure.ti_hour <= 23)
                {
                    settime (&heure);

                    decal_depuis_maj = deviation;

                    majfic_heure ();
                }
            }
            else
            {
                puts ("La correction de l'heure serait trop importante");
                puts ("Faire une mise  jour manuelle avec majheure");
            }
        }
    }
}

/* Mise  l'heure manuelle et calcul de la dviation de l'horloge */
majmanuelle ()
{
    int32 avant_maj, maj_precedente;
    long  delai_2maj, decal_2maj;


    if (access (fichier, 0) == 0)
    {
        lirefic_heure ();

        avant_maj = heure_absolue ();

        heure.ti_hour = nouv_heure;
        heure.ti_min  = nouv_min;
        heure.ti_sec  = nouv_sec;
        heure.ti_hund = 40;      /* pour compenser le temps de traitement */

        settime (&heure);

        maj_precedente = dern_maj_man;

        dern_maj_man = heure_absolue ();

        delai_2maj = dern_maj_man - maj_precedente;
        decal_2maj = decal_depuis_maj + dern_maj_man - avant_maj;

        if (decal_2maj != 0)
            taux_deviation = delai_2maj / decal_2maj;
        else
            taux_deviation = 0;
    }
    else
    {
        heure.ti_hour = nouv_heure;
        heure.ti_min  = nouv_min;
        heure.ti_sec  = nouv_sec;
        heure.ti_hund = 30;      /* pour compenser le temps de traitement */

        settime (&heure);

        dern_maj_man = heure_absolue ();
        taux_deviation = 0;
    }

    decal_depuis_maj = 0;

    majfic_heure ();
}

/* Edite les informations mmorises dans le fichier heure */
etatmaj ()
{
    if (access (fichier, 0) == 0)
    {
        lirefic_heure ();

        printf ("La dernire mise  l'heure manuelle date de");
        affdelta (heure_absolue () - dern_maj_man, 0);

        if (decal_depuis_maj != 0)
        {
            printf ("depuis, l'horloge a t ");

            if (decal_depuis_maj > 0)
                printf ("avance de");
            else
                printf ("retarde de");

            affdelta ((long) decal_depuis_maj, 1);
            putchar ('\n');
        }
        else
            puts ("aucune remise  l'heure automatique n'a eu lieu depuis");

        if (taux_deviation != 0)
        {
            printf ("L'horloge interne du calculateur ");

            if (taux_deviation > 0)
                printf ("retarde");
            else
            {
                printf ("avance");
                taux_deviation = -taux_deviation;
            }

            printf (" d'une seconde\n");

            if (taux_deviation >= 86400)
                printf ("tous les");
            else
                printf ("toutes les");

            affdelta (taux_deviation, 1);

            if (taux_deviation >= 3600)
                putchar (10);
            else
                puts ("!!!");
        }
        else
            puts ("Aucune dviation d'horloge n'a encore t mesure");
    }
    else
        puts ("L'heure n'a pas encore t initialise avec majheure");
}

/* Sous programme d'dition de etatmaj */
affdelta (decalage, affsec)
long decalage;
int  affsec;
{
    int jours, heures, min, sec;


    if (decalage < 0)
        decalage = -decalage;

    jours  = decalage / 86400;
    heures = (decalage % 86400) / 3600;
    min    = (decalage % 3600) / 60;
    sec    = decalage % 60;

    if (jours > 0)
        affval (jours, "jour", ',');

    if (decalage >= 3600)
        affval (heures, "heure", ',');

    if (affsec == 1)
    {
        if (decalage >= 60)
            affval (min, "minute", ',');

        affval (sec, "seconde", ' ');
    }
    else
        affval (min, "minute", '\n');
}



/* Sous programme d'dition de affdelta */
affval (valeur, unite, carfin)
int  valeur;
char *unite;
char carfin;
{
    printf (" %d %s", valeur, unite);

    if (valeur != 1)
        putchar ('s');

    putchar (carfin);
}

psyntaxe ()
{
    fputs ("Syntaxe : majheure <heure> <minutes> [<secondes>]\n", stderr);
    fputs ("   ou     majheure      (mise  l'heure automatique)\n", stderr);
    fputs ("   ou     majheure -l   (dition dviation horloge)\n", stderr);
    exit ();
}



/* calcule le nombre de secondes coules
   depuis un instant de rfrence en 1980 */
int32 heure_absolue ()
{
    int mois, an;
    long numjour, numsec;


    /* rcuprer la date et l'heure courantes */
    getdate (&jour);
    gettime (&heure);

    an   = jour.da_year - 1980;
    mois = jour.da_mon - 2;

    if (mois <= 0)
    {
        mois = mois + 12;
        an = an - 1;
    }

    numjour = jour.da_day + (mois * 30) + (mois * 10 / 17)
                                        + (an * 365) + (an / 4);
    /* quivalent a : jour.da_day + (mois * 30.59) + (an * 365.25)
       sans utiliser l'arithmtique flotante qui augmenterait
       fortement la taille de l'excutable */

    numsec  = ((long) heure.ti_hour * 3600) + (heure.ti_min * 60)
                                            + heure.ti_sec;

    return ((numjour * 86400) + numsec);
}

/* Lecture du fichier heure */
lirefic_heure ()
{
    short der_valeur;


    adrfic = fopen (fichier, "rb");

    if (adrfic != 0)
    {
        fread (&dern_maj_man,     4, 1, adrfic);
        fread (&taux_deviation,   4, 1, adrfic);
        fread (&decal_depuis_maj, 2, 1, adrfic);

        /* pour assurer la compatibilit avec l'ancienne version de majheure */
        if (fread (&der_valeur, 2, 1, adrfic) == 1)
        {
            if (decal_depuis_maj != 0)
            {
                taux_deviation = taux_deviation / decal_depuis_maj;
                decal_depuis_maj = der_valeur;
            }

            if (getc (adrfic) != EOF)
            {
                fputs ("Structure du fichier heure incorrecte\n", stderr);
                exit ();
            }
        }

        fclose (adrfic);
    }
}



/* Mise  jour du fichier heure */
majfic_heure ()
{
    if (access (dirconf, 0) != 0)
        mkdir (dirconf);

    adrfic = fopen (fichier, "wb");

    if (adrfic != 0)
    {
        fwrite (&dern_maj_man,     4, 1, adrfic);
        fwrite (&taux_deviation,   4, 1, adrfic);
        fwrite (&decal_depuis_maj, 2, 1, adrfic);

        fclose (adrfic);
    }
    else
    {
        fputs ("Problme d'accs au fichier "fichier, stderr);
        unlink (fichier);
    }
}