/* Dtecte les lignes suplmentaires du fichier 2 par rapport au fichier 1 */

#include <stdio.h>

#define MAXLIG 256

#define TAB   9
#define CTRZ 26


static char optd = 0;              /* slection de l'option -d */
static char optt = 0;              /* slection de l'option -t */

static char ligne1 [MAXLIG],       /* ligne courante du fichier 1 */
            ligne2 [MAXLIG];       /* ligne courante du fichier 2 */
static int  szlig1, szlig2;        /* taille des lignes */
static unsigned int numl1, numl2;  /* numro de la ligne courante */
static unsigned int maxdiff;       /* nombre maximum de diffrences */

FILE *fic1, *fic2;                 /* descripteurs des fichiers */


main (narg, varg)
int narg;
char *varg [];
{
    /* se positionner sur le premier argument */
    varg++;
    narg--;

    /* initialisation */
    numl1 = 0;
    numl2 = 0;
    maxdiff = 20;

    /* rcupration des options */
    while (**varg == '-')
    {
        if (strcmp (*varg, "-t") == 0)
            optt = 1;

        else if (strcmp (*varg, "-c") == 0)
            maxdiff = 0xFFFF;

        else if (strcmp (*varg, "-d") == 0)
            optd = 1;

        else if (atoi (*varg) < 0)
            maxdiff = -atoi (*varg);

        else
        {
            /* option inconnue */
            psyntaxe ();
            exit ();
        }

        /* passage  l'argument suivant */
        varg++;
        narg--;
    }

    /* si nombre d'arguments correct */
    if (narg == 2)
    {
        /* prendre en compte l'option -d */
        if (optd)
        {
            /* rajouter le nom de fichier  l'argument 1 */
            *(varg [1] - 1) = '/';

            /* supprimer le / en trop si ncessaire */
            if (*(varg [1] - 2) == '/' || *(varg [1] - 2) == '\\')
            {
                strcpy (varg [1] - 1, varg [1]);
                varg [1] = varg [1] - 1;
            }
        }

        /* ouvrir les fichiers */
        fic1 = fopen (varg [0], "rb");

        if (fic1 <= 0)
        {
            fprintf (stderr, "%s : inexistant\n", varg [0]);
            exit ();
        }

        fic2 = fopen (varg [1], "rb");

        if (fic2 <= 0)
        {
            fprintf (stderr, "%s : inexistant\n", varg [1]);
            exit ();
        }

        /* comparer les fichiers */
        cmpfic ();
    }
    /* message d'erreur sur le nombre d'arguments */
    else
        psyntaxe ();
}


/* dition de la syntaxe de la commande */
psyntaxe ()
{
    fputs ("Syntaxe : moins [-t] [-c] <fichier 1> <fichier 2>\n", stderr);
    fputs ("     ou : moins [-t] [-c] -d <rpertoire> <nom de fichier>\n", stderr);
}


/* comparaison des fichiers */
cmpfic ()
{
    unsigned int nbdif; /* comptabilise le nombre de diffrences conscutives */


    /* lire la premire ligne des 2 fichiers */
    szlig1 = lect (fic1, ligne1);
    szlig2 = lect (fic2, ligne2);

    /* tantque non fin de fichiers */
    while (szlig1 >= 0 || szlig2 >= 0)
    {
        /* mettre  jour les numros de ligne */
        numl1++;
        numl2++;

        /* comparer les lignes */
        nbdif = cmplig ();

        /* si une diffrence a t trouve */
        if (nbdif > 0)
        {
            /* prciser la ligne o se trouve la diffrence */
            printf ("%u,%u\n", numl1, numl2);

            do
            {
                /* diter les diffrences */
                affligne (ligne2, szlig2, '>');

                /* passer  la ligne suivante du deuxime fichier */
                numl2++;
                szlig2 = lect (fic2, ligne2);
            }
            while (cmplig () > 0 && nbdif++ < maxdiff && szlig2 >= 0);

            /* termin si trop de diffrences */
            if (nbdif > maxdiff)
            {
                printf ("Arrt de la comparaison\n");
                affligne (ligne1, szlig1, '<');
                exit ();
            }
        }

        /* passer  la ligne suivante de chaque fichier */
        szlig1 = lect (fic1, ligne1);
        szlig2 = lect (fic2, ligne2);
    }
}


/* lecture d'une ligne */
int lect (fichier, ligne)
FILE *fichier;
char *ligne;
{
    int car;    /* dernier caractre lu */
    int poslig; /* position dans la ligne */


    /* lire le premier caractre de la ligne */
    car = getc (fichier);

    /* si non fin de fichier */
    if (car == EOF)
        return (-1);
    else
    {
        /* on est en dbut de ligne */
        poslig = 0;

        /* tantque non fin de ligne */
        while (car != '\n' && car != EOF)
        {
            if (poslig < MAXLIG)
            {
                /* mmoriser le dernier caractre lu */
                if (car != TAB || optt == 1)
                    ligne [poslig++] = car;

                /* si pas d'option -t remplacer les tabulations par des blancs */
                else
                    do
                        ligne [poslig++] = ' ';
                    while (poslig % 8 != 0 && poslig < MAXLIG);
            }

            /* lire le caractre suivant */
            car = getc (fichier);
        }

        /* retourner la taille de la ligne lue sans le CR ventuel */
        if (ligne [poslig - 1] != '\r')
            return (poslig);
        else
            return (poslig - 1);
    }
}


/* comparaison de la ligne courante des 2 fichiers */
int cmplig ()
{
    int poslig;  /* position courante dans chaque ligne */

    /* positionnement au dbut de chaque ligne */
    poslig = 0;

    while (poslig < szlig1 && poslig < szlig2)
    {
        /* termin si diffrence trouve */
        if (ligne1 [poslig] != ligne2 [poslig])
            return (1);

        /* passage aux caractres suivants */
        poslig++;
    }

    /* controle suplmentaire en fin de ligne */
    if (poslig < szlig1 || poslig < szlig2)
        return (1);
    else
        return (0);
}


/* dition de la ligne courante passe en paramtre */
affligne (ligne, szlig, sens)
char *ligne;
int  szlig;
char sens;
{
    int poslig;  /* position dans la ligne  diter */


    putchar (sens);
    putchar (' ');

    for (poslig = 0; poslig < szlig; poslig++)
    {
        if (ligne [poslig] != CTRZ)
            putchar (ligne [poslig]);
        else
        {
            putchar ('^');
            putchar ('Z');
        }
    }

    putchar ('\n');
}
