#include <stdio.h>

/* caractere special a editer */
static char angle [64] = {   0, 0xc4, 0xc4, 0xc4, 0xb3, 0xda, 0xbf, 0xc2,
                          0xb3, 0xc0, 0xd9, 0xc1, 0xb3, 0xc3, 0xb4, 0xc5,
                             0, 0xcd, 0xcd, 0xcd, 0xb3, 0xd5, 0xb8, 0xd1,
                          0xb3, 0xd4, 0xbe, 0xcf, 0xb3, 0xc6, 0xb5, 0xd8,
                             0, 0xc4, 0xc4, 0xc4, 0xba, 0xd6, 0xb7, 0xd2,
                          0xba, 0xd3, 0xbd, 0xd0, 0xba, 0xc7, 0xb6, 0xd7,
                             0, 0xcd, 0xcd, 0xcd, 0xba, 0xc9, 0xbb, 0xcb,
                          0xba, 0xc8, 0xbc, 0xca, 0xba, 0xcc, 0xb9, 0xce,
                         };

/* table de selection des caracteres speciaux */
static char selcar [256];

/* dernier caractere lu */
static short int car;

/* taille maximale d'une ligne */
static short int szmax = 255;

/* pointeurs sur la ligne courante et la ligne suivante */
char *linecur, *linesuiv;

/* pointeurs sur les configurations des
  lignes courante, precedente et suivante */
char *lpred, *lcur, *lsuiv, *ltmp;

/* contenu des 2 dernieres lignes lues */
static char ligne [2][256];

/* configuration de la ligne courante et des 2 lignes environnantes */
static char select [3][257];

    /* programme principal */

    main (narg, varg)
    int narg;
    char *varg [];
{   short int i, szligne;
    char *argcur, portee, defopt;

    /* initialisation des pointeurs et de la liste des caracteres speciaux */
    init ();

    /* positionnement sur le 1er argument */
    varg++;

    /* option de selection par defaut */
    defopt = 1;

    /* tantque l'argument courant est une option de selection */
    while (*varg [0] == '-')
    {
        /* recuperer la valeur de l'option */
        argcur = *varg + 1;

        /* si  option indiquant la longueur maximale d'une ligne */
        if ((*argcur >= '0') && (*argcur <= '9'))
        {
            /* recuperation de la longueur maximale de la ligne */
            szmax = atoi (argcur);
        }
        /* sinon on a affaire a une option de selection */
        else
        {
            /* memoriser les directions se
               rapportant a l'option de selection */
            switch (*argcur)
            {
                case 'h' : portee = 1;
                           break;
                case 'v' : portee = 2;
                           break;
                case 'c' : portee = 3;
                           break;
                case 'H' : portee = 5;
                           break;
                case 'V' : portee = 6;
                           break;
                case 'C' : portee = 7;
                           break;
                default  : printf ("Option -%c incorrecte\n", *argcur);
                           exit (0);
            }

            /* annulation de l'option de selection par defaut */
            defopt = 0;

            /* recuperer les caracteres correspondant
               a l'option de selection */
            while (*(++argcur) != 0)
                selcar [*argcur] = selcar [*argcur] | portee;
        }

        /* passer a l'argument suivant */
        varg++;
        narg--;
    }

    /* si option de selection par defaut */
    if (defopt == 1)
    {
        /* selectionner les caracteres par defaut */
        selcar ['-'] = 1;
        selcar ['|'] = 2;
        selcar ['+'] = 3;
        selcar ['='] = 5;
        selcar ['"'] = 6;
        selcar ['#'] = 7;
    }

    /* prise en compte d'un eventuel nom de fichier passe en parametre */
    if (narg > 1)
    {
        if (freopen (*varg, "rb", stdin) == 0)
            fprintf (stderr, "Fichier %s inexistant\n", *varg);
    }

    /* lecture de la premiere ligne du texte */
    lect ();

    /* tantque non fin de fichier faire */
    while (car != -1)
    {
        /* lire une ligne du texte */
        lect ();

        /* recuperation de la taille de la ligne */
        szligne = *linecur & 0xff;

        /* pour tous les caracteres de l'avant derniere ligne lue */
        for (i = 1; i <= szligne; i++)
        {
            /* si le caractere courant n'est pas un caractere special */
            if (lcur [i] == 0)
            {
                /* editer le caractere courant */
                putchar (linecur [i]);
            }
            /* sinon */
            else
            {
                /* editer le caractere graphique correspondant
                   a la configuration autour du caractere courant */
                cargraph (i);
            }
        }

        /* editer un passage a la ligne */
        putchar (10);
    }
}

    /* initialisation des pointeurs et de la liste des caracteres speciaux */

    init ()
{   short int i;

    /* pointeurs sur la configuration de la
       ligne precedente, courante et suivante */
    lpred = &select [0][0];
    lcur  = &select [1][0];
    lsuiv = &select [2][0];

    /* pointeurs sur la ligne courante et la ligne suivante */
    linecur  = &ligne [0][0];
    linesuiv = &ligne [1][0];

    /* initialisation de la liste des caracteres speciaux */
    for (i = 0; i < 256; i++)  selcar [i] = 0;

    /* initialisation des configurations */
    for (i = 0; i < 3; i++)
    {
         select [i][0] = 0;
         select [i][szmax + 1] = 0;
    }
    for (i = 1; i <= szmax; i++)  select [2][i] = 0;
}

    /* lecture de la ligne suivante du texte */

    lect ()
{   short int i, szligne;

    /* decaler les description de configuration des lignes deja lues */
    ltmp = lpred;
    lpred = lcur;
    lcur = lsuiv;
    lsuiv = ltmp;

    /* le derniere ligne lue devient la ligne courante */
    ltmp = linecur;
    linecur = linesuiv;
    linesuiv = ltmp;

    /* initialisation : ligne suivante vide */
    szligne = 0;

    /* lire un caractere */
    car = getchar ();

    /* tantque non fin de ligne et non fin de fichier */
    while ((car != 10) && (car != -1))
    {
        /* memoriser le caractere lu */
        if (szligne < szmax)  linesuiv [++szligne] = car;

        /* lire le caractere suivant */
        car = getchar ();
    }

    /* prise en compte de la taille de la ligne */
    *linesuiv = szligne;

    /* pour tous les caracteres de la ligne lue */
    for (i = 1; i <= szligne; i++)
    {
        /* memoriser la configuration se rapportant au caractere courant */
        lsuiv [i] = selcar [linesuiv [i]];
    }

    /* raz de la configuration de la fin de la ligne */
    while (i <= szmax)  lsuiv [i++] = 0;
}

    /* edition du caractere graphique correspondant a la
       configuration au voisinage du caractere courant */

    cargraph (i)
    short int i;
{
    char directions;


    /* determination de l'influence verticale du caractere courant */
    if (lcur [i] & 2)
        directions = ((lpred [i] != 0) * 8) + ((lsuiv [i] != 0) * 4);
    else
        directions = ((lpred [i] & 2) * 4) + ((lsuiv [i] & 2) * 2);

    /* determination de l'influence horizontale du caractere courant */
    if (lcur [i] & 1)
        directions += ((lcur [i - 1] != 0) * 2) + (lcur [i + 1] != 0);
    else
        directions += ((lcur [i - 1] & 1) * 2) + (lcur [i + 1] & 1);


    /* determination du doublage des traits verticaux */
    if (((lcur [i] & 6) == 6) || (((directions & 3) != 0) &&
       (((lpred [i] & 6) == 6) || ((lsuiv [i] & 6) == 6))))
    {
        directions = directions + 32;
    }

    /* determination du doublage des traits horizontaux */
    if (((lcur [i] & 5) == 5) || (((directions & 12) != 0) &&
       (((lcur [i - 1] & 5) == 5) || ((lcur [i + 1] & 5) == 5))))
    {
         directions = directions + 16;
    }


    /* si le caractere special est isole, on l'edite */
    if ((directions & 0x0f) == 0) putchar (linecur [i]);

    /* sinon on edite le caractere graphique adequat */
    else  putchar (angle [directions]);
}
