#include <stdio.h>
#include <dir.h>

struct ffblk fich;       /* table de description des fichiers */
static char option = 0;  /* prsence de l'option "-n" ou "-y" */


/* extraction du nom de fichier  partir d'un chemin d'accs */
char *basename (chaine)
char *chaine;
{
    char *car,     /* caractre courant dans la chaine */
         *debchn;  /* caractre qui suit le dernier '/' rencontr */

    /* positionnement sur le premier caractre de la chaine */
    car = chaine;
    debchn = car;

    /* tantque chaine non compltement explore */
    while (*car != 0)
    {
        /* si le caractre courant est un '/' ou un '\' */
        if ((*car == '\\') || (*car == '/'))
            /* mmoriser la position du caractre suivant */
            debchn = car + 1;

        /* avancer d'un caractre */
        car++;
    }

    /* retourner la position du dbut du nom de fichier */
    return (debchn);
}


/* programme principal */
main (narg, varg)
int narg;
char *varg [];
{
    char *carg,        /* caractre courant dans un argument */
         *lastarg;     /* dernier argument */
    char newfic [80];  /* nom du nouveau fichier */

    /* positionnement sur le premier argument */
    *varg++;
    narg--;
    carg = *varg;

    /* prise en compte des options "-y" ou "-n" */
    if (*carg == '-')
    {
         carg++;
         *carg = *carg | 0x20;

         if (*carg == 'n')
             option = -1;
         else if (*carg == 'y')
             option = 1;
         else
             fprintf (stderr, "Option %s inconnue\n", *varg);

         /* passage  l'argument suivant */
         *varg++;
         narg--;
    }

    /* controle du nombre d'arguments */
    if (narg < 2)
        psyntaxe ();
    else
    {
        /* rcupration du dernier argument */
        lastarg = *(varg + narg - 1);

        /* traitement particulier du rpertoire racine */
        if (strcmp (lastarg, "/") == 0 || strcmp (lastarg, "\\") == 0)
            lastarg ++;

        /* s'il s'agit d'un rpertoire */
        if ((findfirst (lastarg, &fich, 0xff) == 0 && (fich.ff_attrib & 0x10))
             || *lastarg == 0)
        {
            /* tantqu'il y a des fichiers  dplacer */
            while (--narg > 0)
            {
                /* crer le chemin d'accs au nouveau fichier */
                sprintf (newfic, "%s/%s", lastarg, basename (*varg));

                /* dplacer le fichier */
                mv2 (*varg, newfic);

                /* passer  l'argument suivant */
                *varg++;
            }
        }
        /* sinon */
        else
        {
            /* si seulement 2 arguments */
            if (narg == 2)
                /* rebaptiser le fichier */
                mv2 (*varg, *(varg + 1));

            /* sinon */
            else
                /* rappeler la syntaxe de la commande */
                psyntaxe ();
        }
    }
}


/* dplacement ou changement de nom d'un fichier */
mv2 (oldfic, newfic)
char oldfic [], newfic [];
{
    char go,   /* indicateur : doit on continuer ? */
         rep;  /* rponse  une question */

    /* si l'ancien fichier existe */
    if (findfirst (oldfic, &fich, 0xff) == 0)
    {
        go = option - 3 * (findfirst (newfic, &fich, 0xff));

        /* traitement en fonction de l'existence
           du nouveau fichier et de l'option */
        switch (go)
        {
            /* nouveau fichier existant et option "-n" */
            case -1 : fprintf (stderr, "Fichier %s dj existant\n", newfic);
                      break;

            /* nouveau fichier existant et pas d'option */
            case  0 : printf ("Fichier %s dj existant, voulez vous l'craser ? ",
                               newfic);

                      /* on demande l'avis de l'oprateur */
                      rep = bioskey (0);
                      putchar (rep);
                      putchar (10);

                      /* prise en compte de la rponse */
                      if ((rep | 0x20) == 'n')
                          break;

            /* nouveau fichier existant et option
               "-y" ou suite du cas prcdent */
            case  1 : if (unlink (newfic) == -1)
                          perror (newfic);

            /* nouveau fichier inexistant ou suite du cas prcdent */
            default : if (rename (oldfic, newfic) == -1)
                          perror (newfic);
        }
    }
    /* sinon message d'erreur */
    else
        fprintf (stderr, "Fichier %s inexistant\n", oldfic);
}


/* rappel de la syntaxe de la commande */
psyntaxe ()
{
     fprintf (stderr, "%s %s\n%s %s\n",
             "Syntaxe : mv [-(y|n)] <nom de fichier>",
                            "<nouveau nom de fichier>",
             "     ou : mv [-(y|n)] <liste de fichiers>",
                         "<rpertoire de destination>");
}
