/* Programme mxpg

   Il est souhaitable de compiler ce programme avec le modle mmoire Compact
   pour disposer du maximum de mmoire  l'excution.

   Avec cette version de pg la taille des fichiers est quasiment illimite.
   En contrepartie, mxpg est plus lent que pg et gpg .

*/

#include <stdio.h>
#include <alloc.h>
#include <conio.h>
#include <mem.h>
#include "carspe.h"
#include "accent.h"

#define szoctet        256
#define bitslignebuf     6
#define bitslistepage   10
#define octetmempage     3   /* nombre d'octets pour mmoriser une page */
#define maxblocs       200   /* nombre maximum de tableaux de pages */
#define maxlong    0x7FFFFFFF
#define memolibre       50
#define szchemin        80
#define lignecran       25
#define colonecran      80
#define tauxdecal        4
#define minmemocom   50000   /* mmoire minimum pour lancer une commande */
#define err_av_help      3

#define szmaxlig       (szoctet - 1)                   /* soit 255 */
#define ligneparbuf    (1 << bitslignebuf)             /* soit 64 */
#define szbuf          (ligneparbuf * (szmaxlig + 1))  /* soit 16 Koctets */
#define szlistepage    (1 << bitslistepage)            /* soit 1024 */
#define masklistepage  (szlistepage - 1)               /* soit 1023 */
#define maskpospage    (ligneparbuf - 1)               /* soit 63 */


#define BIP   7
#define BKSP  8
#define TAB   9
#define EOL  10
#define CTRL 12
#define CR   13
#define ESC  27

#define EN_COURS  0   /* tats d'exploration du fichier */
#define TERMINE   1

#define octet unsigned char
#define int16 unsigned short


/* Recherche d'une ligne dans le fichier

Le fichier est dcompos en pages de 64 lignes chacune.
On mmorise la position de chaque page du fichier.
Ces positions sont memorises dans de tableaux de 1024 pages conscutives.
On alloue le nombre de tableaux ncssaires en fonction de la taille du
fichier et de la mmoire disponible.

   ~ 8,5 bits      ~ 7,5 bits         10 bits          6 bits
<---------------><-------------><------------------><---------->
  inaccessible     lment de      numro de page   numro ligne
                    listepage      dans listepage   dans la page
                (max 200 valeurs)  (1024 valeurs)   (64 valeurs)

On mmorise la position de chaque page sur 3 octets.
Le 4me octet est obtenu en mmorisant les numros de page (256 maximum)
o cet octet change.
Cela revient  dcouper le fichier en blocs de 16 Moctets. */


typedef octet typelistep [szlistepage][octetmempage];

static octet pagemem [2][szbuf];  /* buffer page mmoire 1 et 2 */
static octet *buffer;             /* buffer courant */
static octet pagechoisie;         /* 1 ou 2 */
static int16 posligbuf [2][ligneparbuf]; /* position lignes dans les buffers */
static long  numpagemem [2];      /* numro des pages 1 et 2 */
static long  numpage;             /* numro de la page courante */
static long  nbpage;              /* nombre de pages localises */
static long  derpagelue;          /* derniere pages lue dans le fichier */

/* premire ligne du fichier situe dans un nouveau bloc de 16 Moctets */
static long  posbloc16mo [szoctet + 1];

/* adresse des pointeurs listepage */
static octet far *adrlistpage [maxblocs];
static octet numbloc;          /* indice de adrlistepage */

/* position d'une page mmoire dans un bloc de 16 Moctets du fichier */
static octet far *listepage;

static octet exploration; /* indique si le fichier a t explor en entier */

static long  nblig;
static long  numlig;
static long  numligecran;
static int16 poscar;

static octet szlig;
static octet decald = 0;
static char  colonne;
static char  ligne;

static char  optnuml   = 0;
static char  optaccent = 1;
static char  optab     = 0;
static char  optregul  = 0;

/* interface avec le clavier */
static int   car;              /* caractre saisi au clavier */
static int   carpred;          /* caractre prcdent saisi au clavier */
static int   carsuiv;          /* caractre suivant saisi au clavier */
static octet suivantlu = 0;    /* indique si l'on a lu le caractre suivant */
static int   compred;

static char  commande [colonecran]; /* commande introduite par l'oprateur */
static char  poscom;  /* caractre courant de la commande */
static char  szcom;   /* longueur de la commande */
static char  szexpr;  /* longueur de la chaine ou l'expression regulire
                          rechercher, -1 si erreur dans l'expression */

static FILE *ficaide;   /* descripteur du fichier d'aide en ligne */

main (narg, varg)
int narg;
char *varg [];
{
    int  disque;
    char curdir [szchemin];


    /* fabrication du nom du fichier d'aide en ligne */
    strcpy (*varg + strlen (*varg) - 3, "HLP");
    ficaide = fopen (*varg, "rb");

    varg++;
    narg--;

    while (**varg == '-')
    {
        *varg = *varg + 1;

        do
        {
            switch (**varg)
            {
                case 'n' : optnuml = 1;
                           break;

                case 'a' : optaccent = 0;
                           break;

                case 't' : optab   = 1;
                           break;

                case 'r' : optregul = 1;
                           break;

                default  : fputs (
             "Syntaxe : mxpg -[n] [-a] [-t] [-r] [<fichier(s)>]\n", stderr);
                           exit ();
            }

            *varg = *varg + 1;
        }
        while (**varg != 0);

        varg++;
        narg--;
    }

    initmem ();

    disque = getdisk ();
    getcwd (curdir, szchemin);

    do
    {
        if (narg > 0)
            if (freopen (*varg, "rb", stdin) == 0)
                fprintf (stderr, "Fichier %s inexistant\n", *varg);

        exploration = EN_COURS;
        nblig   = 0;
        nbpage  = 0;
        numpage = 0;
        posbloc16mo [0] = 0;
        posbloc16mo [1] = maxlong;

        chargepage ();

        positlig (1L);

        if (nblig > lignecran - 1)
        {
            while (numlig < lignecran)
                affligsuiv ();

            anacom ();
        }
        else
            while (numlig < nblig)
                affligsuiv ();

        /* libration de la mmoire */
        for (numbloc = 1; adrlistpage [numbloc] != 0; numbloc++)
        {
            farfree (adrlistpage [numbloc]);
            adrlistpage [numbloc] = 0;
        }

        varg++;
        narg--;

        setdisk (disque);
        chdir (curdir);

        if (narg > 0)
        {
            printf (
     "Fichier suivant : %s.   Appuyer sur un touche  ^C pour sortir", *varg);

            leccar ();

            putchar (EOL);

            if (car == '')
                exit ();
        }
    }
    while (narg > 0);
}

initmem ()
{
    listepage = farmalloc ((long) szlistepage * octetmempage);

    if (listepage != 0)
    {
        adrlistpage [0] = listepage;

        for (numbloc = 1; numbloc < maxblocs; numbloc++)
            adrlistpage [numbloc] = 0;

        memset (listepage, 0, szlistepage * octetmempage);
    }
    else
    {
        fputs ("Mmoire insuffisante\n", stderr);
        exit ();
    }
}



int dansfichier (n)
long n;
{
    if (exploration == EN_COURS && n > nblig)
    {
        printf ("  Dplacement en cours");

        do
            pagesuiv ();
        while (exploration == EN_COURS && n > nblig);
    }

    return (n <= nblig);
}

selectligne (n)
long n;
{
    long newpage;


    newpage = (n - 1) >> bitslignebuf;

    if (newpage != numpage)
    {
        pagechoisie = newpage & 1;
        buffer = pagemem [pagechoisie];

        if (numpagemem [pagechoisie] != newpage)
        {
            positsurpage (newpage);
            chargepage ();
        }

        numpage = newpage;
    }

    poscar = posligbuf [pagechoisie][(n - 1) & maskpospage];
}



positsurpage (n)
long n;
{
    long  posfic;
    int   positpage;
    octet i;


    numpage = n;

    numbloc   = n >> bitslistepage;
    positpage = n &  masklistepage;

    listepage = adrlistpage [numbloc];

    for (i = 1; posbloc16mo [i] < numpage; i++);

    posfic = (long) (i - 1) << 24;
    memcpy (&posfic, listepage  + (positpage * octetmempage), octetmempage);

    fseek (stdin, posfic, 0);

    derpagelue = numpage - 1;
}

chargepage ()
{
    int   carfic;
    octet ligpage;


    pagechoisie = numpage & 1;
    numpagemem [pagechoisie] = numpage;
    buffer = pagemem [pagechoisie];

    poscar  = 0;
    carfic  = 0;

    for (ligpage = 0; ligpage < ligneparbuf && carfic != EOF; ligpage++)
    {
        posligbuf [pagechoisie][ligpage] = poscar++;

        szlig = 0;
        carfic = getchar ();

        while (carfic != EOL && carfic != EOF)
        {
            if (szlig < szmaxlig)
            {
                if (carfic != TAB || optab == 1)
                {
                    buffer [poscar++] = carfic;
                    szlig++;
                }
                else
                {
                    do
                        buffer [poscar++] = ' ';
                    while ((szlig++ & 7) != 0);
                }
            }

            carfic = getchar ();
        }

        if (buffer [poscar - 1] == CR && szlig > 0)
        {
            poscar --;
            szlig  --;
        }

        buffer [poscar - szlig - 1] = szlig;
    }

    derpagelue = numpage;

    if (exploration == EN_COURS && nbpage == numpage)
    {
        nblig = nblig + ligpage;

        if (carfic != EOF)
            memadrpage ();
        else
        {
            if (szlig > 0)
                nblig ++;

            exploration = TERMINE;
        }
    }
}

/* memorise la position de la page suivante */

pagesuiv ()
{
    int   carfic, carpred;
    octet ligpage;


    if ((derpagelue + 1) < nbpage);
        positsurpage (nbpage);

    carfic = 0;

    for (ligpage = 0; ligpage < ligneparbuf && carfic != EOF; ligpage++)
    {
        carpred = carfic;

        do
            carfic = getchar ();
        while (carfic != EOL && carfic != EOF);

        nblig ++;
    }

    derpagelue = numpage;

    if (carfic != EOF)
        memadrpage ();
    else
    {
        if (carpred != EOL)
            nblig ++;

        exploration = TERMINE;
    }

    numpage ++;
}



memadrpage ()
{
    long  posfic;
    int   positpage;
    octet i;


    nbpage    = numpage + 1;
    numbloc   = nbpage >> bitslistepage;
    positpage = nbpage &  masklistepage;

    if (adrlistpage [numbloc] == 0)
    {
        listepage = farmalloc ((long) szlistepage * octetmempage);

        adrlistpage [numbloc] = listepage;

        memset (listepage, 0, szlistepage * octetmempage);
    }
    else
        listepage = adrlistpage [numbloc];

    if (listepage != 0)
    {
        posfic = ftell (stdin);

        i = posfic >> 24;

        if (posbloc16mo [i] == maxlong)
        {
            posbloc16mo [i] = numpage;
            posbloc16mo [i + 1] = maxlong;
        }

        memcpy (listepage + (positpage * octetmempage), &posfic, octetmempage);
    }
    else
        exploration = TERMINE;
}

long lecval ()
{
    long valeur;


    putchar (car);

    if (car == '+' || car == '-')
    {
        compred = car;
        valeur = 0;
    }
    else
    {
        compred = 0;
        valeur = car - '0';
    }

    while (1)
    {
        leccar ();

        if ('0' <= car && car <= '9')
        {
            putchar (car);
            valeur = (valeur * 10) + (car - '0');
        }
        else if (car == TBKSP || car == RECULE)
        {
            putchar (BKSP);
            effligne ();
            valeur = valeur / 10;
        }
        else if (car == MONTE && compred == 0)
        {
            compred = '-';

            if (valeur <= maxlong)
                return (valeur);
            else
                return (maxlong);
        }
        else if (car == DESCEND && compred == 0)
        {
            compred = '+';

            if (valeur <= maxlong)
                return (valeur);
            else
                return (maxlong);
        }
        else if (car == ENTER)
        {
            if (valeur <= maxlong)
                return (valeur);
            else
                return (maxlong);
        }
        else
            bip ();
    }
}

anacom ()
{
    char  repete;
    char  majecran = 0;
    octet termine;
    long  valeur;
    long  lignetestee;
    long  fintest;
    int   szligpage;       /* taille de la ligne la plus longue de la page */
    char  sens;            /* sens de recherche */
    long  bord;            /* limite sup. ou inf. du fichier */
    octet trouve;          /* rsultat d'une recherche */
    octet i;               /* compteur */
    octet errutil, nberr;  /* comptage des erreurs conscutives utilisateur */


    if (exploration != TERMINE)
    {
        positsurpage (1L);
        chargepage ();
    }

    ligne = lignecran;
    numligecran = ligne;
    positlig (numligecran);
    nberr = 0;

    termine = 0;

    do
    {
        if (compred != '!')
        {
            leccar ();

            if (car == 'n' && compred != ':')
            {
                car = compred;
                repete = 1;
            }
            else
                repete = 0;
        }

        errutil = 0;

        switch (car)
        {
            case MONTE   : if (ligne > 1)
                               hautpage ();
                           else
                               monte (1L);

                           compred = car;
                           break;

            case DESCEND : if (ligne < lignecran)
                               baspage ();
                           else
                               descend (1L);

                           compred = car;
                           break;

            case AVANCE  : if (decald < szmaxlig - tauxdecal)
                           {
                               decald = decald + tauxdecal;
                               reaffiche ();
                           }
                           else
                           {
                               bip ();
                               supcarid ();
                           }

                           compred = car;
                           break;

            case RECULE  : if (decald > 0)
                           {
                               if (decald > tauxdecal + 1)
                                   decald = decald - tauxdecal;
                               else
                                   decald = 0;

                               reaffiche ();
                           }
                           else
                           {
                               bip ();
                               supcarid ();
                           }

                           compred = car;
                           break;

            case HOME    : if (decald > 0)
                           {
                               decald = 0;
                               reaffiche ();
                           }
                           else
                               bip ();

                           compred = 0;
                           supcarid ();
                           break;

            case END     : hautpage ();
                           szligpage = 0;

                           for (i = 0; i < lignecran - 1; i++)
                           {
                               selectligne (numlig + i);

                               if (szligpage < buffer [poscar])
                                   szligpage = buffer [poscar];
                           }

                           szligpage = szligpage + (optnuml * 8) + 1;

                           if (szligpage > colonecran)
                               decald = szligpage - colonecran;
                           else
                               decald = 0;

                           reaffiche ();
                           compred = 0;
                           supcarid ();
                           break;

            case ENTER   :
            case PAGEDOWN: baspage ();
                           descend ((long) lignecran - 1);
                           compred = car;
                           break;

            case PAGEUP  : hautpage ();
                           monte ((long) lignecran - 1);
                           compred = car;
                           break;

            case '1'     :
            case '2'     :
            case '3'     :
            case '4'     :
            case '5'     :
            case '6'     :
            case '7'     :
            case '8'     :
            case '9'     :
            case '+'     :
            case '-'     : if (repete == 0)
                           {
                               if (compred != ':')
                                   baspage ();

                               else if (majecran == 1)
                               {
                                   reaffiche ();
                                   majecran = 0;
                                   putchar (compred);
                               }

                               valeur = lecval ();
                           }

                           if (compred == '+')
                           {
                               putchar (CR);
                               effligne ();
                               descend (valeur);
                           }
                           else if (compred == '-')
                           {
                               hautpage ();
                               monte (valeur);
                           }
                           else
                               posabs (valeur);

                           break;

            case CTRL    : reaffiche ();
                           compred = 0;
                           break;

            case '^'     : hautpage ();
                           monte (numlig - 1);
                           compred = 0;
                           break;

            case '$'     : baspage ();

                           if (exploration != TERMINE)
                           {
                               printf ("  Dplacement en cours");

                               do
                                   pagesuiv ();
                               while (exploration != TERMINE);
                           }

                           descend (nblig - numlig);
                           compred = 0;
                           break;

            case '/'     :
            case '?'     : lignetestee = numlig;
                           fintest     = numlig;
                           trouve = 0;

                           if (repete == 0)
                           {
                               baspage ();
                               saisie ();
                               szexpr = memoexpr (commande, optregul);

                               if (compred == '/')
                               {
                                   sens = 1;

                                   if (exploration == EN_COURS)
                                       bord = maxlong;
                                   else
                                       bord = nblig + 1;
                               }
                               else
                               {
                                   sens = -1;
                                   bord = 0;
                               }

                               numlig = lignetestee;
                           }

                           if (szexpr >= 0)
                           {
                               if (szexpr < colonecran - 20 && repete == 0)
                                   printf ("   Recherche en cours");

                               do
                               {
                                   lignetestee = lignetestee + sens;

                                   if (lignetestee > nblig && exploration == EN_COURS)
                                   {
                                       pagesuiv ();

                                       if (exploration == TERMINE)
                                           bord = nblig + 1;
                                   }

                                   if (lignetestee == bord)
                                   {
                                       while (exploration == EN_COURS)
                                           pagesuiv ();

                                       lignetestee = (bord - nblig) * sens;
                                   }

                                   selectligne (lignetestee);

                                   trouve = recherche (&buffer [poscar + 1],
                                               buffer [poscar], optregul);
                               }
                               while (trouve == 0 && lignetestee != fintest);

                               if (trouve == 1)
                               {
                                   baspage ();
                                   posabs (lignetestee);
                                   numlig = lignetestee;
                               }
                               else
                               {
                                   if (szexpr > colonecran - 30)
                                   {
                                       putchar (CR);
                                       effligne ();
                                   }
                                   else
                                       for (i = 0; i < 18; i++)
                                           putchar (BKSP);

                                   if (optregul == 0)
                                       printf ("  Chaine non trouve");
                                   else
                                       printf ("  Expression non trouve");

                                   compred = 0;
                                   bip ();
                               }
                           }
                           else
                               bip ();

                           break;

            case '!'     : if (compred != '!' && compred != ':')
                               baspage ();

                           if (farcoreleft () < minmemocom)
                           {
                               printf ("\rMmoire insuffisante pour lancer une commande");
                               bip ();
                               break;
                           }

                           saisie ();

                           if (compred == '!')
                           {
                               putchar (EOL);

                               if (*commande != 0)
                                   system (commande);
                               else
                                   bip ();

                               printf ("Appuyer sur une touche pour continuer ");
                               leccar ();
                               putchar (CR);
                               effligne ();
                               majecran = 1;
                           }
                           else
                           {
                               putchar (CR);
                               effligne ();
                               leccar ();
                           }

                           if (car == ':')
                           {
                               putchar (car);
                               compred = car;
                           }

                           if (car != '!' && car != ':' && majecran == 1)
                           {
                               positlig (numlig - lignecran + 1);
                               descend ((long) lignecran - 1);
                               majecran = 0;
                               compred = 0;
                           }

                           break;

            case ':'     : baspage ();
                           putchar (car);
                           compred = car;
                           break;

            case 'O'     :
            case 'o'     : baspage ();
                           printf ("    Lignes %lu  %lu",
                                       numlig - lignecran + 1, numlig - 1);
                           compred = 0;
                           break;

            case 's'     : if (compred == ':')
                               majoption ();
                           else
                               bip ();

                           compred = 0;
                           break;

            case HELP    : baspage ();

                           if (ficaide > 0)
                               aide ();
                           else
                           {
                               printf ("Fichier d'aide en ligne manquant");
                               bip ();
                           }

                           break;

            case 'Q'     :
            case 'q'     : if (compred == ':')
                           {
                               putchar ('q');
                               putchar (EOL);

                               termine = 1;
                           }
                           else
                               bip ();

                           break;

            default      : if (compred == ':')
                           {
                               putchar (CR);
                               effligne ();
                           }

                           errutil = 1;
                           bip ();
                           compred = 0;
        }

        if (errutil)
        {
            nberr ++;

            if (nberr >= err_av_help)
            {
                baspage ();
                printf ("Taper :q pour sortir, ");

                if (ficaide > 0)
                    printf ("touche F1 pour l'aide en ligne");
                else
                    printf ("(fichier d'aide en ligne manquant)");

                nberr = 0;
            }
        }
        else
            nberr = 0;
    }
    while (termine == 0);
}

saisie ()
{
    char i;


    if (compred == ':')
        colonne = 2;
    else
        colonne = 1;

    compred = car;
    putchar (car);

    poscom = 0;
    szcom = poscom;

    leccar ();

    while (car != ENTER && car != ESCAPE)
    {
        if (car < CARSPE)
        {
            if (optaccent == 1)
            {
                switch (car)
                {
                    case '\'': if (carpred == 'e')
                                   memaccent (eaigu);
                               break;

                    case '`' : if (carpred == 'a')
                                   memaccent (agrave);

                               else if (carpred == 'e')
                                   memaccent (egrave);

                               else if (carpred == 'u')
                                   memaccent (ugrave);

                               break;

                    case '^' : if (carpred == 'a')
                                   memaccent (acirc);

                               else if (carpred == 'e')
                                   memaccent (ecirc);

                               else if (carpred == 'i')
                                   memaccent (icirc);

                               else if (carpred == 'o')
                                   memaccent (ocirc);

                               else if (carpred == 'u')
                                   memaccent (ucirc);

                               break;

                    case '"' : if (carpred == 'e')
                               {
                                   putchar (car);
                                   leccar ();

                                   if (car == '"')
                                   {
                                       putchar (BKSP);
                                       memaccent (etrema);
                                   }
                               }
                               else if (carpred == 'i')
                               {
                                   putchar (car);
                                   leccar ();

                                   if (car == '"')
                                   {
                                       putchar (BKSP);
                                       memaccent (itrema);
                                   }
                               }
                               break;

                    case ',' : if (carpred == 'c' || carpred == 'C')
                               {
                                   putchar (car);
                                   leccar ();

                                   if (car == 'a' || car == 'o' || car == 'u')
                                   {
                                       if (carpred == 'c')
                                           carpred = ccedille;
                                       else
                                           carpred = Ccedille;

                                       putchar (BKSP);
                                       putchar (BKSP);
                                       putchar (carpred);
                                       commande [poscom - 1] = carpred;
                                   }
                               }
                               break;
                }
            }

            if (szcom == poscom)
            {
                if (colonne < colonecran)
                {
                    commande [poscom++] = car;
                    szcom = poscom;
                    affcar (car);
                }
                else
                    bip ();
            }
            else
            {
                if (car >= ' ')
                {
                    if (commande [poscom] < ' ')
                        delcar (1);
                }
                else
                {
                    if (commande [poscom] >= ' ')
                        inscar (1);
                }

                commande [poscom++] = car;
                affcar (car);
            }
        }
        else
        {
            switch (car)
            {
                case AVANCE   : if (poscom == szcom)
                                {
                                    if (colonne < colonecran)
                                    {
                                        commande [poscom++] = ' ';
                                        szcom = poscom;
                                        affcar (' ');
                                    }
                                    else
                                    {
                                        bip ();
                                        supcarid ();
                                    }
                                }
                                else
                                {
                                    if (commande [poscom++] < ' ')
                                        putseq ("2C");
                                    else
                                        putseq ("C");
                                }
                                break;

                case RECULE   : if (colonne > 2)
                                {
                                    if (commande [--poscom] < ' ')
                                        putseq ("2D");
                                    else
                                        putseq ("D");
                                }
                                else
                                {
                                    bip ();
                                    supcarid ();
                                }

                                break;

                case TBKSP    : if (colonne > 2)
                                {
                                    if (commande [--poscom] < ' ')
                                        printf (" ");

                                    printf (" ");

                                    commande [poscom] = ' ';
                                }
                                else
                                {
                                    bip ();
                                    supcarid ();
                                }

                                break;

                case INSERE   : if (poscom < szcom)
                                {
                                    inscar (1);

                                    for (i = szcom; i >= poscom; i--)
                                        commande [i + 1] = commande [i];

                                    commande [poscom] = ' ';
                                    szcom++;
                                }

                                break;

                case SUPPRIME : if (poscom < szcom)
                                {
                                    if (commande [poscom] < ' ')
                                        delcar (2);
                                    else
                                        delcar (1);

                                    for (i = poscom; i < szcom; i++)
                                        commande [i] = commande [i + 1];

                                    szcom--;
                                }

                                break;

                default       : bip ();
            }
        }

        leccar ();
    }

    if (car == ENTER)
    {
        if (commande [szcom - 1] == compred)
            commande [szcom - 1] = 0;
        else
            commande [szcom] = 0;
    }
    else
        compred = 0;
}

/* mmorisation d'un caractre accentu */
memaccent (caccent)
char caccent;
{
    putchar (BKSP);

    poscom--;
    car = caccent;
}




majoption ()
{
    char newval;    /* nouvelle valeur de l'option */


    printf ("set ");

    leccar ();

    if (car == 'e')
    {
        leccar ();

        if (car == 't')
        {
            do
                leccar ();
            while (car == ' ');
        }
    }

    putchar (car);

    if (car == 'n')
    {
        leccar ();

        if (car == 'o')
        {
            putchar (car);
            newval = 0;
            leccar ();
            putchar (car);
        }
        else if (car == 'u')
        {
            newval = 1;
            car = 'n';
        }
        else
        {
            putchar (car);
            car = 0;
        }
    }
    else
        newval = 1;

    fflush (stdout);

    switch (car)
    {
        case 'a' : optaccent = newval;

                   if (optaccent)
                       printf ("\rTraitement des accents");
                   else
                       printf ("\rPas de traitement des accents");

                   break;

        case 'n' : putchar ('u');
                   optnuml = newval;
                   reaffiche ();
                   effligne  ();
                   break;

        case 'r' : optregul = newval;

                   if (optregul)
                       printf ("\rRecherche des expressions rgulires");
                   else
                       printf ("\rPas de recherche des expressions rgulires");

                   break;

        case 't' : optab = newval;

                   if (optab)
                       printf ("\rTraitement des tabulations");
                   else
                       printf ("\rRemplacement des tabulations par des blancs");

                   numpagemem [0] = maxlong;
                   numpagemem [1] = maxlong;
                   numpage = maxlong;
                   selectligne (numlig);
                   break;

        default  : printf (".....    option inconnue");
                   bip ();
    }
}

positlig (n)
long n;
{
    numlig = n;

    selectligne (numlig);
}





posabs (valeur)
long valeur;
{
    putchar (CR);
    effligne ();

    if (valeur >= numlig)
    {
        if (dansfichier (valeur + (lignecran >> 2)))
            descend (valeur - numlig + (lignecran >> 2));
        else
            descend (nblig - numlig);

        putseq ("A");
        ligne --;
        numligecran--;
    }

    if (valeur < nblig)
    {
        hautpage ();

        if (valeur < numlig)
        {
            if (valeur > (lignecran >> 2))
                monte (numlig - valeur + (lignecran >> 2));
            else
                monte (numlig - 1);
        }

        while (valeur-- > numlig)
        {
            putseq ("B");
            ligne++;
            numligecran++;
        }
    }
    else
    {
        baspage ();
        bip ();
    }
}

descend (depl)
long depl;
{
    char finfic = 0;


    if (! dansfichier (numlig + depl))
    {
        depl = nblig - numlig;
        finfic = 1;
    }

    if (depl >= lignecran)
    {
        positlig (numlig + depl - lignecran);
        depl = lignecran;
    }

    putchar (CR);
    effligne ();

    while (depl-- > 0)
        affligsuiv ();

    if (finfic == 1)
    {
        bip ();
        supcarid ();
    }
}




affligsuiv ()
{
    if ((numlig & maskpospage) == 1)
        selectligne (numlig);

    affligne ();

    if (colonne <= colonecran)
        putchar (EOL);

    numlig++;
    numligecran = numlig;
}

monte (depl)
long depl;
{
    char debfic = 0;

    if (depl >= numlig)
    {
        depl = numlig - 1;
        debfic = 1;
    }

    if (depl >= lignecran)
    {
        positlig (numlig - depl + lignecran);
        depl = lignecran;
    }

    while (depl-- > 0)
        affligprec ();

    if (debfic == 1)
    {
        bip ();
        supcarid ();
    }
}




affligprec ()
{
    numlig--;
    numligecran = numlig;

    selectligne (numlig);

    inserligne ();

    affligne ();

    if (colonne <= colonecran)
        putchar (CR);
    else
        putseq ("H");
}




reaffiche ()
{
    hautpage ();

    while (ligne < lignecran)
    {
        effligne ();
        affligsuiv ();
        ligne++;
    }

    effligne ();
}

affligne ()
{
    octet i;


    if (optnuml == 0)
        colonne = 1;
    else
    {
        printf ("%7lu", numlig);

        if (numlig <= 9999999)
            putchar (' ');

        colonne = 9;
    }

    if (decald != 0)
        affcar ('<');

    szlig = buffer [poscar++];

    poscar = poscar + decald;
    i = decald;

    if (i < szlig)
    {
        while (i++ < szlig)
            affcar (buffer [poscar++]);
    }
    else
        poscar = poscar + szlig - i;
}




affcar (car)
octet car;
{
    if (colonne <= colonecran)
    {
        if (car < ' ')
        {
            if (car == TAB && optab == 1)
            {
                putchar (' ');

                while (colonne % 8 != optnuml * 5)
                    affcar (' ');

                colonne++;
            }
            else
            {
                affcar ('^');
                affcar (car | '@');
            }
        }
        else
        {
            putchar (car);
            colonne++;
        }
    }
    else if (colonne == colonecran + 1)
    {
        putseq ("A");
        putseq ("79C");
        putchar ('>');

        colonne++;
    }
}

baspage ()
{
    if (ligne < lignecran)
    {
        putseq ("24B");
        numligecran = numligecran + lignecran - ligne;
        ligne = lignecran;
    }

    positlig (numligecran);

    putchar (CR);
    effligne ();
}




hautpage ()
{
    if (ligne > 1)
    {
        putseq ("H");
        numligecran = numligecran + 1 - ligne;
        ligne = 1;
    }

    positlig (numligecran);
}



bip ()
{
    putchar (BIP);
}



effligne ()
{
    putseq ("K");
}



putseq (chaine)
char chaine [];
{
    putchar (ESC);
    putchar ('[');

    while (*chaine != 0)
        putchar (*(chaine++));
}

/* aide sur l'utilisation de l'outil */
aide ()
{
    int n;   /* slection de l'oprateur */


    /* afficher le menu de la documentation */
    message (0);

    /* lire et mmoriser le choix de l'oprateur */
    leccar ();

    /* affichage de la rponse oprateur */
    putchar (car);

    /* remise en forme de la rponse oprateur */
    n = car - '0';

    /* afficher la page de documentation slectionne */
    if (n > 0 && n <= 7)
        message (n);
    else
    {
        puts ("  Erreur !\r");
        bip ();
    }

    printf ("\n     Appuyer sur une touche revenir au fichier");
    leccar ();

    if (car == HELP)
        aide ();
    else
        reaffiche ();
}

/* affichage d'une page de la documentation en ligne */
int message (n)
int n;
{
    int car;     /* caractre du fichier d'aide en ligne */


    /* se positionner sur la page  afficher */
    rewind (ficaide);

    while (n > 0)
    {
        car = getc (ficaide);

        if (car == CTRL)
            n--;
    }

    puts ("\n");

    car = getc (ficaide);

    /* afficher la page */
    while ((car != CTRL) && (car != EOF))
    {
        /* traitement du dlimiteur de page d'cran */
        if (car == 0)
        {
            printf ("     Appuyer sur une touche pour continuer");
            leccar ();
            putchar (CR);
            effligne ();
        }
        else
            putchar (car);

        car = getc (ficaide);
    }
}

/* Sous programmes spcifiques  MS-DOS */

inscar (nbcar)
char nbcar;
{
    char x, y;

    x = wherex ();
    y = wherey ();

    movetext (x, y, colonecran - nbcar, y, x + nbcar, y);

    putchar (' ');
    putchar (BKSP);
}




delcar (nbcar)
char nbcar;
{
    char x, y;

    x = wherex ();
    y = wherey ();

    movetext (x + nbcar, y, colonecran, y, x, y);
}




inserligne ()
{
    insline ();
}

leccar ()
{
    carpred = car;

    if (suivantlu == 0)
        car = codecar ();
    else
    {
        car = carsuiv;
        suivantlu = 0;
    }
}




int nextcar ()
{
    carsuiv = codecar ();

    suivantlu = 1;

    return (carsuiv);
}




supcarid ()
{
    while (bioskey (1) && nextcar () == car)
        suivantlu = 0;
}




int codecar ()
{
    int carlu;


    while (exploration == EN_COURS && bioskey (1) == 0)
        pagesuiv ();

    carlu = bioskey (0);

    if ((carlu & 0xFF) == 0)
        return (CARSPE | (carlu >> 8));
    else
    {
        if (carlu != TBKSP && carlu != ESCAPE && carlu != ENTER)
            return (carlu & 0xFF);
        else
            return (carlu);
    }
}
