/* Programme pg

   Il est recommand de compiler ce programme avec le modle mmoire Compact
   pour disposer de plus de mmoire lors de l'excution de :!<commande>

   Avec cette version de pg la taille des fichiers
   est limite a 65535 caractres et 32767 lignes.

*/

#include <stdio.h>
#include <alloc.h>
#include <conio.h>
#include "carspe.h"
#include "accent.h"

#define szmaxbuf    65535
#define maxlig      32767
#define szmaxlig      255
#define szchemin       80
#define lignecran      25
#define colonecran     80
#define tauxdecal       4
#define minmemocom  50000    /* mmoire minimum pour lancer une commande */
#define err_av_help     3

#define BIP   7
#define BKSP  8
#define TAB   9
#define EOL  10
#define CTRL 12
#define CR   13
#define ESC  27

#define OPTPOLICE   'p'
#define OPTCOULEUR  'c'

#define CARGRAS     1
#define SOULIGNE    2
#define ITALLIQUE   4


#define octet unsigned char
#define int16 unsigned short


static octet far *buffer;        /* buffer courant */
static int16 far *posdeblig;     /* position des dbuts de ligne */
static octet far *debcoupol;     /* couleur et police en dbut de ligne */

static int16 nblig;
static int16 numlig;
static int16 numligecran;
static int16 poscar;

static octet szlig;
static octet decald = 0;
static char  colonne;
static char  ligne;

static octet polcourante;
static char  couleur;       /* initialis par codecouleur */
static char  police;        /* initialis par codepolice  */
static char  listecouleur [7] = "nrvjbmc";
static struct text_info confecran;
static octet majconfecran;

static char  optnuml   = 0;
static char  optaccent = 1;
static char  optab     = 0;
static char  optescape = 0;
static char  optregul  = 0;

/* interface avec le clavier */
static int   car;              /* caractre saisi au clavier */
static int   carpred;          /* caractre prcdent saisi au clavier */
static int   carsuiv;          /* caractre suivant saisi au clavier */
static octet suivantlu = 0;    /* indique si l'on a lu le caractre suivant */
static int   compred;

static char  commande [colonecran]; /* commande introduite par l'oprateur */
static char  poscom;  /* caractre courant de la commande */
static char  szcom;   /* longueur de la commande */
static char  szexpr;  /* longueur de la chaine ou l'expression rgulire
                          rechercher, -1 si erreur dans l'expression */

static FILE *ficaide;   /* descripteur du fichier d'aide en ligne */

main (narg, varg)
int narg;
char *varg [];
{
    int  disque;
    char curdir [szchemin];


    /* fabrication du nom du fichier d'aide en ligne */
    strcpy (*varg + strlen (*varg) - 3, "HLP");
    ficaide = fopen (*varg, "rb");

    varg++;
    narg--;

    while (**varg == '-')
    {
        *varg = *varg + 1;

        do
        {
            switch (**varg)
            {
                case 'n' : optnuml = 1;
                           break;

                case 'a' : optaccent = 0;
                           break;

                case 't' : optab   = 1;
                           break;

                case 'c' :
                case 'p' : optescape = **varg;
                           break;

                case 'r' : optregul = 1;
                           break;

                default  : fputs (
       "Syntaxe : pg [-n] [-a] [-t] [-(p|c)] [-r] [<fichier(s)>]\n", stderr);
                           exit ();
            }

            *varg = *varg + 1;
        }
        while (**varg != 0);

        varg++;
        narg--;
    }

    majconfecran = 0;

    buffer = farmalloc (szmaxbuf);

    if (buffer == 0)
    {
        fprintf (stderr, "Manque de place mmoire\n");
        exit ();
    }

    disque = getdisk ();
    getcwd (curdir, szchemin);

    do
    {
        if (narg > 0)
            if (freopen (*varg, "rb", stdin) == 0)
                fprintf (stderr, "Fichier %s inexistant\n", *varg);

        debcoupol = 0;

        chargefic ();

        if (nblig > lignecran - 1)
        {
            genposdeblig ();

            anacom ();

            free (posdeblig);
        }

        if (debcoupol != 0)
            free (debcoupol);

        varg++;
        narg--;

        setdisk (disque);
        chdir (curdir);

        if (narg > 0)
        {
            printf (
     "Fichier suivant : %s.   Appuyer sur un touche  ^C pour sortir", *varg);

            leccar ();

            putchar (EOL);

            if (car == '')
                exit ();
        }
    }
    while (narg > 0);

    if (majconfecran != 0)
        razecran ();
}

chargefic ()
{
    int carfic;


    carfic = getchar ();

    if (carfic != EOF)
    {
        nblig = 1;
        numlig = 1;
        poscar = 1;
        szlig = 0;
    }
    else
        nblig = 0;

    while ((carfic != EOF || szlig != 0) && poscar != szmaxbuf && nblig <= maxlig)
    {
        if (carfic == CR)
            carfic = getchar ();

        if (szlig >= szmaxlig)
            while (carfic != EOL && carfic != EOF)
                carfic = getchar ();

        if (carfic != EOL && carfic != EOF)
        {
            if (carfic != TAB || optab == 1)
                buffer [poscar] = carfic;
            else
                buffer [poscar] = ' ';

            szlig++;
        }
        else
        {
            buffer [poscar - szlig - 1] = szlig;

            if (nblig <= lignecran)
                if (nblig < lignecran)
                {
                    poscar = poscar - szlig - 1;
                    affligsuiv ();
                }
                else
                    printf ("Chargement du fichier en cours ");

            szlig = 0;
            nblig++;
        }

        poscar++;

        if (carfic != TAB || optab == 1 || szlig % 8 == 0)
            carfic = getchar ();
    }

    if (nblig >= lignecran)
    {
        putchar (CR);
        effligne ();
    }

    if (poscar == szmaxbuf || nblig > maxlig)
        printf ("Troncation a %d lignes soit %u caractres.  (utiliser gpg)",
                 nblig - 1, poscar - szlig - 1);
}




genposdeblig ()
{
    posdeblig = farcalloc (nblig, 2);

    if (posdeblig == 0)
    {
        fprintf (stderr, "\nManque de place mmoire\n");
        exit ();
    }

    poscar = 0;

    for (numlig = 0; numlig < nblig; numlig++)
    {
        posdeblig [numlig] = poscar;
        poscar = poscar + buffer [poscar] + 1;
    }
}

gendebcoupol ()
{
    octet coupol;
    int   i;


    debcoupol = farmalloc (nblig);

    if (debcoupol != 0)
    {
        coupol = 0;
        *debcoupol = 0;
        poscar = 0;

        for (numlig = 1; numlig < nblig; numlig++)
        {
            szlig = buffer [poscar++];

            for (i = 0; i < szlig; i++)
            {
                if (buffer [poscar] == ESC)
                {
                    if (codepolice () != 0)
                    {
                        if (police > 0)
                            coupol = coupol | police;
                        else
                            coupol = coupol & (police - 1);
                    }
                    else if (codecouleur () >= 0)
                    {
                        coupol = (couleur << 3) | (coupol & 7);
                    }
                }
                poscar++;
            }
            debcoupol [numlig] = coupol;
        }

        if (majconfecran == 0)
        {
            gettextinfo (&confecran);
            majconfecran = 1;
        }
    }
    else
    {
        effligne ();
        printf ("Manque de place mmoire");
    }
}

int16 lecval ()
{
    int16 valeur;


    putchar (car);

    if (car == '+' || car == '-')
    {
        compred = car;
        valeur = 0;
    }
    else
    {
        compred = 0;
        valeur = car - '0';
    }

    while (1)
    {
        leccar ();

        if ('0' <= car && car <= '9')
        {
            putchar (car);
            valeur = (valeur * 10) + (car - '0');
        }
        else if (car == TBKSP || car == RECULE)
        {
            putchar (BKSP);
            effligne ();
            valeur = valeur / 10;
        }
        else if (car == MONTE && compred == 0)
        {
            compred = '-';
            return (valeur);
        }
        else if (car == DESCEND && compred == 0)
        {
            compred = '+';
            return (valeur);
        }
        else if (car == ENTER)
            return (valeur);
        else
            bip ();
    }
}

anacom ()
{
    char  repete;
    char  majecran = 0;
    octet termine;
    int16 valeur;
    int16 lignetestee;
    int16 fintest;
    int   szligpage;       /* taille de la ligne la plus longue de la page */
    char  sens;            /* sens de recherche */
    int16 bord;            /* limite sup. ou inf. du fichier */
    octet trouve;          /* rsultat d'une recherche */
    octet i;               /* compteur */
    octet errutil, nberr;  /* comptage des erreurs conscutives utilisateur */


    ligne = lignecran;
    numligecran = ligne;
    positlig (numligecran);
    nberr = 0;

    if (optescape != 0)
        setcoupol (optescape);

    termine = 0;

    do
    {
        if (compred != '!')
        {
            leccar ();

            if (car == 'n' && compred != ':')
            {
                car = compred;
                repete = 1;
            }
            else
                repete = 0;
        }

        errutil = 0;

        switch (car)
        {
            case MONTE   : if (ligne > 1)
                               hautpage ();
                           else
                               monte (1);

                           compred = car;
                           break;

            case DESCEND : if (ligne < lignecran)
                               baspage ();
                           else
                               descend (1);

                           compred = car;
                           break;

            case AVANCE  : if (decald < szmaxlig - tauxdecal)
                           {
                               decald = decald + tauxdecal;
                               reaffiche ();
                           }
                           else
                           {
                               bip ();
                               supcarid ();
                           }

                           compred = car;
                           break;

            case RECULE  : if (decald > 0)
                           {
                               if (decald > tauxdecal + 1)
                                   decald = decald - tauxdecal;
                               else
                                   decald = 0;

                               reaffiche ();
                           }
                           else
                           {
                               bip ();
                               supcarid ();
                           }

                           compred = car;
                           break;

            case HOME    : if (decald > 0)
                           {
                               decald = 0;
                               reaffiche ();
                           }
                           else
                               bip ();

                           compred = 0;
                           supcarid ();
                           break;

            case END     : hautpage ();
                           szligpage = buffer [posdeblig [numlig - 1]];

                           for (i = 0; i < lignecran - 2; i++)
                               if (szligpage < buffer [posdeblig [numlig + i]])
                                   szligpage = buffer [posdeblig [numlig + i]];

                           szligpage = szligpage + (optnuml * 6) + 1;

                           if (szligpage > colonecran)
                               decald = szligpage - colonecran;
                           else
                               decald = 0;

                           reaffiche ();
                           compred = 0;
                           supcarid ();
                           break;

            case ENTER   :
            case PAGEDOWN: baspage ();
                           descend (lignecran - 1);
                           compred = car;
                           break;

            case PAGEUP  : hautpage ();
                           monte (lignecran - 1);
                           compred = car;
                           break;

            case '1'     :
            case '2'     :
            case '3'     :
            case '4'     :
            case '5'     :
            case '6'     :
            case '7'     :
            case '8'     :
            case '9'     :
            case '+'     :
            case '-'     : if (repete == 0)
                           {
                               if (compred != ':')
                                   baspage ();

                               else if (majecran == 1)
                               {
                                   reaffiche ();
                                   majecran = 0;
                                   putchar (compred);
                               }

                               valeur = lecval ();
                           }

                           if (compred == '+')
                           {
                               putchar (CR);
                               effligne ();
                               descend (valeur);
                           }
                           else if (compred == '-')
                           {
                               hautpage ();
                               monte (valeur);
                           }
                           else
                               posabs (valeur);

                           break;

            case CTRL    : reaffiche ();
                           compred = 0;
                           break;

            case '^'     : hautpage ();
                           monte (numlig - 1);
                           compred = 0;
                           break;

            case '$'     : baspage ();
                           descend (nblig - numlig);
                           compred = 0;
                           break;

            case '/'     :
            case '?'     : lignetestee = numlig;
                           fintest     = numlig;
                           trouve = 0;

                           if (repete == 0)
                           {
                               baspage ();
                               saisie ();
                               szexpr = memoexpr (commande, optregul);

                               if (compred == '/')
                               {
                                   sens = 1;
                                   bord = nblig + 1;
                               }
                               else
                               {
                                   sens = -1;
                                   bord = 0;
                               }

                               numlig = lignetestee;
                           }

                           if (szexpr >= 0)
                           {
                               do
                               {
                                   lignetestee = lignetestee + sens;

                                   if (lignetestee == bord)
                                       lignetestee = (bord - nblig) * sens;

                                   poscar = posdeblig [lignetestee - 1];

                                   trouve = recherche (&buffer [poscar + 1],
                                                  buffer [poscar], optregul);
                               }
                               while (trouve == 0 && lignetestee != fintest);

                               if (trouve == 1)
                               {
                                   baspage ();
                                   posabs (lignetestee);
                                   numlig = lignetestee;
                               }
                               else
                               {
                                   if (szexpr > colonecran - 30)
                                   {
                                       putchar (CR);
                                       effligne ();
                                   }

                                   if (optregul == 0)
                                       printf ("    Chaine non trouve");
                                   else
                                       printf ("    Expression non trouve");

                                   compred = 0;
                                   bip ();
                               }
                           }
                           else
                               bip ();

                           break;

            case '!'     : if (compred != '!' && compred != ':')
                               baspage ();

                           if (farcoreleft () < minmemocom)
                           {
                               printf ("\rMmoire insuffisante pour lancer une commande");
                               bip ();
                               break;
                           }

                           saisie ();

                           if (compred == '!')
                           {
                               putchar (EOL);

                               if (*commande != 0)
                                   system (commande);
                               else
                                   bip ();

                               printf ("Appuyer sur une touche pour continuer ");
                               leccar ();
                               putchar (CR);
                               effligne ();
                               majecran = 1;
                           }
                           else
                           {
                               putchar (CR);
                               effligne ();
                               leccar ();
                           }

                           if (car == ':')
                           {
                               putchar (car);
                               compred = car;
                           }

                           if (car != '!' && car != ':' && majecran == 1)
                           {
                               positlig (numlig - lignecran + 1);
                               descend (lignecran - 1);
                               majecran = 0;
                               compred = 0;
                           }

                           break;

            case ':'     : baspage ();
                           putchar (car);
                           compred = car;
                           break;

            case 'O'     :
            case 'o'     : baspage ();
                           printf ("    Lignes %d a %d",
                                       numlig - lignecran + 1, numlig - 1);
                           compred = 0;
                           break;

            case 's'     : if (compred == ':')
                               majoption ();
                           else
                               bip ();

                           compred = 0;
                           break;

            case HELP    : baspage ();

                           if (ficaide > 0)
                               aide ();
                           else
                           {
                               printf ("Fichier d'aide en ligne manquant");
                               bip ();
                           }

                           break;

            case 'Q'     :
            case 'q'     : if (compred == ':')
                           {
                               putchar ('q');
                               putchar (EOL);

                               termine = 1;
                           }
                           else
                               bip ();

                           break;

            default      : if (compred == ':')
                           {
                               putchar (CR);
                               effligne ();
                           }

                           errutil = 1;
                           bip ();
                           compred = 0;
        }

        if (errutil)
        {
            nberr ++;

            if (nberr >= err_av_help)
            {
                baspage ();
                printf ("Taper :q pour sortir, ");

                if (ficaide > 0)
                    printf ("touche F1 pour l'aide en ligne");
                else
                    printf ("(fichier d'aide en ligne manquant)");

                nberr = 0;
            }
        }
        else
            nberr = 0;
    }
    while (termine == 0);
}

razecran ()
{
    octet teintes;

    textmode (confecran.currmode);

    teintes = ((confecran.attribute & 0x11) << 2) |
               (confecran.attribute & 0x22) |
              ((confecran.attribute & 0x44) >> 2);
    printf ("%c[3%dm%c[4%dm", ESC, teintes & 0x7, ESC, teintes >> 4);

    if (confecran.attribute & 0x08)
        printf ("%c[1m", ESC);
}

saisie ()
{
    char i;


    if (compred == ':')
        colonne = 2;
    else
        colonne = 1;

    compred = car;
    putchar (car);

    poscom = 0;
    szcom = poscom;

    leccar ();

    while (car != ENTER && car != ESCAPE)
    {
        if (car < CARSPE)
        {
            if (optaccent == 1)
            {
                switch (car)
                {
                    case '\'': if (carpred == 'e')
                                   memaccent (eaigu);
                               break;

                    case '`' : if (carpred == 'a')
                                   memaccent (agrave);

                               else if (carpred == 'e')
                                   memaccent (egrave);

                               else if (carpred == 'u')
                                   memaccent (ugrave);

                               break;

                    case '^' : if (carpred == 'a')
                                   memaccent (acirc);

                               else if (carpred == 'e')
                                   memaccent (ecirc);

                               else if (carpred == 'i')
                                   memaccent (icirc);

                               else if (carpred == 'o')
                                   memaccent (ocirc);

                               else if (carpred == 'u')
                                   memaccent (ucirc);

                               break;

                    case '"' : if (carpred == 'e')
                               {
                                   putchar (car);
                                   leccar ();

                                   if (car == '"')
                                   {
                                       putchar (BKSP);
                                       memaccent (etrema);
                                   }
                               }
                               else if (carpred == 'i')
                               {
                                   putchar (car);
                                   leccar ();

                                   if (car == '"')
                                   {
                                       putchar (BKSP);
                                       memaccent (itrema);
                                   }
                               }
                               break;

                    case ',' : if (carpred == 'c' || carpred == 'C')
                               {
                                   putchar (car);
                                   leccar ();

                                   if (car == 'a' || car == 'o' || car == 'u')
                                   {
                                       if (carpred == 'c')
                                           carpred = ccedille;
                                       else
                                           carpred = Ccedille;

                                       putchar (BKSP);
                                       putchar (BKSP);
                                       putchar (carpred);
                                       commande [poscom - 1] = carpred;
                                   }
                               }
                               break;
                }
            }

            if (szcom == poscom)
            {
                if (colonne < colonecran)
                {
                    commande [poscom++] = car;
                    szcom = poscom;
                    affcar (car);
                }
                else
                    bip ();
            }
            else
            {
                if (car >= ' ')
                {
                    if (commande [poscom] < ' ')
                        delcar (1);
                }
                else
                {
                    if (commande [poscom] >= ' ')
                        inscar (1);
                }

                commande [poscom++] = car;
                affcar (car);
            }
        }
        else
        {
            switch (car)
            {
                case AVANCE   : if (poscom == szcom)
                                {
                                    if (colonne < colonecran)
                                    {
                                        commande [poscom++] = ' ';
                                        szcom = poscom;
                                        affcar (' ');
                                    }
                                    else
                                    {
                                        bip ();
                                        supcarid ();
                                    }
                                }
                                else
                                {
                                    if (commande [poscom++] < ' ')
                                        putseq ("2C");
                                    else
                                        putseq ("C");
                                }
                                break;

                case RECULE   : if (colonne > 2)
                                {
                                    if (commande [--poscom] < ' ')
                                        putseq ("2D");
                                    else
                                        putseq ("D");
                                }
                                else
                                {
                                    bip ();
                                    supcarid ();
                                }

                                break;

                case TBKSP    : if (colonne > 2)
                                {
                                    if (commande [--poscom] < ' ')
                                        printf (" ");

                                    printf (" ");

                                    commande [poscom] = ' ';
                                }
                                else
                                {
                                    bip ();
                                    supcarid ();
                                }

                                break;

                case INSERE   : if (poscom < szcom)
                                {
                                    inscar (1);

                                    for (i = szcom; i >= poscom; i--)
                                        commande [i + 1] = commande [i];

                                    commande [poscom] = ' ';
                                    szcom++;
                                }

                                break;

                case SUPPRIME : if (poscom < szcom)
                                {
                                    if (commande [poscom] < ' ')
                                        delcar (2);
                                    else
                                        delcar (1);

                                    for (i = poscom; i < szcom; i++)
                                        commande [i] = commande [i + 1];

                                    szcom--;
                                }

                                break;

                default       : bip ();
            }
        }

        leccar ();
    }

    if (car == ENTER)
    {
        if (commande [szcom - 1] == compred)
            commande [szcom - 1] = 0;
        else
            commande [szcom] = 0;
    }
    else
        compred = 0;
}





/* mmorisation d'un caractre accentu */
memaccent (caccent)
char caccent;
{
    putchar (BKSP);

    poscom--;
    car = caccent;
}

majoption ()
{
    char newval;    /* nouvelle valeur de l'option */


    printf ("set ");

    leccar ();

    if (car == 'e')
    {
        leccar ();

        if (car == 't')
        {
            do
                leccar ();
            while (car == ' ');
        }
    }

    putchar (car);

    if (car == 'n')
    {
        leccar ();

        if (car == 'o')
        {
            putchar (car);
            newval = 0;
            leccar ();
            putchar (car);
        }
        else if (car == 'u')
        {
            newval = 1;
            car = 'n';
        }
        else
        {
            putchar (car);
            car = 0;
        }
    }
    else
        newval = 1;

    fflush (stdout);

    switch (car)
    {
        case 'a' : optaccent = newval;

                   if (optaccent)
                       printf ("\rTraitement des accents");
                   else
                       printf ("\rPas de traitement des accents");

                   break;

        case 'c' :
        case 'p' : if (newval == 1)
                       setcoupol (car);
                   else
                   {
                       if (optescape != 0)
                       {
                           optescape = 0;
                           putseq ("0m");
                           reaffiche ();
                       }

                       effligne  ();
                   }
                   break;

        case 'n' : putchar ('u');
                   optnuml = newval;
                   reaffiche ();
                   effligne  ();
                   break;

        case 'r' : optregul = newval;

                   if (optregul)
                       printf ("\rRecherche des expressions rgulires");
                   else
                       printf ("\rPas de recherche des expressions rgulires");

                   break;

        default  : printf (".....    option inconnue");
                   bip ();
    }
}

setcoupol (valeur)
octet valeur;
{
    if (debcoupol == 0)
        gendebcoupol ();

    if (debcoupol != 0)
    {
        if (valeur == 'c')
            textmode (3);
        else
            textmode (7);

        optescape = valeur;
        reaffiche ();
        effligne ();
    }
    else
        optescape = 0;
}

positlig (n)
int16 n;
{
    numlig = n;

    poscar = posdeblig [numlig - 1];
}




posabs (valeur)
int16 valeur;
{
    putchar (CR);
    effligne ();

    if (valeur >= numlig)
    {
        if (valeur + (lignecran >> 2) < nblig)
            descend (valeur - numlig + (lignecran >> 2));
        else
            descend (nblig - numlig);

        putseq ("A");
        ligne --;
        numligecran--;
    }

    if (valeur < nblig)
    {
        hautpage ();

        if (valeur < numlig)
        {
            if (valeur > (lignecran >> 2))
                monte (numlig - valeur + (lignecran >> 2));
            else
                monte (numlig - 1);
        }

        while (valeur-- > numlig)
        {
            putseq ("B");
            ligne++;
            numligecran++;
        }
    }
    else
    {
        baspage ();
        bip ();
    }
}

descend (depl)
int16 depl;
{
    char finfic = 0;

    if (numlig + depl > nblig)
    {
        depl = nblig - numlig;
        finfic = 1;
    }

    if (depl >= lignecran)
    {
        positlig (numlig + depl - lignecran);
        depl = lignecran;
    }

    putchar (CR);
    effligne ();

    while (depl-- > 0)
        affligsuiv ();

    if (finfic == 1)
    {
        bip ();
        supcarid ();
    }
}




affligsuiv ()
{
    affligne ();

    if (colonne <= colonecran)
        putchar (EOL);

    numlig++;
    numligecran = numlig;
}

monte (depl)
int16 depl;
{
    char debfic = 0;

    if (depl >= numlig)
    {
        depl = numlig - 1;
        debfic = 1;
    }

    if (depl >= lignecran)
    {
        positlig (numlig - depl + lignecran);
        depl = lignecran;
    }

    while (depl-- > 0)
        affligprec ();

    if (debfic == 1)
    {
        bip ();
        supcarid ();
    }
}




affligprec ()
{
    numlig--;
    numligecran = numlig;

    poscar = posdeblig [numlig - 1];

    inserligne ();

    affligne ();

    if (colonne <= colonecran)
        putchar (CR);
    else
        putseq ("H");
}




reaffiche ()
{
    hautpage ();

    while (ligne < lignecran)
    {
        effligne ();
        affligsuiv ();
        ligne++;
    }

    effligne ();
}

affligne ()
{
    octet i;


    if (optescape != 0)
        putseq ("0m");

    if (optnuml == 0)
        colonne = 1;
    else
    {
        printf ("%5u ", numlig);
        colonne = 7;
    }

    if (decald != 0)
        affcar ('<');

    szlig = buffer [poscar++];

    if (optescape == 0)
    {
        poscar = poscar + decald;
        i = decald;
    }
    else
        i = initcopol ();

    if (i < szlig)
    {
        while (i++ < szlig)
        {
            if (buffer [poscar] != ESC)
                affcar (buffer [poscar++]);
            else
                i = i + trtescape ();
        }
    }
    else
        poscar = poscar + szlig - i;

    if (optescape == OPTPOLICE && colonne < colonecran)
        putseq ("0m");
}

affcar (car)
octet car;
{
    if (colonne <= colonecran)
    {
        if (car < ' ')
        {
            if (car == TAB && optab == 1)
            {
                putchar (' ');

                while (colonne % 8 != optnuml * 5)
                    affcar (' ');

                colonne++;
            }
            else
            {
                affcar ('^');
                affcar (car | '@');
            }
        }
        else
        {
            putchar (car);
            colonne++;
        }
    }
    else if (colonne == colonecran + 1)
    {
        putseq ("A");
        putseq ("79C");
        putchar ('>');

        colonne++;
    }
}

int trtescape ()
{
    if (optescape == OPTPOLICE && codepolice () != 0)
    {
        if (police < 0)
        {
            polcourante = polcourante & (police - 1);

            putseq ("0");

            if (polcourante & ITALLIQUE)
            {
                printf (";7");

                if (polcourante & CARGRAS)
                    printf (";1;4");
            }
            else
            {
                if (polcourante & CARGRAS)
                    printf (";1");

                if (polcourante & SOULIGNE)
                    printf (";4");
            }

            putchar ('m');

            poscar = poscar + 3;
            return (2);
        }
        else if (police > 0)
        {
            polcourante = polcourante | police;

            if (polcourante & ITALLIQUE)
            {
                putseq ("0;7");

                if (polcourante & CARGRAS)
                    printf (";1;4");

                putchar ('m');
            }
            else
            {
                if (polcourante & CARGRAS)
                    putseq ("1m");

                if (polcourante & SOULIGNE)
                    putseq ("4m");
            }
            poscar = poscar + 2;
            return (1);
        }
    }
    else if (optescape == OPTCOULEUR && codecouleur () >= 0)
    {
        putseq ("3");
        putchar ('0' | couleur);
        putchar ('m');
        poscar = poscar + 3;
        return (2);
    }

    affcar (ESC);
    poscar++;
    return (0);
}

int initcopol ()
{
    int16 posorig;
    octet nouvcouleur;
    octet i;


    posorig = poscar;

    if (optescape == OPTCOULEUR)
    {
        if (debcoupol != 0)
            nouvcouleur = debcoupol [numlig - 1] >> 3;

        for (i = 0; i < decald; i++)
        {
            if (buffer [poscar] == ESC && codecouleur () >= 0)
            {
                nouvcouleur = couleur;
                poscar = poscar + 2;
                i--;
            }
            poscar++;
        }

        putseq ("47;3");
        putchar ('0' | nouvcouleur);
        putchar ('m');
        effligne ();
    }
    else
    {
        if (debcoupol != 0)
            polcourante = debcoupol [numlig - 1];

        for (i = 0; i < decald; i++)
        {
            if (buffer [poscar] == ESC && codepolice () != 0)
            {
                if (police > 0)
                {
                    polcourante = polcourante | police;
                    poscar++;
                }
                else
                {
                    polcourante = polcourante & (police - 1);
                    poscar = poscar + 2;
                }
                i--;
            }
            poscar++;
        }

        if (polcourante & ITALLIQUE)
        {
            putseq ("7");

            if (polcourante & CARGRAS)
                printf (";1;4");

            putchar ('m');
        }
        else
        {
            if (polcourante & CARGRAS)
                putseq ("1m");

            if (polcourante & SOULIGNE)
                putseq ("4m");
        }
    }
    return (poscar - posorig);
}

int codecouleur ()
{
    char carcouleur;


    if (buffer [poscar + 1] == 'c')
    {
        carcouleur = buffer [poscar + 2];

        for (couleur = 6; couleur >= 0 &&
                          carcouleur != listecouleur [couleur]; couleur--);
    }
    else
        couleur = -1;

    return (couleur);
}




int codepolice ()
{
    char  sens;
    octet carpol;


    if (buffer [poscar + 1] == '-')
    {
        sens = -1;
        carpol = buffer [poscar + 2];
    }
    else
    {
        sens = 1;
        carpol = buffer [poscar + 1];
    }

    switch (carpol)
    {
        case '_' : police = SOULIGNE * sens;
                   break;
        case 'g' : police = CARGRAS  * sens;
                   break;
        case '/' : police = ITALLIQUE * sens;
                   break;
        default  : police = 0;
    }
    return (police);
}

baspage ()
{
    if (ligne < lignecran)
    {
        putseq ("24B");
        numligecran = numligecran + lignecran - ligne;
        ligne = lignecran;
    }

    positlig (numligecran);

    putchar (CR);
    effligne ();
}




hautpage ()
{
    if (ligne > 1)
    {
        putseq ("H");
        numligecran = numligecran + 1 - ligne;
        ligne = 1;
    }

    positlig (numligecran);
}



bip ()
{
    putchar (BIP);
}



effligne ()
{
    putseq ("K");
}



putseq (chaine)
char chaine [];
{
    putchar (ESC);
    putchar ('[');

    while (*chaine != 0)
        putchar (*(chaine++));
}

/* aide sur l'utilisation de l'outil */
aide ()
{
    int n;   /* slection de l'oprateur */


    /* afficher le menu de la documentation */
    message (0);

    /* lire et mmoriser le choix de l'oprateur */
    leccar ();

    /* affichage de la rponse oprateur */
    putchar (car);

    /* remise en forme de la rponse oprateur */
    n = car - '0';

    /* afficher la page de documentation slectionne */
    if (n > 0 && n <= 7)
        message (n);
    else
    {
        puts ("  Erreur !\r");
        bip ();
    }

    printf ("\n     Appuyer sur une touche revenir au fichier");
    leccar ();

    if (car == HELP)
        aide ();
    else
        reaffiche ();
}

/* affichage d'une page de la documentation en ligne */
int message (n)
int n;
{
    int car;     /* caractre du fichier d'aide en ligne */


    /* se positionner sur la page  afficher */
    rewind (ficaide);

    while (n > 0)
    {
        car = getc (ficaide);

        if (car == CTRL)
            n--;
    }

    puts ("\n");

    car = getc (ficaide);

    /* afficher la page */
    while ((car != CTRL) && (car != EOF))
    {
        /* traitement du dlimiteur de page d'cran */
        if (car == 0)
        {
            printf ("     Appuyer sur une touche pour continuer");
            leccar ();
            putchar (CR);
            effligne ();
        }

        /* saut des caractres ~ */
        else if (car != '~')
            putchar (car);

        car = getc (ficaide);
    }
}

/* Sous programmes spcifiques  MS-DOS */

inscar (nbcar)
char nbcar;
{
    char x, y;

    x = wherex ();
    y = wherey ();

    movetext (x, y, colonecran - nbcar, y, x + nbcar, y);

    putchar (' ');
    putchar (BKSP);
}




delcar (nbcar)
char nbcar;
{
    char x, y;

    x = wherex ();
    y = wherey ();

    movetext (x + nbcar, y, colonecran, y, x, y);
}




inserligne ()
{
    insline ();
}

leccar ()
{
    carpred = car;

    if (suivantlu == 0)
        car = codecar ();
    else
    {
        car = carsuiv;
        suivantlu = 0;
    }
}




int nextcar ()
{
    carsuiv = codecar ();

    suivantlu = 1;

    return (carsuiv);
}




supcarid ()
{
    while (bioskey (1) && nextcar () == car)
        suivantlu = 0;
}




int codecar ()
{
    int carlu;


    carlu = bioskey (0);

    if ((carlu & 0xFF) == 0)
        return (CARSPE | (carlu >> 8));
    else
    {
        if (carlu != TBKSP && carlu != ESCAPE && carlu != ENTER)
            return (carlu & 0xFF);
        else
            return (carlu);
    }
}
