#include <stdio.h>
#include <dir.h>

#define szbuf     16384
#define szchemin    256

#define octet      char

#define RETURN       13
#define CTRLC         3
#define sznomfic     13

/* buffer de transfert */
static octet buffer [szbuf];

/* numro de la disquette */
static octet numdisk = 0;

/* chemin d'accs aux fichiers */
char chemin [szchemin + 2], *orig, *dest;


/* programme principal */
main (narg, varg)
int narg;
char *varg [];
{
    /* initialisation en fonction du priphrique sur lequel on est */
    if (getdisk () < 2)
    {
        /* On est positionn sur une disquette */
        dest = chemin;
        orig = dest + 2;
        sprintf (dest, "C:");

        /* test du nombre d'arguments */
        if (narg != 1 && (narg != 2 || varg [1][1] != ':' || varg [1][2] != 0))
        {
            fprintf (stderr, "Syntaxe : restor [<nom de disque>]\n");
            exit ();
        }

        /* rcuprer le nom du disque destinataire de la copie */
        if (narg == 2)
            *dest = *varg [1];
    }
    else
    {
        /* On est positionn sur le disque dur */
        orig = chemin;
        dest = orig + 2;
        sprintf (orig, "A:");

        /* test du nombre d'arguments */
        if (narg != 1 && (narg != 2 || varg [1][1] != ':' || varg [1][2] != 0))
        {
            fprintf (stderr, "Syntaxe : restor [<nom de disquette>]\n");
            exit ();
        }

        /* rcuprer le nom du lecteur des disquettes  restaurer */
        if (narg == 2)
            *orig = *varg [1];

        /* demander d'insrer la premire disquette */
        changedisque ();
    }

    /* dmarrer la restauration */
    restordir ();

    /* si on est boot sur une disquette */
    if (orig > dest)
        /* il faut rebooter */
        puts ("Redmarrer le calculateur sur le disque dur et continuer");

    /* sinon */
    else
    {
        /* tantque non fin de la restauration */
        while (chemin [3] != 0x7f || chemin [4] != 0)
        {
            /* demander une nouvelle disquette */
            changedisque ();

            /* la restaurer */
            chemin [2] = 0;
            restordir ();
        }

        /* dtruire la marque de fin de restauration sur le disque dur */
        unlink (dest);
        puts ("[AC'est fini !");
    }
}


/* restauration du rpertoire sur lequel on est positionn */
restordir ()
{
    /* table de description d'un fichier */
    struct ffblk fich;

    /* indicateur */
    int trouve;

    /* chemin relatif au fichier dans le rpertoire selectionn */
    char *nomfic;


    /* fabriquer le chemin d'accs aux lments du rpertoire  recopier */
    nomfic = orig + strlen (orig);
    memcpy (nomfic, "/*.*", 5);
    nomfic++;

    /* recherche du premier fichier de ce rpertoire
       on exclue un ventuel fichier label de la recherche */
    trouve = findfirst (orig, &fich, 0xf7);

    /* saut ventuel des 2 premiers lments du rpertoire */
    if (strcmp (fich.ff_name, ".") == 0)
    {
        /* passer au fichier suivant */
        trouve = findnext (&fich);

        if (strcmp (fich.ff_name, "..") == 0)
            /* passer au fichier suivant */
            trouve = findnext (&fich);
    }

    /* tantque on trouve des nouveaux fichiers dans le rpertoire */
    while (trouve == 0)
    {
        /* construire le chemin d'accs aux fichier */
        memcpy (nomfic, fich.ff_name, sznomfic);

        /* si le fichier  recopier est un rpertoire */
        if (fich.ff_attrib & 0x10)
        {
            /* si le rpertoire de destination n'existe pas */
            if (access (dest, 0) == -1)
            {
                /* la crer */
                if (mkdir (dest) == 0)
                    puts (dest);
                else
                {
                    /* abandon si le rpertoire n'a pu tre cr */
                    fprintf (stderr, "impossible de crer le rpertoire %s\n",
                                                                        dest);
                    arret ();
                }
            }

            /* restaurer son arborescence */
            restordir ();
        }

        /* sinon restaurer le fichier */
        else
            restorfic (&fich.ff_ftime);

        /* rechercher le fichier suivant du rpertoire */
        trouve = findnext (&fich);
    }
}


/* restauration du fichier sur lequel on est positionn */
restorfic (mtime)
unsigned long *mtime;
{
    /* table de description du fichier destination */
    struct ffblk fich;

    /* descripteur de fichier (pour la fonction open) */
    static int descfic;

    /* descripteurs de fichiers (pour la fonction fopen) */
    static FILE *ficin, *ficout;

    /* mode d'ouverture du fichier destination */
    static octet ajout;

    /* taille des zones de donnes lues et recopies */
    static int szlect, szrecop;


    /* ouvrir les fichiers origine */
    ficin  = fopen (orig, "rb");

    /* dterminer le mode d'ouverture du fichier destination */
    ajout = findfirst (dest, &fich, 0xF7) == 0 && fich.ff_fdate == 0
                                               && fich.ff_ftime == 0;

    /* ouvrir le fichier de destination */
    if (ajout)
        ficout = fopen (dest, "ab");
    else
        ficout = fopen (dest, "wb");

    /* si le fichier  restaurer n'est pas protg */
    if (ficout > 0)
        /* lire un morceau du fichier origine */
        szlect = fread (buffer, 1, szbuf, ficin);
    else
    {
        /* sinon dition de l'erreur systme */
        perror (dest);
        szlect = 0;
    }

    /* tantque non fin de fichier */
    while (szlect > 0)
    {
        /* recopier la zone lue */
        szrecop = fwrite (buffer, 1, szlect, ficout);

        /* si problme lors de la copie */
        if (szrecop < szlect)
        {
            fprintf (stderr, "Erreur indtermine\n");

            /* fermer et dtruire le fichier mal recopi */
            fclose (ficout);
            unlink (dest);

            /* arrt de la restauration */
            arret ();
        }

        /* lire la suite du fichier d'origine */
        szlect = fread (buffer, 1, szbuf, ficin);
    }

    /* fermer les fichiers */
    fclose (ficin);
    fclose (ficout);

    /* corriger la date de mise  jour du fichier destination */
    descfic = open (dest, 0x8001);
    setftime (descfic, mtime);
    close (descfic);

    /* diter le nom du fichier transfr */
    printf ("%s", dest);

    /* et prciser un ventuel transfert partiel */
    if (*mtime)
    {
        if (ajout)
            puts ("  (fin)");
        else
            putchar ('\n');
    }
    else
    {
        if (ajout)
            puts ("  (suite)");
        else
            puts ("  (dbut)");
    }
}


/* changement de disquette pour continuer la restauration */
changedisque ()
{
    char reponse;
    
    
    /* passer  la disquette suivante */
    numdisk++;
    
    /* effacer le buffer clavier */
    while (bioskey (1) != 0)
        bioskey (0);
        
    /* et demander une autre disquette */
    printf ("Insrer la disquette numro %d et taper Return ", numdisk);

    /* attendre la rponse de l'oprateur */
    do
    {
        reponse = bioskey (0) & 0xFF;

        if (reponse == CTRLC)
        {
            putchar ('\n');
            arret ();
        }
    }
    while (reponse != RETURN);

    putchar ('\n');
}


/* interruption durant la restauration */
arret ()
{
    fprintf (stderr, "Restauration interrompue\n");
    exit ();
}