/* Programme reverse

   Il est recommande de compiler ce programme avec le modele memoire Compact
   afin de pouvoir memoriser le nombre maximum de lignes

*/

#include <stdio.h>
#include <alloc.h>

#define EOL  10

static char huge *buffer;   /* buffer contenant le fichier a inverser */
static long szbuf     = 0;  /* taille de buffer */
static long nbcarmem  = 0;  /* nombre de caracteres memorises dans buffer */

static int nbcoupures = 0;  /* compte les depassements de capacite de buffer */


main (narg, varg)
int narg;
char *varg [];
{
    if (--narg > 0)
    {
        if (freopen (varg [1], "rb", stdin) == 0)
            fprintf (stderr, "Fichier %s inexistant\n", varg [1]);
    }

    szbuf  = farcoreleft () - 50;
    buffer = farmalloc (szbuf);

    memorise ();
    affiche (nbcarmem);

    if (nbcoupures > 0)
       fprintf (stderr, "Fichier trop grand, edite en %d morceaux\n",
                                                         nbcoupures + 1);
}

memorise ()
{
    int car;


    car = getchar ();

    while (car != -1)
    {
        if (nbcarmem >= szbuf)
        {
            vidange ();
            nbcoupures++;
        }

        buffer [nbcarmem++] = car;

        car = getchar ();
    }

    if (buffer [nbcarmem] != EOL)
        buffer [nbcarmem++] = EOL;
}


vidange ()
{
    long posfinlig;
    long posbuf;


    posfinlig = nbcarmem - 1;

    while (buffer [posfinlig] != EOL && posfinlig > 0)
        posfinlig--;

    affiche (posfinlig);

    posbuf = 0;

    while (posfinlig < nbcarmem)
        buffer [posbuf++] = buffer [posfinlig++];

    nbcarmem = posbuf;
}

affiche (nbcar)
long nbcar;
{
    long posdeblig;
    long posfinlig;
    long posbuf;


    posfinlig = nbcar - 1;

    while (posfinlig > 0)
    {
        posdeblig = posfinlig;

        do
            posdeblig--;
        while (buffer [posdeblig] != EOL && posdeblig > 0);

        if (buffer [posdeblig] == EOL)
            posbuf = posdeblig + 1;
        else
            posbuf = 0;

        while (posbuf <= posfinlig)
            putchar (buffer [posbuf++]);

        posfinlig = posdeblig;
    }
}