#include <stdio.h>
#include <dir.h>
#include <dos.h>

static char superu;   /* option super utilisateur */


main (narg, varg)
int narg;
char *varg [];
{
    struct ffblk fich; /* table de description des fichiers  */
    char recursif;     /* indicateur : option -r positionne */

    /* se positionner sur le premier argument */
    varg++;

    /* initialisation : aucun option */
    recursif = 0;
    superu   = 0;

    /* prise en compte des options -r et -s */
    while (**varg == '-' && narg > 1)
    {
        (*varg) ++;

        do
        {
            if (**varg == 'r')
                recursif = 1;

            else if (**varg == 's')
                superu = 1;
            else
            {
                fprintf (stderr, "option -%c inconnue\n", **varg);

                narg = 0;  /* pour sortir en rappelant la syntaxe d'appel */
            }

            (*varg) ++;
        }
        while (**varg != 0);

        /* et passage  l'argument suivant */
        varg++;
        narg--;
    }

    /* vrification de la syntaxe de la commande */
    if (narg < 2)
        fputs ("Syntaxe : rm [-r] [-s] <liste de fichiers ou rpertoires>\n",
                                                                     stderr);
    else
    {
        /* tantqu'il y a des fichiers ou des rpertoires  dtruire */
        while (--narg > 0)
        {
            /* si le fichier  dtruire existe */
            if (findfirst (*varg, &fich, 0xff) == 0)
            {
                /* s'il s'agit d'un rpertoire */
                if (fich.ff_attrib & 0x10)
                {
                    /* que l'on peut dtruire */
                    if (recursif == 1)
                    {
                        /* dtruire les fichiers qu'elle contient */
                        rmr (*varg);

                        /* et dtruire le rpertoire */
                        if (rmdir (*varg) == -1)
                            fprintf (stderr,
                            "%s : rpertoire non vide ou protg\n", *varg);
                    }
                    /* sinon message d'erreur */
                    else
                        fprintf (stderr, "%s est un rpertoire\n", *varg);
                }
                /* sinon destruction d'un fichier */
                else
                    detruire (*varg);
            }
            /* sinon message d'erreur */
            else
                fprintf (stderr, "Fichier %s inexistant\n", *varg);

            /* passer a l'argument suivant */
            varg++;
        }
    }
}


/* destruction de l'arborescence d'un rpertoire */
rmr (chaine)
char chaine [];
{
    struct ffblk fich; /* table de description des fichiers  */
    char chemin [256]; /* chemin d'accs  un fichier du rpertoire */
    int trouve;        /* indicateur : rpertoire non entirement explor */


    /* crer le chemin d'accs aux fichiers du rpertoire */
    sprintf (chemin, "%s/*.*", chaine);

    /* chercher un fichier dans le rpertoire */
    trouve = findfirst (chemin, &fich, 0xff);

    /* sauter les fichiers . et .. */
    if (strcmp (fich.ff_name, ".") == 0)
    {
        trouve = findnext (&fich);

        if (strcmp (fich.ff_name, "..") == 0)
            trouve = findnext (&fich);
    }

    /* tantque le rpertoire n'est pas vide */
    while (trouve == 0)
    {
        /* reconstituer le chemin d'accs au fichier trouv */
        sprintf (chemin, "%s/%s", chaine, fich.ff_name);

        /* si l'on a trouv un sous rpertoire */
        if (fich.ff_attrib & 0x10)
        {
            /* dtruire l'arborescence de ce rpertoire */
            rmr (chemin);

            /* dtruire le rpertoire */
            if (rmdir (chemin) == -1)
                fprintf (stderr, "%s : rpertoire non vide ou protg\n",
                                                                   chemin);
        }
        /* sinon dtruire le fichier */
        else
            detruire (chemin);

        /* chercher le fichier suivant */
        trouve = findnext (&fich);
    }
}


/* destruction d'un fichier */
detruire (fichier)
char *fichier;
{
    if (unlink (fichier) == -1)
    {
        if (superu == 1)
        {
            _chmod (fichier, 1, 0);

            if (unlink (fichier) == -1)
                fprintf (stderr, "%s : fichier indestructible\n", fichier);
        }
        else
            fprintf (stderr, "%s : fichier protg\n", fichier);
    }
}
