#include <stdio.h>
#include <dir.h>
#include <dos.h>

static char superu;   /* option super utilisateur */


main (narg, varg)
int narg;
char *varg [];
{
    struct ffblk fich; /* table de description des fichiers  */
    char chemin [80];  /* chemin d'accs aux fichiers du rpertoire */


    /* se positionner sur le premier argument */
    varg++;

    /* prise en compte de l'option -s ventuelle */
    if (strcmp (*varg, "-s") == 0)
    {
        superu = 1;

        /* passer  l'argument suivant */
        varg++;
        narg--;
    }
    else
        superu = 0;

    /* vrification de la syntaxe de la commande */
    if (narg < 2)
        fputs ("Syntaxe : rmr [-s] <liste de rpertoires>\n", stderr);
    else
    {
        /* tantqu'il y a des rpertoires  dtruire */
        while (--narg > 0)
        {
            /* crer le chemin d'accs aux fichiers du rpertoire */
            sprintf (chemin, "%s/*.*", *varg);

            /* si le rpertoire contient des fichier  dtruire */
            if (findfirst (chemin, &fich, 0xff) == 0)
            {
                /* dtruire ces fichiers */
                explore (*varg);
            }

            /* cas particulier du rpertoire "/" */
            else if ((strcmp (*varg, "/") == 0) ||
                     (strcmp (*varg, "\\") == 0))
                explore ("");

            /* sinon message d'erreur */
            else
                fprintf (stderr, "%s n'est pas un rpertoire\n", *varg);

            /* passer  l'argument suivant */
            varg++;
        }
    }
}


/* destruction de l'arborescence d'un rpertoire */
explore (chaine)
char chaine [];
{
    struct ffblk fich; /* table de description des fichiers  */
    char chemin [256]; /* chemin d'accs  un fichier du rpertoire */
    int trouve;        /* indicateur : rpertoire non entirement explor */


    /* crer le chemin d'accs aux fichiers du rpertoire */
    sprintf (chemin, "%s/*.*", chaine);

    /* chercher un fichier dans le rpertoire. On
       exclue un ventuel fichier label de la recherche */
    trouve = findfirst (chemin, &fich, 0xf7);

    /* sauter les fichiers . et .. */
    if (strcmp (fich.ff_name, ".") == 0)
    {
        trouve = findnext (&fich);

        if (strcmp (fich.ff_name, "..") == 0)
            trouve = findnext (&fich);
    }

    /* tantque le rpertoire n'est pas vide */
    while (trouve == 0)
    {
        /* reconstituer le chemin d'accs au fichier trouv */
        sprintf (chemin, "%s/%s", chaine, fich.ff_name);

        /* si l'on a trouv un sous rpertoire */
        if (fich.ff_attrib & 0x10)
        {
            /* dtruire l'arborescence de ce rpertoire */
            explore (chemin);

            /* dtruire le rpertoire */
            if (rmdir (chemin) == -1)
                fprintf (stderr, "%s : rpertoire non vide ou protg\n",
                                                                   chemin);
        }
        /* sinon dtruire le fichier */
        else if (unlink (chemin) == -1)
        {
            if (superu == 1)
            {
                _chmod (chemin, 1, 0);

                if (unlink (chemin) == -1)
                    fprintf (stderr, "%s : fichier indestructible\n", chemin);
            }
            else
                fprintf (stderr, "%s : fichier protg\n", chemin);
        }

        /* chercher le fichier suivant */
        trouve = findnext (&fich);
    }
}
