#include <stdio.h>
#include <stdlib.h>
#include <dir.h>
#include <alloc.h>
#include <mem.h>
#include <string.h>

#define SZMAXBOOT   70000   /* taille maximale des fichiers de "/" sauvegards */
#define szbuf       16384
#define szchemin      256
#define szlistini      64

#define sznomfic       13
#define szficdef    sizeof (struct ficdef)

#define RETURN         13   /* caractre de passage  la ligne lu par bioskey */
#define CTRLC           3   /* caractre de sortie du programme */

#define octet      char

typedef struct ficdef
{
    char     nomfic [sznomfic];
    octet    attrib;
    unsigned long datef;
    unsigned long taillef;
};

static octet buffer [szbuf];    /* buffer de transfert */
static octet numdisk = 0;       /* numro de la disquette */
static char drive;              /* numro du disque de destination */
static octet optsd = 0; /* option de sauvegarde des sous rpertoires de "/" */
static char dest [szchemin], *orig; /* chemins d'accs aux fichiers */
static struct ffblk fich;       /* table de description d'un fichier */
static char dirunix [9];        /* nom du rpertoire de commandes principal */

static char  *dirsup [3];       /* liste des rpertoires  ne pas sauvegarder */
static octet nbdirsup = 0;      /* nombre de rpertoires  ne pas sauvegarder */

static char rechflop [] = "x:/*.*"; /* sert  tester si disquettes vierges */
static char marquefin []= "x:/\x7f"; /* marque de fin de sauvegarde */
static char nomflop []  = "x:"; /* sert  effacer les disquettes avec rmr */

static long datepartiel = 0;    /* marquage copie partielle de fichier */

static octet typeffac;          /* choix du mode d'effacement des disquettes */

static struct                   /* place restante sur le disque */
{
    unsigned libre;
    unsigned total;
    unsigned szsect;
    unsigned szgrl;
}   place;

/* programme principal */
main (narg, varg)
int narg;
char *varg [];
{
    /* caractre de "chaine" sur lequel on est positionn */
    char *poschn;


    /* initialisation : dest = <disque>:<orig> */
    orig = dest + 2;

    /* prise en compte de l'option "-sd" */
    if (narg >= 3 && strcmp (varg [1], "-sd") == 0 && varg [2][1] == 0
                              && (*varg [2] == '/' || *varg [2] == '\\'))
    {
        /* chercher le rpertoire  sauvegarder en premier */
        strcpy (dest, searchpath (*varg));
        memcpy (dirunix, dest + 3, 9);

        poschn = dirunix + 1;

        while (*poschn != '\\')
            poschn++;

        *poschn = 0;

        /* mmoriser l'option -sd */
        optsd = 1;
        varg++;
        narg--;

        /* tablir la liste des rpertoires  ne pas sauvegarder */
        lecdirsup ("BAKDIR");
        lecdirsup ("HIERDIR");
    }

    /* test du nombre d'arguments */
    if (narg != 2 && (narg != 3 || varg [2][1] != ':' || varg [2][2] != 0))
        fprintf (stderr,
              "Syntaxe : sauveg <nom de rpertoire> [<nom de disquette>]\n");

    else if (varg [1][1] == ':')
        fprintf (stderr,
             "La sauvegarde n'est accepte qu' partir du disque courant\n");
    else
    {
        /* positionnement sur le premier caractre de "chaine" */
        poschn = varg [1];

        /* rpter */
        do
        {
            /* si le caractre courant est un '\' */
            if (*poschn == '\\')
                /* le remplacer par '/' */
                *poschn = '/';

            /* sinon si le caractre est une lettre minuscule */
            else if (*poschn >= 'a')
                /* le remplacer par la lettre majuscule correspondante */
                *poschn = *poschn - 0x20;

            /* passer au caractre suivant */
            poschn++;
        }
        /* jusque toute la chaine a t explore */
        while (*poschn != 0);

        /* si le dernier caractre de la chaine est un '/' */
        if (*(poschn - 1) == '/')
            /* supprimer ce caractre */
            *(poschn - 1) = 0;

        /* fabriquer le chemin d'accs aux lments du rpertoire  tester */
        sprintf (orig, "%s/*.*", varg [1]);

        /* si on n'a pas trouv de fichier dans le rpertoire */
        if (findfirst (orig, &fich, 0x10) != 0)
            fprintf (stderr, "Rpertoire %s inexistant\n", varg [1]);
        else
        {
            /* terminer proprement le nom du rpertoire  sauvegarder */
            orig [strlen (orig) - 4] = 0;

            /* rcuprer le nom du disque destinataire de la copie */
            if (narg == 3)
                *dest = *varg [2] & 0x5f;
            else
                *dest = 'A';

            dest [1] = ':';

            /* permettra de tester si les disquettes sont vierges */
            *rechflop = *dest;

            /* de les effacer */
            *nomflop = *dest;

            /* et de marquer les fins de sauvegardes */
            *marquefin = *dest;

            /* calcul du numro physique du disque destinataire */
            drive = *dest & 0x1f;

            /* initialisation du mode d'effacement */
            if (drive < 3)
                typeffac = 0;
            else
                typeffac = 2;

            /* demander d'insrer la premiere disquette */
            changedisque ();

            /* effectuer la sauvegarde */
            mkdir (dest);
            sauvdir ();

            /* cration d'une marque de fin de sauvegarde */
            fclose (fopen (marquefin, "a"));
        }
    }
}

/* rcupration d'un nom de rpertoire  ne pas sauvegarder */
lecdirsup (varenv)
char *varenv;
{
    char *cardirsup;


    /* rcuprer le rpertoire dclar en variable d'environnement */
    dirsup [nbdirsup] = getenv (varenv);

    /* si le rpertoire existe */
    if (dirsup [nbdirsup])
    {
        /* suppimer le <disque>: ventuel */
        if (dirsup [nbdirsup][1] == ':')
            dirsup [nbdirsup] = dirsup [nbdirsup] + 2;

        cardirsup = dirsup [nbdirsup];

        do
        {
            /* remplacer les '\' par des '/' dans le chemin d'accs */
            if (*cardirsup == '\\')
                *cardirsup = '/';

            /* et les minuscules par des majuscules */
            if (*cardirsup >= 'a')
                *cardirsup = *cardirsup - 0X20;

            cardirsup ++;
        }
        while (*cardirsup != 0);

        /* mettre  jour le nombre de rpertoires  ne pas sauvegarder */
        nbdirsup ++;
    }
}

/* sauvegarde du rpertoire sur lequel on est positionn */
sauvdir ()
{
    /* indicateur */
    int trouve;

    /* compteurs */
    int posliste, nbfic, szliste, i;

    /* liste des noms et attribut des fichiers d'un rpertoire */
    struct ficdef *listefic, *newliste;

    /* chemin relatif au fichier dans le rpertoire slectionn */
    char *nomfic;


    /* suppression des rpertoire  ne pas sauvegarder */
    for (i = 0; i < nbdirsup; i++)
        if (strcmp (orig, dirsup [i]) == 0)
            return;

    /* allocation du tableau listefic */
    szliste = szlistini;
    listefic = malloc (szliste * szficdef);

    if (listefic == 0)
    {
        fprintf (stderr, "Dbordement mmoire\n");
        exit (-1);
    }

    puts (dest);

    /* fabriquer le chemin d'accs aux lments du rpertoire  recopier */
    nomfic = orig + strlen (orig);
    memcpy (nomfic, "/*.*", 5);
    nomfic++;

    /* recherche du premier fichier de ce rpertoire
       on exclue un ventuel fichier label de la recherche */
    trouve = findfirst (orig, &fich, 0xf7);

    /* si ce fichier est "." */
    if (strcmp (fich.ff_name, ".") == 0)
    {
        /* passer au fichier suivant */
        trouve = findnext (&fich);

        /* si ce fichier est ".." */
        if (strcmp (fich.ff_name, "..") == 0)
            /* passer au fichier suivant */
            trouve = findnext (&fich);
    }

    /* initialisation : nombre de fichiers mmoriss */
    nbfic = optsd;

    /* tantque on trouve des nouveaux fichiers dans le rpertoire */
    while (trouve == 0)
    {
        /* prise en compte en fonction de optsd,
           de la nature du fichier et de sa taille */
        if (optsd == 0 || (fich.ff_attrib & 0x10)
                       || fich.ff_fsize >= SZMAXBOOT)
        {
            /* si liste de fichiers trop petite */
            if (nbfic >= szliste)
            {
                newliste = realloc (listefic, (szliste + szlistini) * szficdef);

                /* prise en compte du rsultat de l'opration */
                if (newliste != 0)
                {
                    /* nouvelle taille et nouvelle adresse de la liste */
                    szliste  = szliste + szlistini;
                    listefic = newliste;
                }
                else
                {
                    /* dbordement, on traite le premier fichier class */
                    trtfic (listefic, nomfic);

                    /* et on le supprime de la liste */
                    memmove (&listefic [0], &listefic [1], --nbfic * szficdef);
                }
            }

            if (optsd == 1 && strcmp (fich.ff_name, dirunix) == 0)
                posliste = 0;
            else
            {
                /* chercher l'lment de la liste o le nouveau fichier
                   doit tre insr pour respecter l'ordre alphabtique */
                for (posliste = optsd; (posliste < nbfic) &&
                 (strcmp (listefic [posliste].nomfic, fich.ff_name)) < 0; posliste++);

                /* si la liste n'a pas t parcourrue en entier */
                if (posliste < nbfic)
                    /* dcaler les fichiers restants d'une position */
                    memmove (&listefic [posliste + 1], &listefic [posliste],
                                             (nbfic - posliste) * szficdef);

                /* incrmenter le nombre de fichiers mmoriss */
                nbfic++;
            }

            memmove (&listefic [posliste].nomfic, fich.ff_name, sznomfic);

            /* recopier l'attribut du fichier */
            listefic [posliste].attrib = fich.ff_attrib;

            /* recopier la date de mise  jour du fichier */
            memmove (&listefic [posliste].datef, &fich.ff_ftime, 4);

            /* recopier la taille du fichier */
            listefic [posliste].taillef = fich.ff_fsize;
        }

        /* rechercher le fichier suivant du rpertoire */
        trouve = findnext (&fich);
    }

    /* le reste de l'arborescence sera sauvegarde en entier */
    optsd = 0;

    for (posliste = 0; posliste < nbfic; posliste++)
        trtfic (&listefic [posliste], nomfic);

    /* librer la liste des fichiers du rpertoire */
    free (listefic);
}

trtfic (fichier, nomfic)
struct ficdef *fichier;
char   *nomfic;
{
    /* construire les chemins d'accs aux fichiers */
    memmove (nomfic, fichier->nomfic, sznomfic);

    /* si le fichier  recopier peut tre lu */
    if (access (orig, 4) == 0)
    {
        /* si le fichier  recopier est un rpertoire */
        if (fichier->attrib & 0x10)
        {
            /* si le rpertoire de destination n'existe pas */
            if (access (dest, 0) == -1)
            {
                /* la crer */
                if (mkdir (dest) < 0)
                {
                    /* crer si ncessaire toute son arborescence */
                    mkarbor (dest);
                    mkdir (dest);
                }
            }

            /* si le rpertoire de destination existe */
            if (access (dest, 0) == 0)
                /* recopier son arborescence */
                sauvdir ();
            /* sinon message d'erreur */
            else
                fprintf (stderr, "impossible de crer le rpertoire %s\n",
                                                                   dest);
        }
        /* sinon sauvegarder le fichier */
        else
            sauvfic (fichier->datef, fichier->taillef);
    }
    /* sinon (le fichier ne peut pas tre lu */
    else
        /* message d'erreur */
        fprintf (stderr, "%s : Droit d'accs insuffisant\n", orig);
}

sauvfic (mtime, taillefic)
unsigned long mtime, taillefic;
{
    /* descripteur de fichier (pour la fonction open) */
    static int descfic;

    /* descripteurs de fichiers (pour la fonction fopen) */
    static FILE *ficin, *ficout;

    /* taille des zones de donnes lues et recopies */
    static int szlect, szrecop, placelibre;

    /* indique si un fichier est sauvegard par morceaux */
    static octet morceaux;


    /* raison ???? */
    printf ("");

    /* ouvrir les fichiers origine et destination */
    ficin  = fopen (orig, "rb");
    ficout = fopen (dest, "wb");

    /* initialisation */
    morceaux = 0;

    /* lire un morceau du fichier origine */
    szlect = fread (buffer, 1, szbuf, ficin);

    /* tantque non fin de fichier */
    while (szlect > 0)
    {
        /* recopier la zone lue */
        szrecop = fwrite (buffer, 1, szlect, ficout);

        /* si problme lors de la copie */
        if (szrecop < szlect)
        {
            /* manque d'espace disque ? */
            getdfree (drive, &place);

            /* message d'erreur si ce n'est pas le cas */
            placelibre = place.libre * place.szsect * place.szgrl;

            if (placelibre >= szlect)
                fprintf (stderr, "Erreur indtermine\n");

            /* voir si l'on rpartit le fichier sur plusieurs disquettes */
            if (morceaux | (taillefic >
                   ((long) place.total * (place.szsect >> 4) * place.szgrl)))
            {
                /* recopier ce qu'on peut du fichier */
                if (fwrite (buffer + szrecop, 1, placelibre, ficout) < placelibre)
                    fprintf (stderr, "Erreur 2 indtermine\n");

                /* fermer le fichier recopi partiellement */
                fclose (ficout);

                /* mmoriser la copie partielle */
                descfic = open (dest, 0x8001);
                setftime (descfic, &datepartiel);
                close (descfic);

                /* rendre compte de la copie partielle */
                printf ("%s", dest);

                if (morceaux)
                    puts ("  (suite)");
                else
                {
                    morceaux = 1;
                    puts ("  (dbut)");
                }

                /* et continuer la sauvegarde du fichier */
                fseek (ficin, placelibre - szlect, 1);
            }
            else
            {
                /* fermer et dtruire le fichier partiellement recopi */
                fclose (ficout);
                unlink (dest);

                /* et recommencer entirement la sauvegarde du fichier */
                rewind (ficin);
            }

            /* demander une autre disquette */
            changedisque ();

            /* continuer ou recommencer la sauvegarde du fichier */
            ficout = fopen (dest, "wb");
        }

        /* lire la suite du fichier d'origine */
        szlect = fread (buffer, 1, szbuf, ficin);
    }

    /* fermer les fichiers */
    fclose (ficin);
    fclose (ficout);

    /* corriger la date de mise  jour du fichier destination */
    descfic = open (dest, 0x8001);
    setftime (descfic, &mtime);
    close (descfic);

    /* diter le nom du fichier transfr */
    printf ("%s", dest);

    if (morceaux)
        puts ("  (fin)");
    else
        putchar ('\n');
}

/* lecture et retour de la rponse  une question */
char reponse ()
{
    char rep;

    /* lire la rponse */
    rep = leccar (1);

    putchar ('\n');

    /* retourner la rponse */
    return (rep | 0x20);
}



/* saisie d'un caractre au clavier */
int leccar (affichage)
int affichage;
{
    int resultat;


    resultat = bioskey (0) & 0xFF;

    if (resultat == CTRLC)
    {
        putchar ('\n');
        arret ();
    }

    if (affichage)
        putchar (resultat);

    return (resultat);
}



/* changement de disquette pour continuer la sauvegarde */
changedisque ()
{
    /* passer  la disquette suivante */
    numdisk++;

    /* effacer le buffer clavier */
    while (bioskey (1) != 0)
        bioskey (0);

    /* et demander une autre disquette */
    printf ("Insrer la disquette numro %d et taper Return ", numdisk);

    /* attendre l'intervention de l'oprateur */
    while (leccar (0) != RETURN);

    putchar ('\n');

    /* controler si la disquette est vierge */
    ctrlvierge ();

    /* gnrer l'arborescence jusqu'au prochain fichier  sauvegarder */
    mkarbor ();
}

/* controle si la disquette est vierge, effacement ventuel */
ctrlvierge ()
{
    /* la disquette est elle vierge ? */
    if (findfirst (rechflop, &fich, 0xF7) == 0)
    {
        /* non, on demande l'avis de l'oprateur */
        printf ("La disquette n'est pas vierge, voulez vous l'effacer ? ");

        if (reponse () == 'n')
        {
            /* traitement d'une rponse ngative */
            if (numdisk > 1)
                arret ();
            else
            {
                printf ("Voulez vous rajouter les informations  la suite ? ");

                if (reponse () == 'n')
                    arret ();
                else
                {
                    /* dtruire la marque de fin de sauvegarde ventuelle */
                    unlink (marquefin);
                }
            }
        }
        else
        {
            while (typeffac != 1 && typeffac != 2)
            {
                puts ("\n1 : effacement rapide (pour disquettes sans dfaut)");
                puts ("2 : effacement standard (et lent !)\n");
                printf ("Votre choix ?  ");

                typeffac = leccar (1) - '0';
                putchar ('\n');

                if (typeffac != 1 && typeffac != 2)
                    puts ("Erreur !");
            }

            if (typeffac == 1)
            {
                /* on efface la disquette en rinitialisant la table d'allocation */
                absread (drive -1, 1, 1, buffer);
                memset (&buffer [3], 0, szbuf - 4);
                abswrite (drive -1, 20, 1, buffer);

                /* faut il une intervention manuelle ? */
                getdfree (drive, &place);

                if (place.libre != place.total)
                {
                    /* permettra la prise en compte de l'criture physique */
                    printf
          ("Ouvrir puis refermer le lecteur de disquettes et taper return ");
                    while (leccar (0) != RETURN);

                    putchar ('\n');
                }
            }
            else if (spawnlp (0, "rmr", "rmr", "-s", nomflop, 0) == -1)
                fputs ("Commande rmr non trouve\n", stderr);

            /* la disquette est elle vierge ? */
            if (findfirst (rechflop, &fich, 0xF7) == 0)
            {
                fputs ("La disquette n'a pu tre totalement efface\n",
                                                                stderr);
                arret ();
            }
        }
    }
}



/* interruption durant la sauvegarde */
arret ()
{
    fprintf (stderr, "Sauvegarde interrompue\n");
    exit (0);
}

/* fabrication de l'arborescence de rpertoires jusqu'au fichier courant */
mkarbor ()
{
    /* position dans le chemin d'accs et taille de celui ci */
    int i, taille;

    /* rcupration de la taille du chemin d'accs */
    taille = strlen (dest);

    /* parcours de l'arborescence */
    for (i = 3; i < taille; i++)
    {
        /* si on est positionn sur un rpertoire */
        if (dest [i] == '/')
        {
            /* la crer */
            dest [i] = 0;
            mkdir (dest);
            dest [i] = '/';
        }
    }
}
