#include <stdio.h>
#include <stdlib.h>
#include <dir.h>
#include <alloc.h>

#define szficdef     18
#define szbuf     16384
#define szliste      64
#define szchemin    256

#define octet      char

#define RETURN       13
#define sznomfic     13
#define posattrib sznomfic
#define posmtime     14

/* nom d'un fichier + nature */
typedef char ficdef [szficdef];

/* buffer de transfert */
static octet buffer [szbuf];

/* numro de la disquette de destination */
static char drive;

/* date de la sauvegarde totale */
static long datsauvtot = 0;

/* liste des rpertoires  ne pas sauvegarder */
static char  *dirsup [3];

/* nombre de rpertoires  ne pas sauvegarder */
static octet nbdirsup = 0;

/* place restante sur la disquette */
static struct
{
    unsigned libre;
    unsigned total;
    unsigned szsect;
    unsigned szgrl;
}   place;

/* chemin d'accs aux fichiers */
char dest [szchemin], *orig;


/* programme principal */
main (narg, varg)
int narg;
char *varg [];
{
     /* table de description d'un fichier */
    struct ffblk fich;

    /* caractre de "chaine" sur lequel on est positionn */
    char *poschn;


    /* initialisation : dest = <disquette>:<orig> */
    orig = dest + 2;

    /* test du nombre d'arguments */
    if (narg != 2 && (narg != 3 || varg [2][1] != ':' || varg [2][2] != 0))
        fputs ("Syntaxe : sauvinc <nom de rpertoire> [<nom de disquette>]\n",
                                                                    stderr);

    else if (varg [1][1] == ':')
        fputs ("La sauvegarde n'est accepte qu' partir du disque courant\n",
                                                                       stderr);
    else
    {
        /* positionnement sur le premier caractre de "chaine" */
        poschn = varg [1];

        /* rpter */
        do
        {
            /* si le caractre courant est un '\' */
            if (*poschn == '\\')
                /* le remplacer par '/' */
                *poschn = '/';

            /* sinon si le caractre est une lettre minuscule */
            else if (*poschn >= 'a')
                /* le remplacer par la lettre majuscule correspondante */
                *poschn = *poschn - 0x20;

            /* passer au caractre suivant */
            poschn++;
        }
        /* jusque toute la chaine a t explore */
        while (*poschn != 0);

        /* si le dernier caractre de la chaine est un '/' */
        if (*(poschn - 1) == '/')
            /* supprimer ce caractre */
            *(poschn - 1) = 0;

        /* fabriquer le chemin d'accs aux lments du rpertoire  tester */
        sprintf (orig, "%s/*.*", varg [1]);

        /* si on n'a pas trouv de fichier dans le rpertoire */
        if (findfirst (orig, &fich, 0x10) != 0)
            fprintf (stderr, "Rpertoire %s inexistant\n", varg [1]);
        else
        {
            /* terminer proprement le nom du rpertoire  sauvegarder */
            orig [strlen (orig) - 4] = 0;

            /* rcuprer le nom de la disquette destinataire de la copie */
            if (narg == 3)
                *dest = *varg [2];
            else
                *dest = 'A';

            dest [1] = ':';

            /* calcul du numro physique de la disquette destinataire */
            drive = *dest & 0x1f;

            /* rcuprer la date de la sauvegarde totale */
            recupdatsauv ();

            /* tablir la liste des rpertoires  ne pas sauvegarder */
            lecdirsup ("BAKDIR");
            lecdirsup ("HIERDIR");

            /* effectuer la sauvegarde */
            sauvdir ();
        }
    }
}

/* rcupration d'un nom de rpertoire  ne pas sauvegarder */
lecdirsup (varenv)
char *varenv;
{
    char *cardirsup;


    /* rcuprer le rpertoire dclar en variable d'environnement */
    dirsup [nbdirsup] = getenv (varenv);

    /* si le rpertoire existe */
    if (dirsup [nbdirsup])
    {
        /* suppimer le <disque>: ventuel */
        if (dirsup [nbdirsup][1] == ':')
            dirsup [nbdirsup] = dirsup [nbdirsup] + 2;

        cardirsup = dirsup [nbdirsup];

        do
        {
            /* remplacer les '\' par des '/' dans le chemin d'accs */
            if (*cardirsup == '\\')
                *cardirsup = '/';

            /* et les minuscules par des majuscules */
            if (*cardirsup >= 'a')
                *cardirsup = *cardirsup - 0X20;

            cardirsup ++;
        }
        while (*cardirsup != 0);

        /* mettre  jour le nombre de rpertoires  ne pas sauvegarder */
        nbdirsup ++;
    }
}

/* sauvegarde du rpertoire sur lequel on est positionn */
sauvdir ()
{
    /* table de description d'un fichier */
    struct ffblk fich;

    /* indicateur */
    int trouve;

    /* compteurs */
    int posliste, nbfic, i;

    /* liste des noms et attribut des fichiers d'un rpertoire */
    ficdef listefic [szliste];

    /* chemin relatif au fichier dans le rpertoire selectionn */
    char *nomfic;

    /* date de mise  jour du fichier courant */
    long datmaj;



    /* suppression des rpertoire  ne pas sauvegarder */
    for (i = 0; i < nbdirsup; i++)
        if (strcmp (orig, dirsup [i]) == 0)
            return;

    /* fabriquer le chemin d'accs aux lments du rpertoire  recopier */
    nomfic = orig + strlen (orig);
    memcpy (nomfic, "/*.*", 5);
    nomfic++;

    /* recherche du premier fichier de ce rpertoire
       on exclue un ventuel fichier label de la recherche */
    trouve = findfirst (orig, &fich, 0xf7);

    /* si ce fichier est "." */
    if (strcmp (fich.ff_name, ".") == 0)
    {
        /* passer au fichier suivant */
        trouve = findnext (&fich);

        /* si ce fichier est ".." */
        if (strcmp (fich.ff_name, "..") == 0)
            /* passer au fichier suivant */
            trouve = findnext (&fich);
    }

    /* initialisation : nombre de fichiers mmoriss */
    nbfic = 0;

    /* tantque on trouve des nouveaux fichiers dans le rpertoire */
    while (trouve == 0)
    {
        /* rcuprer la date de mise a jour du fichier */
        memcpy (&datmaj, &fich.ff_ftime, 4);

        /* si le fichier doit etre sauvegard */
        if (datmaj > datsauvtot || (fich.ff_attrib & 0x10))
        {
            /* termin si dbordement de la liste */
            if (nbfic >= szliste)
            {
                fprintf (stderr,
            "Trop de fichiers  sauvegarder, faire une sauvegarde totale\n");
                exit (-1);
            }

            /* chercher l'lment de la liste o le nouveau fichier
               doit tre insr pour respecter l'ordre alphabtique */
            for (posliste = 0; (posliste < nbfic) &&
                (strcmp (listefic [posliste], fich.ff_name)) < 0; posliste++);

            /* si la liste n'a pas t parcourrue en entier */
            if (posliste < nbfic)
                /* dcaler les fichiers restants d'une position */
                memmove (listefic [posliste + 1], listefic [posliste],
                                        (nbfic - posliste) * szficdef);

            /* recopier le nom du fichier dans la liste */
            memmove (listefic [posliste], fich.ff_name, sznomfic);

            /* recopier l'attribut du fichier */
            listefic [posliste][posattrib] = fich.ff_attrib;

            /* recopier la date de mise a jour du fichier */
            memmove (&listefic [posliste][posmtime], &fich.ff_ftime, 4);

            /* incrmenter le nombre de fichiers mmoriss */
            nbfic++;
        }

        /* rechercher le fichier suivant du rpertoire */
        trouve = findnext (&fich);
    }

    /* pour tous les fichiers mmoriss */
    for (posliste = 0; posliste < nbfic; posliste++)
    {
        /* construire les chemins d'accs aux fichiers */
        memcpy (nomfic, listefic [posliste], sznomfic);

        /* si le fichier  recopier peut tre lu */
        if (access (orig, 4) == 0)
        {
            /* si le fichier  recopier est un rpertoire */
            if (listefic [posliste][posattrib] & 0x10)
                /* faire la sauvegarde incrmentale de son arborescence */
                sauvdir ();
            else
                /* sinon sauvegarder le fichier */
                sauvfic (&listefic [posliste][posmtime]);
        }
        /* sinon (le fichier ne peut pas tre lu */
        else
            /* message d'erreur */
            fprintf (stderr, "%s : Droit d'accs insuffisant\n", orig);
    }
}

sauvfic (mtime)
unsigned long mtime;
{
    /* descripteur de fichier (pour la fonction open) */
    static int descfic;

    /* descripteurs de fichiers (pour la fonction fopen) */
    static FILE *ficin, *ficout;

    /* taille des zones de donnes lues et recopies */
    static int szlect, szrecop;


    /* ouvrir les fichiers origine et destination */
    ficin  = fopen (orig, "rb");
    ficout = fopen (dest, "wb");

    /* si probleme a l'ouverture du fichier destination */
    if (ficout == 0)
    {
        /* crr son arborescence */
        mkarbor ();

        /* et ressayer de l'ouvrir */
        ficout = fopen (dest, "wb");

        /* termin si on y arrive pas */
        if (ficout == 0)
        {
            fputs ("La disquette est certainement protge en criture\n",
                                                                    stderr);
            exit (-2);
        }
    }

    /* lire un morceau du fichier origine */
    szlect = fread (buffer, 1, szbuf, ficin);

    /* tantque non fin de fichier */
    while (szlect > 0)
    {
        /* recopier la zone lue */
        szrecop = fwrite (buffer, 1, szlect, ficout);

        /* si problme lors de la copie */
        if (szrecop < szlect)
        {
            /* manque d'espace disque ? */
            getdfree (drive, &place);

            /* Editer le message d'erreur adquat */
            if ((place.libre * place.szsect * place.szgrl) < szlect)
                fprintf (stderr,
        "Manque de place sur la disquette, refaire une sauvegarde totale\n");
            else
                fputs ("Erreur indtermine\n", stderr);

            /* fermer et dtruire le fichier mal recopi */
            fclose (ficout);
            unlink (dest);

            /* sauvegarde termine */
            exit (0);
        }

        /* lire la suite du fichier d'origine */
        szlect = fread (buffer, 1, szbuf, ficin);
    }

    /* fermer les fichiers */
    fclose (ficin);
    fclose (ficout);

    /* corriger la date de mise  jour du fichier destination */
    descfic = open (dest, 0x8001);
    setftime (descfic, mtime);
    close (descfic);

    /* diter le nom du fichier transfr */
    printf ("%s\n", dest);
}

/* lecture et retour de la rponse a une question */
char reponse ()
{
    char rep;

    /* lire le rponse */
    rep = getche ();

    putchar ('\n');

    /* retourner le rponse */
    return (rep | 0x20);
}

/* changement de disquette pour continuer la sauvegarde */
recupdatsauv ()
{
    /* nombre de disquettes essayes pour trouver la date sauvegarde totale */
    octet passage;

    /* fichier contenant la date de la sauvegarde totale */
    char finsauvgen [5];

    /* table de description du fichier finsauvgen */
    struct ffblk fich;


    /* initialisation : fichier contenant la date de la sauvegarde totale */
    finsauvgen [0] = dest [0];
    finsauvgen [1] = dest [1];
    finsauvgen [2] = '/';
    finsauvgen [3] = 0x7f;
    finsauvgen [4] = 0;

    /* rcupration de la date de la sauvegarde totale */
    passage = 1;
    do
    {
        printf ("Introduire la dernire disquette ");
        printf ("de la sauvegarde totale et taper <return> " );

        while (getchar () != '\n');

        /* controler la conformit de la disquette */
        if (findfirst (finsauvgen, &fich, 0xff) == 0)
            /* rcuprer la date de la sauvegarde totale */
            memcpy (&datsauvtot, &fich.ff_ftime, 4);
        else
            fputs ("Vous n'avez pas introduit la bonne disquette\n", stderr);
    }
    while (datsauvtot == 0 && passage++ < 3);

    /* termin si disquette non trouve */
    if (passage >= 3)
        exit (-2);

    /* demander la disquette de sauvegarde */
    printf ("Mettre la disquette de sauvegarde incrmentale et taper <return> ");
    while (getchar () != '\n');

    /* la disquette est elle vierge ? */
    getdfree (drive, &place);

    if (place.libre != place.total)
    {
        /* non, on demande l'avis de l'oprateur */
        printf ("La disquette n'est pas vierge, voulez vous la rutiliser ? ");

        if (reponse () == 'n')
            exit (-1);

        /* on efface la disquette en rinitialisant la table d'allocation */
        absread (drive -1, 1, 1, buffer);
        memset (&buffer [3], 0, szbuf - 4);
        abswrite (drive -1, 16, 1, buffer);

        /* ncessaire pour la prise en compte de l'criture physique */
        printf("Ouvrir puis refermer le lecteur de disquettes et taper return");
        while (getch () != RETURN);
        putchar ('\n');

        /* la disquette est elle vierge ? */
        getdfree (drive, &place);

        if (place.libre != place.total)
        {
            fputs ("La disquette n'a pu tre totalement efface\n", stderr);
            exit (-2);
        }
    }
}

/* fabrication de l'arborescence de rpertoires jusqu'au fichier courant */
mkarbor ()
{
    /* position dans le chemin d'accs et taille de celui ci */
    int i, taille;

    /* rcupration de la taille du chemin d'accs */
    taille = strlen (dest);

    /* parcours de l'arborescence */
    for (i = 3; i < taille; i++)
    {
        /* si on est positionn sur un rpertoire */
        if (dest [i] == '/')
        {
            /* la crer */
            dest [i] = 0;
            mkdir (dest);
            dest [i] = '/';
        }
    }
}
