#include <stdio.h>
#include <dir.h>
#include <alloc.h>


#define szficdef     18
#define szbuf     16384
#define szchemin    256
#define memsyst    5000   /* mmoire rserve au systme (1100 octets min) */
#define SZMAXBOOT 70000   /* taille maximale des fichiers sauvegards */
#define sznomfic     13
#define posattrib sznomfic
#define posmtime     14

/* commandes  recopier sur la disquette */
static char *commandes [sznomfic] = {"restor", "df", "grl", "format",
                                     "fdisk", "keyb", "keyboard", "activep",
                                     "masquep", 0};

typedef char ficdef [szficdef]; /* nom d'un fichier + nature */

static char buffer [szbuf];     /* buffer de transfert */
static char drive;              /* numro de la disquette de destination */
char dest [szchemin], *orig;    /* chemins d'accs aux fichiers */

static struct                   /* place restante sur la disquette */
{
    unsigned libre;
    unsigned total;
    unsigned szsect;
    unsigned szgrl;
}   place;

/* programme principal */
main (narg, varg)
int narg;
char *varg [];
{
    int i;


    /* initialisation : dest = <disquette>:<orig> */
    orig = dest + 2;

    /* test du nombre d'arguments */
    if (narg != 1 && (narg != 2 || varg [1][1] != ':' || varg [1][2] != 0))
    {
        fputs ("Syntaxe : sauvroot [<nom de disquette>]\n", stderr);
        exit (-1);
    }
    else
    {
        /* fabriquer le chemin d'accs aux lments du rpertoire "/" */
        sprintf (dest, "A:");

        /* rcuprer le nom de la disquette destinataire de la copie */
        if (narg == 2)
            *dest = *varg [1] & 0x5f;

        /* calcul du numro physique de la disquette destinataire */
        drive = *dest & 0x1f;

        /* demander d'insrer la disquette */
        printf ("Insrer la disquette root et taper Return ");

        /* attendre l'intervention de l'oprateur */
        while (getchar () != '\n');

        /* si la disquette est vierge */
        getdfree (drive, &place);
        if (place.libre == place.total)
        {
            /* effectuer la sauvegarde */
            sauvdir ();

            /* sauvegarder les commandes systme */
            for (i = 0; commandes [i] != 0; i++)
                sauvecom (commandes [i]);

            /* mettre  jour le fichier autoexec.bat */
            majautoexec ();

            exit (1);
        }
        else
        {
            /* sinon, message d'erreur */
            fputs ("La disquette n'est pas vierge, reformattez la\n", stderr);
            exit (0);
        }
    }
}


/* sauvegarde du rpertoire sur lequel on est positionn */
sauvdir ()
{
    /* table de description d'un fichier */
    struct ffblk fich;

    /* indicateur */
    int trouve;

    /* compteurs */
    int posliste, nbfic, szliste;

    /* liste des noms et attribut des fichiers d'un rpertoire */
    ficdef *listefic;

    /* chemin relatif aux fichiers dans le rpertoire selectionne */
    char *nomfic;


    /* fabriquer le chemin d'accs aux lments du rpertoire  recopier */
    puts (dest);
    nomfic = orig + strlen (orig);
    memcpy (nomfic, "/*.*", 5);
    nomfic++;

    /* recherche du premier fichier de ce rpertoire
       on exclue un ventuel fichier label de la recherche */
    trouve = findfirst (orig, &fich, 0xf7);

    /* copie des 2 premiers fichiers dans leur ordre d'apparition */
    for (posliste = 0; posliste < 2; posliste++)
    {
        /* construire les chemins d'accs aux fichiers */
        memcpy (nomfic, fich.ff_name, sznomfic);

        /* sauvegarder le fichier */
        sauvfic ((long) &fich.ff_ftime, 0);

        /* passer au fichier suivant */
        trouve = findnext (&fich);
    }

    /* initialisation : nombre de fichiers mmoriss */
    nbfic = 0;

    /* allocation du tableau listefic */
    szliste = (coreleft () - memsyst) / szficdef;
    listefic = malloc (szliste * szficdef);

    /* tantque on trouve des nouveaux fichiers dans le rpertoire */
    while (trouve == 0)
    {
        /* on ne sauvegarde pas les trs gros fichiers sur cette disquette */
        if (fich.ff_fsize < SZMAXBOOT)
        {
            /* si liste de fichiers trop petite */
            if (nbfic >= szliste)
            {
                fputs ("Trop de fichiers ou de sous rpertoires dans \"/\"\n", stderr);
                exit (0);
            }

            /* chercher l'lment de la liste o le nouveau fichier
               doit tre insr pour respecter l'ordre alphabtique */
            for (posliste = 0; (posliste < nbfic) &&
                (strcmp (listefic [posliste], fich.ff_name)) < 0; posliste++);

            /* si la liste n'a pas t parcourrue en entier */
            if (posliste < nbfic)
                /* dcaler les fichiers restants d'une position */
                memmove (listefic [posliste + 1], listefic [posliste],
                                           (nbfic - posliste) * szficdef);

            /* recopier le nom du fichier dans la liste */
            memmove (listefic [posliste], fich.ff_name, sznomfic);

            /* recopier l'attribut du fichier */
            listefic [posliste][posattrib] = fich.ff_attrib;

            /* recopier la date de mise  jour du fichier */
            memmove (&listefic [posliste][posmtime], &fich.ff_ftime, 4);

            /* incrmenter le nombre de fichiers mmoriss */
            nbfic++;
        }

        /* rechercher le fichier suivant du rpertoire */
        trouve = findnext (&fich);
    }

    /* pour tous les fichiers mmoriss */
    for (posliste = 0; posliste < nbfic; posliste++)
    {
        /* construire les chemins d'accs aux fichiers */
        memcpy (nomfic, listefic [posliste], sznomfic);

        /* si le fichier  recopier peut tre lu */
        if (access (orig, 4) == 0)
        {
            /* si le fichier  recopier est un rpertoire */
            if (listefic [posliste][posattrib] & 0x10)
            {
                /* crer le rpertoire de destination */
                if (mkdir (dest) == 0)
                    printf ("%s\n", dest);
                else
                    /* message d'erreur ventuel */
                    fprintf (stderr, "impossible de crer le rpertoire %s\n",
                                                                       dest);
            }
            /* sinon sauvegarder le fichier */
            else
                sauvfic ((long) &listefic [posliste][posmtime], 0);
        }
        /* sinon (le fichier ne peut pas tre lu */
        else
            /* message d'erreur */
            fprintf (stderr, "%s : Droit d'accs insuffisant\n", orig);
    }

    /* librer la liste des fichiers du rpertoire */
    free (listefic);

}


/* sauvegarde du fichier sur lequel on est positionn */
sauvfic (mtime, offset)
unsigned long mtime;   /* date et heure de mise  jour */
int           offset;  /* permet de retrouver le disque d'origine
                          d'un fichier de commande */
{
    /* descripteur de fichier (pour la fonction open) */
    static int descfic;

    /* descripteurs de fichiers (pour la fonction fopen) */
    static FILE *ficin, *ficout;

    /* taille des zones de donnes lues et recopies */
    static int szlect, szrecop;


    /* ouvrir les fichiers origine et destination */
    ficin  = fopen (orig, "rb");

    if (ficin == 0 && offset != 0)
    {
        /* cas trs particulier : on a voulu ouvrir un fichier
           de commandes qui n'est pas sur le disque courant.
           on retente l'ouverture avec le nom du disque */
        *dest = *dest + offset;
        ficin = fopen (dest, "rb");
        *dest = *dest - offset;
    }

    ficout = fopen (dest, "wb");

    /* lire un morceau du fichier origine */
    szlect = fread (buffer, 1, szbuf, ficin);

    /* tantque non fin de fichier */
    while (szlect > 0)
    {
        /* recopier la zone lue */
        szrecop = fwrite (buffer, 1, szlect, ficout);

        /* si problme lors de la copie */
        if (szrecop < szlect)
        {
            /* manque d'espace disque ? */
            getdfree (drive, &place);

            /* message d'erreur */
            if ((place.libre * place.szsect * place.szgrl) < szlect)
                fputs ("Manque d'espace disque\n", stderr);
            else
                fputs ("Erreur indtermine\n", stderr);

            /* fermer et dtruire le fichier mal recopi */
            fclose (ficout);
            unlink (dest);

            /* interrompre la sauvegarde */
            fputs ("Sauvegarde interrompue\n", stderr);
            exit (0);
        }

        /* lire la suite du fichier d'origine */
        szlect = fread (buffer, 1, szbuf, ficin);
    }

    /* fermer les fichiers */
    fclose (ficin);
    fclose (ficout);

    /* corriger la date de mise  jour du fichier destination */
    descfic = open (dest, 0x8001);
    setftime (descfic, mtime);
    close (descfic);

    /* diter le nom du fichier transfr */
    printf ("%s\n", dest);
}


/* sauvegarde d'une commande systme */
sauvecom (nomfic)
char *nomfic;
{
    struct ffblk fich;  /* table de description d'un fichier */
    char nomexe [13];   /* nom du fichier de commande avec extention */
    char *chemin;       /* chemin d'accs  ce fichier */
    int i;              /* compteur de caractres */


    /* chercher le chemin d'accs au fichier de commande */
    sprintf (nomexe, "%s.EXE", nomfic);

    chemin = searchpath (nomexe);

    if (chemin == 0)
    {
        sprintf (nomexe, "%s.COM", nomfic);
        chemin = searchpath (nomexe);
    }

    if (chemin == 0)
    {
        sprintf (nomexe, "%s.SYS", nomfic);
        chemin = searchpath (nomexe);
    }

    /* si commande trouve */
    if (chemin != 0)
    {
        /* rcuprer le chemin d'accs */
        for (i = 3; chemin [i] != 0; i++)
        {
            if (chemin [i] == '\\')
            {
                /* en crant les sous rpertoires ncessaires */
                dest [i] = 0;
                mkdir (dest);
                dest [i] = '/';
            }
            else
                dest [i] = chemin [i];
        }
        dest [i] = 0;

        /* sauver le fichier de commande */
        findfirst (chemin, &fich, 0xf7);
        sauvfic ((long) &fich.ff_ftime, (*chemin - *dest) & 0x1F);
    }
    else
        fprintf (stderr, "Commande %s non trouve\n", nomfic);
}


/* mise a jour du fichier AUTOEXEC.BAT pour dmarrage sur la disquette */
majautoexec ()
{
    char autoexec [20];     /* nouveau fichier AUTOEXEC.BAT sur la disquette */
    FILE *ficin, *ficout;   /* descripteurs de fichiers */
    char car1, car2;        /* 2 caractres consecutifs du AUTOEXEC.BAT d'origine */


    strcpy  (orig, "/autoexec.bat");
    sprintf (autoexec, "%c:/autoexec.dsk", *dest);

    /* rebaptiser le fichier autoexec.bat destin au disque dur */
    if (rename (dest, autoexec) != 0)
    {
        unlink (autoexec);
        rename (dest, autoexec);
    }

    /* on va crer une version diffrente de ce fichier pour la disquette */
    ficin  = fopen (orig, "rb");
    ficout = fopen (dest, "wb");

    if (ficin != 0 && ficout != 0)
    {
        car2 = getc (ficin);

        while (car2 != EOF)
        {
            car1 = car2;
            car2 = getc (ficin);

            /* on supprime les <nom de disque>: */
            if (car2 == ':' && 'a' <= (car1 | ' ') && (car1 | ' ') <= 'z')
            {
                car1 = getc (ficin);
                car2 = getc (ficin);
            }

            putc (car1, ficout);
        }

        fclose (ficin);
        fclose (ficout);
    }
    else
        fputs ("Impossible de mettre  jour le fichier AUTOEXEC.BAT\n", stderr);
}
