#include <stdio.h>
#include <dos.h>

#define nbpistes     80
#define carpistemax  18

#define carOK        0xB2
#define carOKdebp    0xDB

static char     *buffer;    /* buffer de lecture */
static unsigned char nflop; /* numro associ au lecteur de disquettes choisi */
static unsigned posit;      /* positionnement sur la disquette */
static int      secarreaux; /* secpiste / carreaux */
static int      debpiste;   /* pour localiser les de'buts de piste a l'e'cran */


/* programme principal */
main (narg, varg)
int narg;
char *varg [];
{
    struct dfree place;  /* description des caractristiques du floppy */
    unsigned szpiste;    /* taille suppose d'une piste (80 pistes) */
    int      carreaux;   /* longueur reprsentation graphique des pistes */    int      secpiste;   /* nombre de secteurs par piste */
    int i;               /* compteur de pistes */


    /* prise en compte du nom de la disquette s'il est pass en paramtre */
    if (--narg > 0)
    {
        if (narg == 1 && (varg [1][1] == 0 || varg [1][1] == ':'))
            nflop = (*varg [1] & 0x1f) - 1;
        else
        {
            fprintf (stderr, "Syntaxe : testflop [<nom de disque>]\n");
            exit ();
        }
    }
    else
        /* par dfaut, la disquette est A: */
        nflop = 0;

    /* lecture des caractristiques de la disquette */
    getdfree (nflop + 1, &place);

    /* vrification avant lecture */
    if (place.df_sclus < 0)
    {
        fprintf (stderr, "Disquette manquante ou non formatte\n");
        exit ();
    }

    /* calcul du nombre de secteurs par pistes */
    secpiste = place.df_total * place.df_sclus / nbpistes;

    if ((place.df_total * place.df_sclus) % nbpistes != 0)
        secpiste++;

    /* calcul de la taille effective d'une piste */
    szpiste = secpiste * place.df_bsec;

    /* taille de la reprsentation "graphique" d'une piste */
    secarreaux = 0;

    do
    {
        carreaux = secpiste / ++secarreaux;
    }
    while (carreaux > carpistemax);


    /* allocation du buffer de lecture */
    buffer = (void *) malloc (szpiste);

    if (buffer == 0)
    {
        fputs ("Manque de place mmoire\n", stderr);
    }


    /* examen de la disquette */
    posit = 0;

    for (i = 1; i <= nbpistes; i++)
    {
        if ((i & 0x3) == 1)
            printf ("%2d ", i);

        debpiste = 1;
        testzone (carreaux);

        if ((i & 0x3) == 0)
            printf (" %2d\n", i);
    }
}


testzone (int nbcarreaux)
{
    int i;
    int nouvtaille;
    int reste;


    if (absread (nflop, nbcarreaux * secarreaux, posit, buffer) == 0)
    {
        if (debpiste)
        {
            putchar (carOKdebp);
            debpiste = 0;
        }
        else
            putchar (carOK);

        for (i = 1; i < nbcarreaux; i++)
            putchar (carOK);

        posit = posit + nbcarreaux * secarreaux;
    }
    else
    {
        if (nbcarreaux > 1)
        {
            nouvtaille = nbcarreaux / 4;

            if (nouvtaille == 0)
                nouvtaille++;

            reste = nbcarreaux;

            while (reste > nouvtaille)
            {
                testzone (nouvtaille);
                reste = reste - nouvtaille;
            }

            testzone (reste);
        }
        else
        {
            putchar ('D');

            posit = posit + secarreaux;
        }
    }
}