/* Module trouvchn

   Ce module est destin  permettre la recherche et la localisation dans
   la ligne de chaines de caractres ou d'expressions rgulires  partir
   des utilitaires vi et drivs.

   Il est recommand de compiler ce module avec le mme modle mmoire
   que l'outil qui l'utilise (le modle Compact est recommand).

*/

#include <stdio.h>

#define szmaxexpr    255

#define CR   13

#define octet unsigned char
#define int16 unsigned short


static octet optdeb;             /* recherche seulement en dbut de ligne */
static octet optfin;             /* recherche seulement en fin de ligne */

static octet far *carlig;        /* caractre de la ligne  analyser */
static int16 szlig;              /* taille de la ligne  analyser */
static octet expr  [szmaxexpr];  /* expression  rechercher */
static octet occur [szmaxexpr];  /* occurence caractres de l'expression */
static octet szexpr;             /* taille de l'expression  rechercher */
static octet nbcarmin;           /* taille min chaine contenant expression */

static octet touscar;        /* codage si n'importe quel caractre accept */

/* Procdures d'interface avec le programme appelant */


/* mmorisation de la chaine (ou l'expression)  rechercher
   retourne la taille de l'expression rgulire, -1 si erreur */

int memoexpr (chaine, optregul)
char  *chaine;
octet optregul;
{
    preanalyse (chaine);

    if (optregul == 1)
    {
        sepoccur ();

        simplifie ();
    }

    return (szexpr);
}



/* Recherche de la chaine ou de l'expression mmorise */
int rechexpr (ligne, szligne, optregul, posdeb, posfin, sens)
octet far *ligne;
int16 szligne;
octet optregul;
int16 *posdeb;
int16 *posfin;
char  sens;
{
    carlig = ligne;
    szlig  = szligne;

    if (sens < 0 && *posfin == 0)
        return (0);

    if (optregul == 0)
        return (trouvchn (posdeb, posfin, sens));
    else
    {
        if (sens > 0)
            return (trouvexpr (*posdeb, 0, optdeb, posdeb, posfin, sens));
        else
            return (trouvexpr (0, 0, optdeb, posdeb, posfin, sens));
    }
}

/* Pranalyse de l'expression  rechercher */
preanalyse (char *exporig)
{
    octet valcar, i;


    /* initialisation */
    szexpr = 0;

    /* recherche seulement en dbut de ligne ? */
    if (*exporig == '^')
    {
        optdeb = 1;
        exporig++;
    }
    else
        optdeb = 0;

    optfin = 0;

    /* analyse des caractres de l'expression */
    while (*exporig != 0)
    {
        switch (*exporig)
        {
            /* recherche seulement en fin de ligne ? */
            case '$' : if (*(exporig + 1) == 0)
                           optfin = 1;
                       else
                           expr [szexpr++] = '$';

                       break;

            /* traitement des '\' */
            case '\\': exporig++;

                       switch (*exporig)
                       {
                           /* caractre exprim en hexa */
                           case 'x' : for (i = 0; i < 2; i++)
/* recentrage  gauche */
{
    exporig++;

    valcar = *exporig - '0';

    if (valcar > 16)
        valcar -= 7;

    if ((valcar & 0xD0) != 0)
    {
        fprintf (stderr, "Valeur hexadcimale incorrecte\n");

        exit ();
    }

    expr [szexpr] = (expr [szexpr] << 4) | valcar;
}
/* fin du recentrage  gauche */
                                      szexpr++;
                                      break;

                           /* caractre CR */
                           case 'r' : expr [szexpr++] = CR;
                                      break;

                           default  : /* le '\' est conserve pour la suite */
                                      exporig--;
                                      expr [szexpr++] = '\\';
                       }

                       break;

            /* cas gnral */
            default  : expr [szexpr++] = *exporig;
        }

        /* analyser le caractre suivant */
        exporig++;
    }
}

/* sparation des caractres et de leurs occurences */
int sepoccur ()
{
    octet i, j, k;       /* compteurs */
    octet chertouscar;   /* indique si touscar initialis */


    /* variable touscar non encore initialise */
    chertouscar = 1;

    /* positionnement en debut d'expression */
    i = 0;
    j = 0;

    /* tantque expression non traite en entier */
    while (i < szexpr)
    {
        /* si mtacaractre '!' ou '>' */
        if (expr [i] == '!' || expr [i] == '>')
        {
            /* erreur si fin de chaine */
            if (i + 1 == szexpr)
                err_expr (
          "Le mtacaractre '%c' ne peut terminer une expression", expr [i]);

            /* erreur si "!." ou ">." */
            else if (expr [i + 1] == '.')
                err_expr ("Mtacaractres '%c' et '.' incompatibles",
                                                                   expr [i]);
            else
                /* sinon mmoriser le mtacaractre comme occurence */
                occur [j] = expr [i++];
        }
        /* sinon initialiser l'occurence */
        else
            occur [j] = '1';

        /* si mtacaractre '.' */
        if (expr [i] == '.')
        {
            /* si variable "n'importe quel caractre" non initialise */
            if (chertouscar == 1)
            {
                touscar = 0xff;
                k = 0;

                /* rechercher un caractre non utilis dans l'expression */
                while (k < szexpr)
                {
                    if (expr [k++] == touscar)
                    {
                        touscar--;
                        k = 0;
                    }
                }

                /* la variable a t initialise avec le caractre trouv */
                chertouscar = 0;
            }

            /* le caractre courant signifie "n'importe quel caractre" */
            expr [i] = touscar;
        }
        /* sinon si caractre '\', passer au caractre suivant */
        else if (expr [i] == '\\')
            i++;

        /* mmoriser le caractre courant */
        expr [j] = expr [i++];

        /* si le caractre suivant prcise un nombre d'occurences */
        if (expr [i] == '?' || expr [i] == '*' || expr [i] == '+')
        {
            /* si pas de mtacaractre '!' ou '>' */
            if (occur [j] == '1')
                /* mmoriser le nombre d'occurences et avancer d'un caractre */
                occur [j++] = expr [i++];
            else
            {
                if (occur [j] == '>' || expr [i] == '?')
                    err_expr ("Mtacaractres '%c' et '%c' incompatibles",
                                                        occur [j], expr [i]);

                else if (optfin == 0 || i + 1 < szexpr)
                    err_expr (
       "Mtacaractres '%c' et '%c' autoriss seulement en fin d'expression",
                                                        occur [j], expr [i]);
                else
                {
                    if (expr [i++] == '+')
                        expr [++j] = expr [j];

                    occur [j++] = '$';
                }
            }
        }
        else
            /* sinon 1 occurence du caractre (dj mmoris) */
            j++;
    }

    /* mmoriser la taille de l'expression traite */
    if (szexpr >= 0)
        szexpr = j;
}

/* interruption de l'analyse de l'expression aprs une erreur */
err_expr (format, car1, car2)
char *format;
char car1;
char car2;
{
    putchar (CR);
    effligne ();
    printf (format, car1, car2);

    /* analyse termine */
    szexpr = -1;
}

/* simplification de l'expression pour rendre la recherche dterministe */
simplifie ()
{
    octet i, j;    /* compteurs */


    /* parcour de l'expression */
    for (i = 1; i < szexpr; i++)
    {
        /* si 2 caractres conscutifs identiques dans l'expression */
        if (expr [i - 1] == expr [i])
        {
            /*  <car><occurence><car>  ==>  <car><car><occurence>  */
            if (occur [i] == '1' && occur [i - 1] != '!'
                                 && occur [i - 1] != '>')
            {
                occur [i] = occur [i - 1];
                occur [i - 1] = '1';
            }

            switch (occur [i - 1])
            {
                           /*  <car><car>*  ==>  <car>+  */
                case '1' : if (occur [i] == '*')
                           {
                               occur [i - 1] = 0;
                               occur [i] = '+';
                           }
                           break;

                           /*  <car>*<car>?  ==>  <car>*  */
                case '*' : if (occur [i] == '?')
                               occur [i] = '*';

                           /*  <car>*<car>*  ==>  <car>*
                               <car>*<car>+  ==>  <car>+
                               <car>?<car>*  ==>  <car>*
                               <car>?<car>+  ==>  <car>+  */
                case '?' : if (occur [i] == '*' || occur [i] == '+')
                               occur [i - 1] = 0;

                           break;

                           /*  <car>+<car>+  ==>  <car><car>+  */
                case '+' : if (occur [i] == '+')
                               occur [i - 1] = '1';

                           /*  <car>+<car>*  ==>  <car>+
                               <car>+<car>?  ==>  <car>+  */
                           else if (occur [i] == '*' || occur [i] == '?')
                           {
                               occur [i - 1] = 0;
                               occur [i] = '+';
                           }
                           break;
            }
        }

        /* sinon si .* ou .+ suivi d'un caractre avec occurence */
        else if (expr [i - 1] == touscar &&
                 (occur [i] == '?' || occur [i] == '*' || occur [i] == '+'))
        {
            if (occur [i - 1] == '*' || occur [i - 1] == '+')
            {
                /*  .*<car>+  ==>  .*<car>  et  .+<car>+  ==>  .+<car>  */
                if (occur [i] == '+')
                    occur [i] = '1';

                /*  .*<car>*  ou  .*<car>?  ==>  .*
                    .+<car>*  ou  .+<car>?  ==>  .+  */
                else
                    occur [i] = 0;
            }
        }

        /* sinon si caractre avec occurence suivi de .* ou .+  */
        else if (expr [i] == touscar && (occur [i - 1] == '?'
              || occur [i - 1] == '*' || occur [i - 1] == '+'))
        {
            if (occur [i] == '*' || occur [i] == '+')
            {
                /*  <car>+.*  ==>  <car>.*  et  <car>+.+  ==>  <car>.+  */
                if (occur [i - 1] == '+')
                    occur [i - 1] = '1';

                /*  <car>*.*  ou  <car>?.*  ==>  .*
                    <car>*.+  ou  <car>?.+  ==>  .+  */
                else
                    occur [i - 1] = 0;
            }
        }
    }

    j = 0;
    nbcarmin = 0;

    /* compacter l'expression en supprimant les occurences effaces et
       calculer la taille minimale d'une chaine contenant l'expression */
    for (i = 0; i < szexpr; i++)
    {
        if (occur [i] != 0)
        {
            expr  [j]   = expr  [i];
            occur [j++] = occur [i];

            if (occur [i] == '1' || occur [i] == '+'
             || occur [i] == '!' || occur [i] == '>')
                nbcarmin++;
        }
    }

    /* mmoriser la taille de l'expression simplifie */
    szexpr = j;
}

/* recherche de la prochaine occurence de la chaine dans la ligne */
int trouvchn (posdeb, posfin, sens)
int16 *posdeb;   /* position du premier caractre de la chaine */
int16 *posfin;   /* position du dernier caractre de la chaine */
char  sens;      /* sens d'exploration de la ligne */
{
    int16 rechdeb, rechfin;  /* dbut et fin de la zone de recherche */
    int16 i, j;              /* position dans la ligne et dans la chaine */


    /* termin si chaine plus longue que la ligne */
    if (szexpr > szlig)
        return (0);

    /* cas particulier : chaine vide */
    if (szexpr == 0 && (optdeb | optfin) > 0)
    {
        if (optdeb)
        {
           if (optfin)
           {
               *posdeb = 0;
               *posfin = -1;
               return (szlig == 0);
           }
           else if (*posdeb == 0 || sens < 0)
           {
               *posdeb = 0;
               *posfin = -1;
               return (1);
           }
        }
        else
        {
            if (sens > 0 || *posfin == szlig)
            {
                *posdeb = szlig;
                *posfin = szlig - 1;
                return (1);
            }
        }

        return (0);
    }

    /* initialisation de la fin de la zone de recherche */
    if (optdeb == 0)
        rechfin =  szlig - szexpr;
    else
        rechfin = 0;

    /* initialisation du dbut de la zone de recherche */
    if (optfin == 0)
        rechdeb = 0;
    else
        rechdeb = szlig - szexpr;

    /* prise en compte des limites imposes par le programme appelant */
    if (sens > 0)
    {
        if (rechdeb < *posdeb)
            rechdeb = *posdeb;

        i = rechdeb;
    }
    else
    {
        if (rechfin > *posfin)
            rechfin = *posfin;

        i = rechfin;
    }

    /* recherche de la chaine dans la ligne */
    while (rechdeb <= i && i <= rechfin)
    {
        /* si le premier caractre est bon */
        if (carlig [i] == expr [0])
        {
            j = 1;

            /* on compare les caractres suivants */
            while ((carlig [i + j] == expr [j]) && (j < szexpr))
                j++;

            /* termin s'ils sont tous bons */
            if (j == szexpr)
            {
                *posdeb = i;
                *posfin = i + j - 1;
                return (1);
            }
        }

        i = i + sens;
    }

    /* la chaine n'a pas t trouve */
    return (0);
}

/* recherche de la prochaine occurence de l'expression dans la ligne */
int trouvexpr (debrech, debexpr, opdeb, posdeb, posfin, sens)
int16 debrech;   /* position dans la ligne o commence la recherche */
octet debexpr;   /* position dans l'expression o commence l'analyse */
octet opdeb;     /* indique si l'expression doit commencer en dbut de ligne */
int16 *posdeb;   /* position du premier caractre de l'expression */
int16 *posfin;   /* position du dernier caractre de l'expression */
char  sens;      /* sens d'exploration de la ligne */
{
    int16 finrech;
    octet contin;
    int16 i, j;
    int16 mempos;
    int   retour;


    /* cas particulier : chaine vide */
    if (szexpr == 0 && (optdeb | optfin) > 0)
    {
        if (optdeb)
        {
           if (optfin)
           {
               *posdeb = 0;
               *posfin = -1;
               return (szlig == 0);
           }
           else if (*posdeb == 0 || sens < 0)
           {
               *posdeb = 0;
               *posfin = -1;
               return (1);
           }
        }
        else
        {
            if (sens > 0 || *posfin == szlig)
            {
                *posdeb = szlig;
                *posfin = szlig - 1;
                return (1);
            }
        }

        return (0);
    }

    /* initialisation recherche en dbut de ligne ou sur toute la ligne */
    if (opdeb == 0)
        finrech = debrech + szlig - nbcarmin;
    else
        finrech = debrech;

    /* prise en compte des limites imposes par le programme appelant */
    if (sens > 0)
    {
        if (debrech < *posdeb)
            debrech = *posdeb;
    }
    else
    {
        if (finrech > *posfin)
            finrech = *posfin;
    }

    /* recherche de l'expression dans la ligne */
    while (debrech <= finrech)
    {
        /* initialisation */
        contin = 1;

        if (sens > 0)
            i = debrech ++;
        else
            i = finrech --;

        mempos = i;

        /* pour tous les caractres de l'expression */
        for (j = debexpr; j < szexpr && contin == 1; j++)
        {
            /* termin si la ligne est trop courte */
            if (i >= szlig)
                if (sens > 0)
                    return (0);
                else
                    contin = 0;

            /* si n'importe quel caractre est accept en position courante */
            if (expr [j] == touscar)
            {
                switch (occur [j])
                {
                    case '1' : i++;
                               break;

                    case '?' : retour = trouvexpr (i, j + 1, 1, posdeb, posfin, sens);
                               *posdeb = mempos;

                               if (retour)
                                   return (1);
                               else
                                   i++;

                               break;

                    case '+' : i++;
                    case '*' : j++;
                               *posdeb = i;
                               retour = trouvexpr (i, j, 0, posdeb, posfin, 1);
                               *posdeb = mempos;
                               return (retour);
                }
            }

            /* sinon si le caractre courant dans la
               ligne coincide avec celui de l'expression */
            else if (carlig [i] == expr [j])
            {
                /* si occurence multiple du caractre possible */
                if (occur [j] == '+' || occur [j] == '*')
                {
                    /* sauter ces occurences */
                    while (carlig [++i] == expr [j]);
                }
                /* sinon si on ne voulait pas ce caractre */
                else if (occur [j] == '!')
                {
                    /* echec de l'analyse */
                    contin = 0;
                }
                /* sinon passer au caractre suivant */
                else
                    i++;
            }
            /* sinon, le caractre n'est pas celui recherch */
            else
            {
                /* si le caractre cherch doit figurer au moins une fois */
                if (occur [j] == '1' || occur [j] == '+')
                {
                    /* echec de l'analyse */
                    contin = 0;
                }
                /* sinon si on ne voulait pas ce caractre */
                else if (occur [j] == '!')
                {
                    /* passer au caractre suivant */
                    i++;
                }
                /* sinon si mtacaractre '>' */
                else if (occur [j] == '>')
                {
                    /* sauter tous les caractres jusqu' celui recherch */
                    while (carlig [++i] != expr [j])
                        if (i >= szlig)
                            /* termin si caractre non trouv */
                            return (0);

                    /* passer au caractre suivant */
                    i++;
                }
                /* sinon si le caractre ne doit plus apparaitre dans la ligne */
                else if (occur [j] == '$')
                {
                    /* explorer la fin de la ligne */
                    while (carlig [++i] != expr [j])
                    {
                        if (i >= szlig)
                        {
                            /* termin on n'a pas trouv de caractre */
                            *posdeb = mempos;
                            *posfin = szlig - 1;
                            return (1);
                        }
                    }

                    /* sinon echec de l'analyse */
                    contin = 0;
                }
                /* sinon on poursuivra l'analyse sur le caractre courant */
            }
        }

        /* si expression trouve */
        if (contin == 1)
        {
            /* controle si position par rapport  la fin de ligne correcte */
            if (optfin == 0 || i == szlig)
            {
                *posdeb = mempos;
                *posfin = i - 1;
                return (1);
            }
        }
    }

    /* l'expression n'a pas t trouve */
    return (0);
}
