#include <stdio.h>
#include <dir.h>

#define szchemin    256

#define octet      char

#define CTRLC         3
#define sznomfic     13
#define szbuf     16384

static octet numdisk = 0;        /* numro de la disquette */

char chemin [szchemin + 2];      /* chemin d'accs aux fichiers */

static octet buffer [szbuf];     /* buffer de lecture */

static int   szlect;             /* nombre d'octets lus simultanment */


/* programme principal */
main (narg, varg)
int narg;
char *varg [];
{
    /* initialisation */
    strcpy (chemin, "A:");

    /* test du nombre d'arguments */
    if (narg != 1 && (narg != 2 || varg [1][1] != ':' || varg [1][2] != 0))
    {
        fprintf (stderr, "Syntaxe : tstsauv [<nom de disquette>]\n");
        exit ();
    }

    /* rcuprer le nom du lecteur des disquettes  tester */
    if (narg == 2)
        *chemin = *varg [1];

    /* test de toutes les disquettes de la sauvegarde */
    do
    {
        /* demander une disquette */
        numdisk++;
        printf ("Insrer la disquette numro %d et taper Return ", numdisk);

        /* attendre la rponse de l'oprateur */
        if (getch () != CTRLC)
            putchar ('\n');
        else
        {
            putchar ('\n');
            exit (-1);
        }

        /* la tester */
        chemin [2] = 0;
        testdir ();
    }
    while (chemin [3] != 0x7f || chemin [4] != 0);

    puts ("[AC'est fini !");
}


/* test du rpertoire sur lequel on est positionn */
testdir ()
{
    /* table de description d'un fichier */
    struct ffblk fich;

    /* indicateur */
    int trouve;

    /* chemin relatif au fichier dans le rpertoire slectionn */
    char *nomfic;

    /* descripteur du fichier */
    static FILE *descfic;


    /* fabriquer le chemin d'accs aux lments de le rpertoire  tester */
    nomfic = chemin + strlen (chemin);
    memcpy (nomfic, "/*.*", 5);
    nomfic++;

    /* recherche du premier fichier de ce rpertoire
       on exclue un ventuel fichier label de la recherche */
    trouve = findfirst (chemin, &fich, 0xf7);

    /* saut ventuel des 2 premiers lments du rpertoire */
    if (strcmp (fich.ff_name, ".") == 0)
    {
        /* passer au fichier suivant */
        trouve = findnext (&fich);

        if (strcmp (fich.ff_name, "..") == 0)
            /* passer au fichier suivant */
            trouve = findnext (&fich);
    }

    /* tantque on trouve des nouveaux fichiers dans le rpertoire */
    while (trouve == 0)
    {
        /* construire le chemin d'accs aux fichier */
        memcpy (nomfic, fich.ff_name, sznomfic);

        /* diter le nom du fichier test */
        printf ("Test de %s\n", chemin);

        /* si le fichier  tester est un rpertoire */
        if (fich.ff_attrib & 0x10)
            /* tester son arborescence */
            testdir ();

        /* sinon tester le fichier */
        else
        {
            /* ouvrir le fichier */
            descfic = fopen (chemin, "rb");

            /* lire le fichier */
            do
            {
                szlect = fread (buffer, 1, szbuf, descfic);
            }
            while (szlect > 0);

            /* fermer le fichier */
            fclose (descfic);
        }

        /* rechercher le fichier suivant du rpertoire */
        trouve = findnext (&fich);
    }
}
