/* Programme vipart */

/*
   Il est recommand de compiler ce programme avec le modle mmoire
   Compact pour disposer du maximum de mmoire sous l'diteur vi
*/
   
#include <stdio.h>
#include <stdlib.h>
#include <process.h>
#include <dir.h>
#include <mem.h>
#include <io.h>
#include <fcntl.h>


#define szchemin  80


/* noms des fichiers utiliss */
static char nomcom  [9];
static char nomedit [9];
static char chemprt [szchemin];
static char chempos [szchemin];
static char chemsav [szchemin];
static char chemnsv [szchemin];

/* liste d'arguments de vi */
static int  nargvi = 0;
static char *argvi [10];

/* options traites localement */
static int optr = 0;
static int opts = 0;

/* programme principal */

main (narg, varg)
int narg;
char *varg [];
{
    int  i;
    long debut;       /* lignes de dbut et de fin */
    long fin;


    recupcom (*varg);

    argvi [nargvi++] = nomedit;

    varg++;
    narg--;
    i = 0;

    while (*varg [i] == '-')
    {
        switch (varg [i][1])
        {
            case 'a' :
            case 'c' :
            case 'i' :
            case 'n' :
            case 'p' : argvi [nargvi++] = varg [i];
                       break;

            case 'r' : optr = 1;
                       break;

            case 's' : opts = 1;
                       break;

            default  : fprintf (stderr, "Option %s incorrecte\n", varg [i]);
                       psyntaxe ();
        }

        i++;
    }

    if (narg == i)
    {
        fputs ("Il manque le nom de fichier\n", stderr);
        psyntaxe ();
    }
    else if (optr == 1)
    {
        if (access (chemsav, 0) == -1)
            erreur ("Aucun fichier n'est en attente de rcupration");
            
    }
    else
    {
        switch (narg - i)
        {

            case 1  : varg --;
                      execvp (nomedit, varg);
                      erreur ("Commande %s inaccessible", nomedit);

            case 2  :
            case 3  : debut = atoi (varg [i + 1]);

                      if (debut == 0)
                      {
                          fputs ("Mauvais argument aprs le nom de fichier\n", stderr);
                          psyntaxe ();
                      }

                      if (narg - i == 3)
                      {
                          fin = atoi (varg [i + 2]);

                          if (fin < debut)
                          {
                              fputs ("Erreur sur le dernier argument\n", stderr);

                              psyntaxe ();
                          }
                      }
                      else
                          fin = 0x7FFFFFFF;

                      genchemfich (varg [i]);

                      argvi [nargvi++] = "-s";
                      argvi [nargvi++] = chemprt;
                      argvi [nargvi] = "";

                      vipart (varg [i], debut, fin);
                      break;

            default : fputs ("Trop d'arguments\n", stderr);
                      psyntaxe ();
        }
    }
}




recupcom (chemin)
char *chemin;
{
    char *cardeb;
    int i;


    /* rcupration du nom de la commande lance */
    cardeb = chemin;

    while (*chemin != 0)
    {
        if (*chemin == '\\')
            cardeb = ++chemin;
        else
            chemin ++;
    }

    for (i = 0; *cardeb != '.'; i++)
    {
        nomcom [i] = *cardeb | 0x20;
        cardeb ++;
    }

    nomcom [i] = 0;

    /* fabrication du nom de l'diteur associ */
    strcpy (nomedit, nomcom);
    nomedit [strlen (nomcom) - 4] = 0;
}



psyntaxe ()
{
    fprintf (stderr,
            "Syntaxe : %s [-a] [-i] [-n] [-(p|c)] [-s] <nom de fichier>\n%s\n",
      nomcom, "                           <num 1re ligne> [<num dern. ligne>]");
    exit (-1);
}



erreur (message, arg1, arg2)
char *message, *arg1, *arg2;
{
    fprintf (stderr, message, arg1, arg2);
    putc ('\n', stderr);
    exit (-1);
}



genchemfich (chemfich)
char *chemfich;
{
    char *carcur, *carpoint;
    int i;


    strcpy (chemprt, chemfich);

    carcur = chemprt + strlen (chemprt) - 1;
    carpoint = carcur + 1;

    for (i = 0; i < 3 && *carcur != '.'; i++)
        carcur --;

    if (*carcur == '.')
        carpoint = carcur;

    strcpy (carpoint, ".sav");
    strcpy (chemsav, chemprt);

    strcpy (carpoint, ".nsv");
    strcpy (chemnsv, chemprt);

    strcpy (carpoint, ".pos");
    strcpy (chempos, chemprt);

    strcpy (carpoint, ".prt");

    if (strcmp (chemfich, chemprt) == 0 || strcmp (chemfich, chemsav) == 0
     || strcmp (chemfich, chemnsv) == 0 || strcmp (chemfich, chempos) == 0)
        erreur ("%s ne peut pas diter les fichier de suffixe %s",
                                nomcom, chemfich + strlen (chemfich) - 4);

    rename (chemnsv, chemsav);
}



vipart (chemfich, debut, fin)
char *chemfich;
long debut, fin;
{
    long ligne, posdeb, posfin;
    int  handle;
    FILE *ficin, *ficout, *ficprt;
    int  car;
    struct ffblk descfic;
    long avant, apres;


    if (access (chempos, 0) == 0 && access (chemsav, 0) == 0)
    {
        erreur ("Cas particulier chiant");
    }

    handle = open (chemfich, O_RDWR | O_BINARY);
    ficin = fdopen (handle, "r+b");

    if (ficin == 0)
        erreur ("Fichier %s inaccessible ou inexistant", chemfich);

    for (ligne = 1; ligne < debut; ligne ++)
    {
        do
        {
            car = getc (ficin);

            if (car == EOF)
                erreur ("Le fichier contient moins de %ld lignes", debut);
        }
        while (car != '\n');
    }

    ficprt = fopen (chemprt, "wb");

    if (ficprt == 0)
        erreur ("Impossible de crer le fichier de travail");

    posdeb = ftell (ficin);

    while (ligne++ <= fin && car != EOF)
    {
        do
        {
            car = getc (ficin);

            if (car != EOF)
                putc (car, ficprt);
        }
        while (car != '\n' && car != EOF);
    }

    fclose (ficprt);
    posfin = ftell (ficin);

    ficout = fopen (chempos, "wb");

    if (ficout != 0)
    {
        fwrite (&posdeb, 4, 1, ficout);
        fwrite (&posfin, 4, 1, ficout);

        fclose (ficout);
    }

    if (findfirst (chemprt, &descfic, 0xFF) == 0)
        memcpy (&avant, &descfic.ff_ftime, 4);
    else
        erreur ("Problme d'accs au fichier %s", chemprt);

    spawnvp (P_WAIT, nomedit, argvi);

    unlink (chempos);

    if (findfirst (chemprt, &descfic, 0xFF) == 0)
        memcpy (&apres, &descfic.ff_ftime, 4);
    else
        erreur ("Problme d'accs au fichier %s", chemprt);

    if (avant != apres)
    {
        printf ("Sauvegarde de la version prcdente de %s\n", chemfich);
        spawnlp (P_WAIT, "savef", "savef", chemfich, "");

        printf ("Mise  jour de %s\n", chemfich);

        ficprt = fopen (chemprt, "ab");

        if (ficprt == 0)
            erreur (" !");

        car = getc (ficin);

        while (car != EOF)
        {
            putc (car, ficprt);
            car = getc (ficin);
        }

        fclose (ficprt);

        if (fseek (ficin, posdeb, 0) != 0)
            erreur ("Fichier %s certainement modifi", chemfich);

        chsize (handle, posdeb);

        ficprt = fopen (chemprt, "rb");

        car = getc (ficprt);

        while (car != EOF)
        {
            putc (car, ficin);
            car = getc (ficprt);
        }

        fclose (ficin);
        fclose (ficprt);
    }

    unlink (chemprt);
}
